/* panel.c generated by valac 0.56.17, the Vala compiler
 * generated from panel.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2014 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2015-2024 Takao Fujwiara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <ibus.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <locale.h>
#include <float.h>
#include <math.h>
#include <libnotify/notify.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <signal.h>
#include <sys/types.h>
#include <config.h>

#define PANEL_PRELOAD_ENGINES_DELAY_TIME ((guint) 30000)
#define KEYBINDING_MANAGER_MODIFIER_FILTER ((guint) (GDK_MODIFIER_MASK & (~(((((((((GDK_LOCK_MASK | GDK_MOD2_MASK) | GDK_BUTTON1_MASK) | GDK_BUTTON2_MASK) | GDK_BUTTON3_MASK) | GDK_BUTTON4_MASK) | GDK_BUTTON5_MASK) | GDK_SUPER_MASK) | GDK_HYPER_MASK) | GDK_META_MASK))))
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PANEL (panel_get_type ())
#define PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL, Panel))
#define PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL, PanelClass))
#define IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL))
#define IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL))
#define PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL, PanelClass))

typedef struct _Panel Panel;
typedef struct _PanelClass PanelClass;
typedef struct _PanelPrivate PanelPrivate;
typedef enum  {
	PANEL_ICON_TYPE_STATUS_ICON,
	PANEL_ICON_TYPE_INDICATOR
} PanelIconType;

#define PANEL_TYPE_ICON_TYPE (panel_icon_type_get_type ())

#define TYPE_INDICATOR (indicator_get_type ())
#define INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR, Indicator))
#define INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR, IndicatorClass))
#define IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR))
#define IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR))
#define INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR, IndicatorClass))

typedef struct _Indicator Indicator;
typedef struct _IndicatorClass IndicatorClass;
typedef enum  {
	INDICATOR_STATUS_PASSIVE,
	INDICATOR_STATUS_ACTIVE,
	INDICATOR_STATUS_ATTENTION
} IndicatorStatus;

#define INDICATOR_TYPE_STATUS (indicator_status_get_type ())

#define TYPE_CANDIDATE_PANEL (candidate_panel_get_type ())
#define CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANDIDATE_PANEL, CandidatePanel))
#define CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANDIDATE_PANEL, CandidatePanelClass))
#define IS_CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANDIDATE_PANEL))
#define IS_CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANDIDATE_PANEL))
#define CANDIDATE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANDIDATE_PANEL, CandidatePanelClass))

typedef struct _CandidatePanel CandidatePanel;
typedef struct _CandidatePanelClass CandidatePanelClass;

#define TYPE_SWITCHER (switcher_get_type ())
#define SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWITCHER, Switcher))
#define SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWITCHER, SwitcherClass))
#define IS_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWITCHER))
#define IS_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWITCHER))
#define SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWITCHER, SwitcherClass))

typedef struct _Switcher Switcher;
typedef struct _SwitcherClass SwitcherClass;

#define TYPE_PROPERTY_MANAGER (property_manager_get_type ())
#define PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_MANAGER, PropertyManager))
#define PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_MANAGER, PropertyManagerClass))
#define IS_PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_MANAGER))
#define IS_PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_MANAGER))
#define PROPERTY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_MANAGER, PropertyManagerClass))

typedef struct _PropertyManager PropertyManager;
typedef struct _PropertyManagerClass PropertyManagerClass;

#define TYPE_PROPERTY_PANEL (property_panel_get_type ())
#define PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_PANEL, PropertyPanel))
#define PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_PANEL, PropertyPanelClass))
#define IS_PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_PANEL))
#define IS_PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_PANEL))
#define PROPERTY_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_PANEL, PropertyPanelClass))

typedef struct _PropertyPanel PropertyPanel;
typedef struct _PropertyPanelClass PropertyPanelClass;

#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;

#define BINDING_COMMON_TYPE_KEYBINDING (binding_common_keybinding_get_type ())
#define BINDING_COMMON_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybinding))
#define BINDING_COMMON_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))
#define BINDING_COMMON_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))

typedef struct _BindingCommonKeybinding BindingCommonKeybinding;
typedef struct _BindingCommonKeybindingClass BindingCommonKeybindingClass;
enum  {
	PANEL_0_PROPERTY,
	PANEL_NUM_PROPERTIES
};
static GParamSpec* panel_properties[PANEL_NUM_PROPERTIES];
typedef enum  {
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_EMOJI_TYPING
} BindingCommonKeyEventFuncType;

#define BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE (binding_common_key_event_func_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _property_manager_unref0(var) ((var == NULL) ? NULL : (var = (property_manager_unref (var), NULL)))
#define _xkb_layout_unref0(var) ((var == NULL) ? NULL : (var = (xkb_layout_unref (var), NULL)))
typedef enum  {
	INDICATOR_CATEGORY_APPLICATION_STATUS,
	INDICATOR_CATEGORY_COMMUNICATIONS,
	INDICATOR_CATEGORY_SYSTEM_SERVICES,
	INDICATOR_CATEGORY_HARDWARE,
	INDICATOR_CATEGORY_OTHER
} IndicatorCategory;

#define INDICATOR_TYPE_CATEGORY (indicator_category_get_type ())
typedef struct _Block7Data Block7Data;

#define TYPE_KEYBINDING_MANAGER (keybinding_manager_get_type ())
#define KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManager))
#define KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))
#define IS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYBINDING_MANAGER))
#define IS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYBINDING_MANAGER))
#define KEYBINDING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))

typedef struct _KeybindingManager KeybindingManager;
typedef struct _KeybindingManagerClass KeybindingManagerClass;
typedef void (*KeybindingManagerKeybindingHandlerFunc) (GdkEvent* event, gpointer user_data);
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
enum  {
	PANEL_REALIZE_SURFACE_SIGNAL,
	PANEL_UPDATE_SHORTCUT_KEYS_SIGNAL,
	PANEL_NUM_SIGNALS
};
static guint panel_signals[PANEL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Panel {
	IBusPanelService parent_instance;
	PanelPrivate * priv;
};

struct _PanelClass {
	IBusPanelServiceClass parent_class;
};

struct _PanelPrivate {
	IBusBus* m_bus;
	GSettings* m_settings_general;
	GSettings* m_settings_hotkey;
	GSettings* m_settings_panel;
	PanelIconType m_icon_type;
	Indicator* m_indicator;
	IndicatorStatus m_indicator_show_status;
	GtkStatusIcon* m_status_icon;
	GtkMenu* m_ime_menu;
	GtkMenu* m_sys_menu;
	IBusEngineDesc** m_engines;
	gint m_engines_length1;
	gint _m_engines_size_;
	GHashTable* m_engine_contexts;
	gchar* m_current_context_path;
	gchar* m_real_current_context_path;
	gboolean m_use_global_engine;
	gboolean m_use_engine_lang;
	CandidatePanel* m_candidate_panel;
	Switcher* m_switcher;
	guint m_switcher_focus_set_engine_id;
	gint m_switcher_selected_index;
	GThread* m_switcher_waiting_release;
	PropertyManager* m_property_manager;
	PropertyPanel* m_property_panel;
	GPid m_setup_pid;
	GtkAboutDialog* m_about_dialog;
	GtkCssProvider* m_css_provider;
	gint m_switcher_delay_time;
	gboolean m_use_system_keyboard_layout;
	GHashTable* m_xkb_icon_pixbufs;
	GHashTable* m_xkb_icon_image;
	GdkRGBA m_xkb_icon_rgba;
	XKBLayout* m_xkblayout;
	gboolean inited_engines_order;
	guint m_preload_engines_id;
	gchar* m_icon_prop_key;
	gint m_property_icon_delay_time;
	guint m_property_icon_delay_time_id;
	guint m_menu_update_delay_time;
	guint m_menu_update_delay_time_id;
	gboolean m_is_wayland;
	gboolean m_is_wayland_im;
	gboolean m_is_kde;
	gboolean m_is_context_menu;
	gulong m_popup_menu_id;
	gulong m_activate_id;
	gulong m_registered_status_notifier_item_id;
	FILE* m_log;
	gboolean m_verbose;
	GList* m_keybindings;
};

struct _Block7Data {
	int _ref_count_;
	Panel* self;
	GdkRectangle area;
	GdkWindow* window;
	GtkMenuPositionFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

struct _Block8Data {
	int _ref_count_;
	Panel* self;
	gchar** names;
	gint names_length1;
	gint _names_size_;
};

struct _Block9Data {
	int _ref_count_;
	Panel* self;
	GtkMessageDialog* dialog;
};

struct _Block10Data {
	int _ref_count_;
	Panel* self;
	IBusEngineDesc* e;
};

struct _Block11Data {
	int _ref_count_;
	Panel* self;
	gchar* symbol;
};

static gint Panel_private_offset;
static gpointer panel_parent_class = NULL;

VALA_EXTERN GType panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Panel, g_object_unref)
static GType panel_icon_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indicator, g_object_unref)
VALA_EXTERN GType indicator_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType candidate_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CandidatePanel, g_object_unref)
VALA_EXTERN GType switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Switcher, g_object_unref)
VALA_EXTERN gpointer property_manager_ref (gpointer instance);
VALA_EXTERN void property_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_property_manager (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_property_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_property_manager (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_property_manager (const GValue* value);
VALA_EXTERN GType property_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyManager, property_manager_unref)
VALA_EXTERN GType property_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyPanel, g_object_unref)
VALA_EXTERN gpointer xkb_layout_ref (gpointer instance);
VALA_EXTERN void xkb_layout_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_xkb_layout (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_xkb_layout (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_xkb_layout (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_xkb_layout (const GValue* value);
VALA_EXTERN GType xkb_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (XKBLayout, xkb_layout_unref)
VALA_EXTERN GType binding_common_keybinding_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BindingCommonKeybinding, g_object_unref)
VALA_EXTERN void indicator_unregister_connection (Indicator* self);
VALA_EXTERN GType binding_common_key_event_func_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void binding_common_unbind_switch_shortcut (BindingCommonKeyEventFuncType ftype,
                                            GList* keybindings);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _g_free0_ (gpointer var);
static void _cairo_surface_destroy0_ (gpointer var);
VALA_EXTERN XKBLayout* xkb_layout_new (void);
VALA_EXTERN XKBLayout* xkb_layout_construct (GType object_type);
static gboolean panel_is_kde (void);
VALA_EXTERN Panel* panel_new (IBusBus* bus,
                  gboolean is_wayland_im);
VALA_EXTERN Panel* panel_construct (GType object_type,
                        IBusBus* bus,
                        gboolean is_wayland_im);
VALA_EXTERN gboolean binding_common_default_is_xdisplay (void);
static void panel_init_settings (Panel* self);
VALA_EXTERN PropertyManager* property_manager_new (void);
VALA_EXTERN PropertyManager* property_manager_construct (GType object_type);
static void __lambda84_ (Panel* self,
                  PropertyManager* w,
                  const gchar* k,
                  gint s);
static void ___lambda84__property_manager_property_activate (PropertyManager* _sender,
                                                      const gchar* key,
                                                      gint state,
                                                      gpointer self);
static void panel_init_indicator (Panel* self);
static void panel_init_status_icon (Panel* self);
VALA_EXTERN CandidatePanel* candidate_panel_new (void);
VALA_EXTERN CandidatePanel* candidate_panel_construct (GType object_type);
static void __lambda96_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda96__candidate_panel_page_up (CandidatePanel* _sender,
                                           gpointer self);
static void __lambda97_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda97__candidate_panel_page_down (CandidatePanel* _sender,
                                             gpointer self);
static void __lambda98_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda98__candidate_panel_cursor_up (CandidatePanel* _sender,
                                             gpointer self);
static void __lambda99_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda99__candidate_panel_cursor_down (CandidatePanel* _sender,
                                               gpointer self);
static void __lambda100_ (Panel* self,
                   CandidatePanel* w,
                   guint i,
                   guint b,
                   guint s);
static void ___lambda100__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                      guint index,
                                                      guint button,
                                                      guint state,
                                                      gpointer self);
static void __lambda101_ (Panel* self,
                   CandidatePanel* w,
                   void* s);
static void ___lambda101__candidate_panel_realize_surface (CandidatePanel* _sender,
                                                    void* surface,
                                                    gpointer self);
VALA_EXTERN Switcher* switcher_new (void);
VALA_EXTERN Switcher* switcher_construct (GType object_type);
static void __lambda102_ (Panel* self,
                   Switcher* w,
                   void* s);
static void ___lambda102__switcher_realize_surface (Switcher* _sender,
                                             void* surface,
                                             gpointer self);
static void panel_bind_switch_shortcut (Panel* self);
VALA_EXTERN void switcher_set_popup_delay_time (Switcher* self,
                                    guint popup_delay_time);
VALA_EXTERN PropertyPanel* property_panel_new (void);
VALA_EXTERN PropertyPanel* property_panel_construct (GType object_type);
static void __lambda103_ (Panel* self,
                   PropertyPanel* w,
                   const gchar* k,
                   gint s);
static void ___lambda103__property_panel_property_activate (PropertyPanel* _sender,
                                                     const gchar* key,
                                                     gint state,
                                                     gpointer self);
static void panel_set_version (Panel* self);
static void panel_check_wayland (Panel* self);
static void __lambda60_ (Panel* self,
                  const gchar* key);
static void panel_update_engines (Panel* self,
                           gchar** unowned_engine_names,
                           gint unowned_engine_names_length1,
                           gchar** order_names,
                           gint order_names_length1);
static void ___lambda60__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda63_ (Panel* self,
                  const gchar* key);
static void panel_set_switcher_delay_time (Panel* self);
static void ___lambda63__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda64_ (Panel* self,
                  const gchar* key);
static void panel_set_use_system_keyboard_layout (Panel* self);
static void ___lambda64__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda65_ (Panel* self,
                  const gchar* key);
static void panel_set_embed_preedit_text (Panel* self);
static void ___lambda65__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda66_ (Panel* self,
                  const gchar* key);
static void panel_set_use_global_engine (Panel* self);
static void ___lambda66__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda67_ (Panel* self,
                  const gchar* key);
static void panel_set_use_xmodmap (Panel* self);
static void ___lambda67__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda68_ (Panel* self,
                  const gchar* key);
static void ___lambda68__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda70_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_font (GSettings* settings_panel,
                                     GSettings* settings_emoji,
                                     GtkCssProvider** css_provider);
static void ___lambda70__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda71_ (Panel* self,
                  const gchar* key);
static void ___lambda71__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda72_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_theme (GSettings* settings_panel);
static void ___lambda72__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda73_ (Panel* self,
                  const gchar* key);
static void ___lambda73__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda74_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_icon (GSettings* settings_panel);
static void ___lambda74__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda75_ (Panel* self,
                  const gchar* key);
static void ___lambda75__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda76_ (Panel* self,
                  const gchar* key);
static void panel_set_language_from_engine (Panel* self,
                                     IBusEngineDesc* engine);
static void ___lambda76__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda77_ (Panel* self,
                  const gchar* key);
static void panel_set_show_icon_on_systray (Panel* self,
                                     gboolean update_now);
static void ___lambda77__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda78_ (Panel* self,
                  const gchar* key);
static void panel_set_lookup_table_orientation (Panel* self);
static void ___lambda78__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda79_ (Panel* self,
                  const gchar* key);
static void panel_set_show_property_panel (Panel* self);
static void ___lambda79__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda80_ (Panel* self,
                  const gchar* key);
static void panel_set_timeout_property_panel (Panel* self);
static void ___lambda80__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda81_ (Panel* self,
                  const gchar* key);
static void panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self);
static void ___lambda81__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda82_ (Panel* self,
                  const gchar* key);
static void panel_set_xkb_icon_rgba (Panel* self);
static void ___lambda82__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda83_ (Panel* self,
                  const gchar* key);
static void panel_set_property_icon_delay_time (Panel* self);
static void ___lambda83__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void panel_popup_menu_at_area_window (Panel* self,
                                      GtkMenu* menu,
                                      GdkRectangle* area,
                                      GdkWindow* window,
                                      GtkMenuPositionFunc func,
                                      gpointer func_target);
static gboolean panel_is_gnome (void);
static void panel_popup_menu_at_pointer_window (Panel* self,
                                         GtkMenu* menu,
                                         gint x,
                                         gint y,
                                         GdkWindow* window,
                                         GtkMenuPositionFunc func,
                                         gpointer func_target);
VALA_EXTERN GType indicator_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Indicator* indicator_new (const gchar* id,
                          IndicatorCategory category);
VALA_EXTERN Indicator* indicator_construct (GType object_type,
                                const gchar* id,
                                IndicatorCategory category);
VALA_EXTERN void indicator_set_title (Indicator* self,
                          const gchar* value);
static void __lambda85_ (Panel* self);
VALA_EXTERN void indicator_set_status (Indicator* self,
                           IndicatorStatus status);
static void ___lambda85__indicator_registered_status_notifier_item (Indicator* _sender,
                                                             gpointer self);
static void __lambda86_ (Panel* self);
VALA_EXTERN void indicator_set_menu (Indicator* self,
                         GtkMenu* menu);
static GtkMenu* panel_create_context_menu (Panel* self,
                                    gboolean use_x11);
static GtkMenu* panel_create_activate_menu (Panel* self,
                                     gboolean use_x11);
static void ___lambda86__indicator_secondary_activate (Indicator* _sender,
                                                gpointer self);
static void panel_init_status_icon_menu (Panel* self);
static void _panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
VALA_EXTERN GdkX11Display* binding_common_get_xdisplay (gboolean check_only);
static void __lambda94_ (Block7Data* _data7_,
                  guint b,
                  guint t);
static void ___lambda94__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                              guint button,
                                              guint activate_time,
                                              gpointer self);
static void __lambda95_ (Block7Data* _data7_);
static void ___lambda95__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                            gpointer self);
VALA_EXTERN GType keybinding_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeybindingManager, g_object_unref)
VALA_EXTERN KeybindingManager* keybinding_manager_get_instance (gboolean is_wayland_im);
VALA_EXTERN void binding_common_keybinding_manager_bind (KeybindingManager* keybinding_manager,
                                             GList** keybindings,
                                             const gchar* accelerator,
                                             BindingCommonKeyEventFuncType ftype,
                                             KeybindingManagerKeybindingHandlerFunc handler_normal,
                                             gpointer handler_normal_target,
                                             KeybindingManagerKeybindingHandlerFunc handler_reverse,
                                             gpointer handler_reverse_target);
static void panel_handle_engine_switch_normal (Panel* self,
                                        GdkEvent* event);
static void _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                    gpointer self);
static void panel_handle_engine_switch_reverse (Panel* self,
                                         GdkEvent* event);
static void _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                     gpointer self);
VALA_EXTERN gboolean binding_common_keybinding_get_reverse (BindingCommonKeybinding* self);
VALA_EXTERN guint binding_common_keybinding_get_keysym (BindingCommonKeybinding* self);
VALA_EXTERN GdkModifierType binding_common_keybinding_get_modifiers (BindingCommonKeybinding* self);
static void _vala_array_add18 (IBusProcessKeyEventData* * array,
                        gint* length,
                        gint* size,
                        const IBusProcessKeyEventData* value);
static void _vala_array_add19 (IBusProcessKeyEventData* * array,
                        gint* length,
                        gint* size,
                        const IBusProcessKeyEventData* value);
static GList* panel_get_engines_from_xkb (Panel* self,
                                   GList* engines);
VALA_EXTERN void xkb_layout_get_layout (XKBLayout* self,
                            gchar** layout,
                            gchar** variant,
                            gchar** option);
static GList* panel_get_engines_from_locale (Panel* self,
                                      GList* engines);
static gint __lambda104_ (IBusEngineDesc* a,
                   IBusEngineDesc* b);
static gint ___lambda104__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void panel_init_engines_order (Panel* self);
VALA_EXTERN void xkb_layout_set_latin_layouts (XKBLayout* self,
                                   gchar** xkb_latin_layouts,
                                   gint xkb_latin_layouts_length1);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_set_use_xmodmap (XKBLayout* self,
                                 gboolean use_xmodmap);
VALA_EXTERN void candidate_panel_set_vertical (CandidatePanel* self,
                                   gboolean vertical);
VALA_EXTERN void property_panel_set_show (PropertyPanel* self,
                              gint _show);
VALA_EXTERN void property_panel_set_auto_hide_timeout (PropertyPanel* self,
                                           guint timeout);
VALA_EXTERN void property_panel_set_follow_input_cursor_when_always_shown (PropertyPanel* self,
                                                               gboolean is_follow);
static gint panel_compare_versions (Panel* self,
                             const gchar* version1,
                             const gchar* version2);
static void panel_update_version_1_5_8 (Panel* self);
static void panel_save_log (Panel* self,
                     const gchar* format);
VALA_EXTERN void panel_load_settings (Panel* self);
VALA_EXTERN void panel_disconnect_signals (Panel* self);
VALA_EXTERN void panel_set_global_shortcut_key_state (Panel* self,
                                          IBusBusGlobalBindingType type,
                                          gboolean is_pressed,
                                          gboolean is_backward);
static void panel_handle_engine_switch_focused (Panel* self,
                                         gboolean pressed,
                                         gboolean reverse);
VALA_EXTERN void panel_set_log (Panel* self,
                    FILE* log,
                    gboolean verbose);
static void panel_engine_contexts_insert (Panel* self,
                                   IBusEngineDesc* engine);
VALA_EXTERN void candidate_panel_set_language (CandidatePanel* self,
                                   PangoAttribute* language_attribute);
static void panel_set_engine (Panel* self,
                       IBusEngineDesc* engine);
VALA_EXTERN void xkb_layout_set_layout (XKBLayout* self,
                            IBusEngineDesc* engine);
static void panel_switch_engine (Panel* self,
                          gint i,
                          gboolean force);
static void panel_handle_engine_switch (Panel* self,
                                 GdkEvent* event,
                                 gboolean reverse);
VALA_EXTERN GdkModifierType keybinding_manager_get_primary_modifier (guint binding_mask);
VALA_EXTERN gboolean keybinding_manager_primary_modifier_still_pressed (GdkEvent* event,
                                                            guint primary_modifier);
VALA_EXTERN gint switcher_run (Switcher* self,
                   guint keyval,
                   guint state,
                   GdkEvent* event,
                   IBusEngineDesc** engines,
                   gint engines_length1,
                   gint index,
                   const gchar* input_context_path);
static void panel_switcher_focus_set_engine (Panel* self);
VALA_EXTERN gint switcher_run_popup (Switcher* self,
                         IBusEngineDesc** engines,
                         gint engines_length1,
                         gint index);
static gboolean ___lambda105_ (Panel* self);
static void panel_handle_engine_switch_release (Panel* self,
                                         gboolean is_timeout);
static gpointer ____lambda105__gthread_func (gpointer self);
static void panel_run_preload_engines (Panel* self,
                                IBusEngineDesc** engines,
                                gint engines_length1,
                                gint index);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean __lambda62_ (Block8Data* _data8_);
static gboolean ___lambda62__gsource_func (gpointer self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add24 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void ___lambda61_ (Block9Data* _data9_,
                   gint id);
static void ____lambda61__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static IBusEngineDesc** _vala_array_dup3 (IBusEngineDesc** self,
                                   gssize length);
static IBusEngineDesc** _vala_array_dup4 (IBusEngineDesc** self,
                                   gssize length);
static void panel_context_render_string (Panel* self,
                                  cairo_t* cr,
                                  const gchar* symbol,
                                  gint image_width,
                                  gint image_height);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static cairo_surface_t* panel_create_cairo_image_surface_with_string (Panel* self,
                                                               const gchar* symbol,
                                                               gboolean cache);
static GdkPixbuf* panel_create_icon_pixbuf_with_string (Panel* self,
                                                 const gchar* symbol);
static void panel_show_setup_dialog (Panel* self);
static void __lambda88_ (Panel* self,
                  GPid pid,
                  gint state);
static void ___lambda88__gchild_watch_func (GPid pid,
                                     gint wait_status,
                                     gpointer self);
static void panel_show_about_dialog (Panel* self);
static void panel_run_ibus_command (Panel* self,
                             const gchar* args);
static void _vala_array_add25 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add26 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add27 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void panel_append_preferences_menu (Panel* self,
                                    GtkMenu* menu);
static void __lambda87_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void panel_append_emoji_menu (Panel* self,
                              GtkMenu* menu);
static void __lambda89_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda90_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda91_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda92_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
VALA_EXTERN gint property_manager_create_menu_items (PropertyManager* self,
                                         GtkMenu* menu);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void ____lambda93_ (Block10Data* _data10_,
                    GtkMenuItem* item);
static void _____lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void panel_set_properties (Panel* self,
                           IBusPropList* props);
static void panel_set_property (Panel* self,
                         IBusProperty* prop,
                         gboolean all_update);
static void panel_animate_icon (Panel* self,
                         const gchar* symbol,
                         gboolean all_update);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean __lambda106_ (Block11Data* _data11_);
VALA_EXTERN void indicator_set_cairo_image_surface_full (Indicator* self,
                                             cairo_surface_t* image,
                                             const gchar* icon_desc);
static gboolean ___lambda106__gsource_func (gpointer self);
static void panel_real_set_cursor_location (IBusPanelService* base,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height);
VALA_EXTERN void candidate_panel_set_cursor_location (CandidatePanel* self,
                                          gint x,
                                          gint y,
                                          gint width,
                                          gint height);
VALA_EXTERN void property_panel_set_cursor_location (PropertyPanel* self,
                                         gint x,
                                         gint y,
                                         gint width,
                                         gint height);
static gboolean panel_switcher_focus_set_engine_real (Panel* self);
VALA_EXTERN IBusEngineDesc* switcher_get_selected_engine (Switcher* self);
VALA_EXTERN gchar* switcher_get_input_context_path (Switcher* self);
VALA_EXTERN void switcher_reset (Switcher* self);
VALA_EXTERN gboolean switcher_is_running (Switcher* self);
static gboolean ___lambda69_ (Panel* self);
static gboolean ____lambda69__gsource_func (gpointer self);
static void panel_real_focus_in (IBusPanelService* base,
                          const gchar* input_context_path);
VALA_EXTERN void property_panel_focus_in (PropertyPanel* self);
static void panel_real_focus_out (IBusPanelService* base,
                           const gchar* input_context_path);
static void panel_real_destroy_context (IBusPanelService* base,
                                 const gchar* input_context_path);
static void panel_real_register_properties (IBusPanelService* base,
                                     IBusPropList* props);
VALA_EXTERN void property_manager_set_properties (PropertyManager* self,
                                      IBusPropList* props);
VALA_EXTERN void property_panel_set_properties (PropertyPanel* self,
                                    IBusPropList* props);
static gboolean __lambda107_ (Panel* self);
static gboolean ___lambda107__gsource_func (gpointer self);
static void panel_real_update_property (IBusPanelService* base,
                                 IBusProperty* prop);
VALA_EXTERN void property_manager_update_property (PropertyManager* self,
                                       IBusProperty* prop);
VALA_EXTERN void property_panel_update_property (PropertyPanel* self,
                                     IBusProperty* prop);
static void panel_real_update_preedit_text (IBusPanelService* base,
                                     IBusText* text,
                                     guint cursor_pos,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_preedit_text (CandidatePanel* self,
                                       IBusText* text,
                                       guint cursor);
VALA_EXTERN void property_panel_set_preedit_text (PropertyPanel* self,
                                      IBusText* text,
                                      guint cursor);
static void panel_real_hide_preedit_text (IBusPanelService* base);
static void panel_real_update_auxiliary_text (IBusPanelService* base,
                                       IBusText* text,
                                       gboolean visible);
VALA_EXTERN void candidate_panel_set_auxiliary_text (CandidatePanel* self,
                                         IBusText* text);
VALA_EXTERN void property_panel_set_auxiliary_text (PropertyPanel* self,
                                        IBusText* text);
static void panel_real_hide_auxiliary_text (IBusPanelService* base);
static void panel_real_update_lookup_table (IBusPanelService* base,
                                     IBusLookupTable* table,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_lookup_table (CandidatePanel* self,
                                       IBusLookupTable* table);
VALA_EXTERN void property_panel_set_lookup_table (PropertyPanel* self,
                                      IBusLookupTable* table);
static void panel_real_hide_lookup_table (IBusPanelService* base);
static void panel_real_set_content_type (IBusPanelService* base,
                                  guint purpose,
                                  guint hints);
VALA_EXTERN void candidate_panel_set_content_type (CandidatePanel* self,
                                       guint purpose,
                                       guint hints);
static void panel_real_state_changed (IBusPanelService* base);
VALA_EXTERN void indicator_set_icon_full (Indicator* self,
                              const gchar* icon_name,
                              const gchar* icon_desc);
VALA_EXTERN gchar* switcher_get_xkb_language (Switcher* self,
                                  IBusEngineDesc* engine);
static void _vala_array_add28 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void g_cclosure_user_marshal_VOID__POINTER_INT_ENUM (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static void panel_finalize (GObject * obj);
static GType panel_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
panel_get_instance_private (Panel* self)
{
	return G_STRUCT_MEMBER_P (self, Panel_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 183 "panel.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 988 "panel.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 183 "panel.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 996 "panel.c"
}

static GType
panel_icon_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PANEL_ICON_TYPE_STATUS_ICON, "PANEL_ICON_TYPE_STATUS_ICON", "status-icon"}, {PANEL_ICON_TYPE_INDICATOR, "PANEL_ICON_TYPE_INDICATOR", "indicator"}, {0, NULL, NULL}};
	GType panel_icon_type_type_id;
	panel_icon_type_type_id = g_enum_register_static ("PanelIconType", values);
	return panel_icon_type_type_id;
}

static GType
panel_icon_type_get_type (void)
{
	static volatile gsize panel_icon_type_type_id__once = 0;
	if (g_once_init_enter (&panel_icon_type_type_id__once)) {
		GType panel_icon_type_type_id;
		panel_icon_type_type_id = panel_icon_type_get_type_once ();
		g_once_init_leave (&panel_icon_type_type_id__once, panel_icon_type_type_id);
	}
	return panel_icon_type_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 44 "panel.vala"
	var = (g_free (var), NULL);
#line 1025 "panel.c"
}

static void
_cairo_surface_destroy0_ (gpointer var)
{
#line 66 "panel.vala"
	(var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL));
#line 1033 "panel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "panel.vala"
	return self ? g_object_ref (self) : NULL;
#line 1041 "panel.c"
}

static void
__lambda84_ (Panel* self,
             PropertyManager* w,
             const gchar* k,
             gint s)
{
#line 125 "panel.vala"
	g_return_if_fail (w != NULL);
#line 125 "panel.vala"
	g_return_if_fail (k != NULL);
#line 126 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1056 "panel.c"
}

static void
___lambda84__property_manager_property_activate (PropertyManager* _sender,
                                                 const gchar* key,
                                                 gint state,
                                                 gpointer self)
{
#line 125 "panel.vala"
	__lambda84_ ((Panel*) self, _sender, key, state);
#line 1067 "panel.c"
}

static void
__lambda96_ (Panel* self,
             CandidatePanel* w)
{
#line 141 "panel.vala"
	g_return_if_fail (w != NULL);
#line 141 "panel.vala"
	ibus_panel_service_page_up ((IBusPanelService*) self);
#line 1078 "panel.c"
}

static void
___lambda96__candidate_panel_page_up (CandidatePanel* _sender,
                                      gpointer self)
{
#line 141 "panel.vala"
	__lambda96_ ((Panel*) self, _sender);
#line 1087 "panel.c"
}

static void
__lambda97_ (Panel* self,
             CandidatePanel* w)
{
#line 142 "panel.vala"
	g_return_if_fail (w != NULL);
#line 142 "panel.vala"
	ibus_panel_service_page_down ((IBusPanelService*) self);
#line 1098 "panel.c"
}

static void
___lambda97__candidate_panel_page_down (CandidatePanel* _sender,
                                        gpointer self)
{
#line 142 "panel.vala"
	__lambda97_ ((Panel*) self, _sender);
#line 1107 "panel.c"
}

static void
__lambda98_ (Panel* self,
             CandidatePanel* w)
{
#line 143 "panel.vala"
	g_return_if_fail (w != NULL);
#line 143 "panel.vala"
	ibus_panel_service_cursor_up ((IBusPanelService*) self);
#line 1118 "panel.c"
}

static void
___lambda98__candidate_panel_cursor_up (CandidatePanel* _sender,
                                        gpointer self)
{
#line 143 "panel.vala"
	__lambda98_ ((Panel*) self, _sender);
#line 1127 "panel.c"
}

static void
__lambda99_ (Panel* self,
             CandidatePanel* w)
{
#line 144 "panel.vala"
	g_return_if_fail (w != NULL);
#line 144 "panel.vala"
	ibus_panel_service_cursor_down ((IBusPanelService*) self);
#line 1138 "panel.c"
}

static void
___lambda99__candidate_panel_cursor_down (CandidatePanel* _sender,
                                          gpointer self)
{
#line 144 "panel.vala"
	__lambda99_ ((Panel*) self, _sender);
#line 1147 "panel.c"
}

static void
__lambda100_ (Panel* self,
              CandidatePanel* w,
              guint i,
              guint b,
              guint s)
{
#line 146 "panel.vala"
	g_return_if_fail (w != NULL);
#line 146 "panel.vala"
	ibus_panel_service_candidate_clicked ((IBusPanelService*) self, i, b, s);
#line 1161 "panel.c"
}

static void
___lambda100__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                 guint index,
                                                 guint button,
                                                 guint state,
                                                 gpointer self)
{
#line 145 "panel.vala"
	__lambda100_ ((Panel*) self, _sender, index, button, state);
#line 1173 "panel.c"
}

static void
__lambda101_ (Panel* self,
              CandidatePanel* w,
              void* s)
{
#line 149 "panel.vala"
	g_return_if_fail (w != NULL);
#line 149 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, s);
#line 1185 "panel.c"
}

static void
___lambda101__candidate_panel_realize_surface (CandidatePanel* _sender,
                                               void* surface,
                                               gpointer self)
{
#line 148 "panel.vala"
	__lambda101_ ((Panel*) self, _sender, surface);
#line 1195 "panel.c"
}

static void
__lambda102_ (Panel* self,
              Switcher* w,
              void* s)
{
#line 155 "panel.vala"
	g_return_if_fail (w != NULL);
#line 155 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, s);
#line 1207 "panel.c"
}

static void
___lambda102__switcher_realize_surface (Switcher* _sender,
                                        void* surface,
                                        gpointer self)
{
#line 154 "panel.vala"
	__lambda102_ ((Panel*) self, _sender, surface);
#line 1217 "panel.c"
}

static void
__lambda103_ (Panel* self,
              PropertyPanel* w,
              const gchar* k,
              gint s)
{
#line 165 "panel.vala"
	g_return_if_fail (w != NULL);
#line 165 "panel.vala"
	g_return_if_fail (k != NULL);
#line 166 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1232 "panel.c"
}

static void
___lambda103__property_panel_property_activate (PropertyPanel* _sender,
                                                const gchar* key,
                                                gint state,
                                                gpointer self)
{
#line 165 "panel.vala"
	__lambda103_ ((Panel*) self, _sender, key, state);
#line 1243 "panel.c"
}

Panel*
panel_construct (GType object_type,
                 IBusBus* bus,
                 gboolean is_wayland_im)
{
	Panel * self = NULL;
	GDBusConnection* _tmp0_;
	IBusBus* _tmp1_;
	PropertyManager* _tmp2_;
	PropertyManager* _tmp3_;
	CandidatePanel* _tmp4_;
	CandidatePanel* _tmp5_;
	CandidatePanel* _tmp6_;
	CandidatePanel* _tmp7_;
	CandidatePanel* _tmp8_;
	CandidatePanel* _tmp9_;
	CandidatePanel* _tmp10_;
	Switcher* _tmp11_;
	Switcher* _tmp12_;
	PropertyPanel* _tmp14_;
	PropertyPanel* _tmp15_;
#line 104 "panel.vala"
	g_return_val_if_fail (bus != NULL, NULL);
#line 106 "panel.vala"
	_vala_assert (ibus_bus_is_connected (bus), "bus.is_connected()");
#line 108 "panel.vala"
	_tmp0_ = ibus_bus_get_connection (bus);
#line 108 "panel.vala"
	self = (Panel*) g_object_new (object_type, "connection", _tmp0_, "object-path", "/org/freedesktop/IBus/Panel", NULL);
#line 111 "panel.vala"
	_tmp1_ = _g_object_ref0 (bus);
#line 111 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 111 "panel.vala"
	self->priv->m_bus = _tmp1_;
#line 112 "panel.vala"
	self->priv->m_is_wayland_im = is_wayland_im;
#line 115 "panel.vala"
	self->priv->m_is_wayland = !binding_common_default_is_xdisplay ();
#line 121 "panel.vala"
	panel_init_settings (self);
#line 124 "panel.vala"
	_tmp2_ = property_manager_new ();
#line 124 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 124 "panel.vala"
	self->priv->m_property_manager = _tmp2_;
#line 125 "panel.vala"
	_tmp3_ = self->priv->m_property_manager;
#line 125 "panel.vala"
	g_signal_connect_object (_tmp3_, "property-activate", (GCallback) ___lambda84__property_manager_property_activate, self, 0);
#line 131 "panel.vala"
	if (self->priv->m_is_kde) {
#line 132 "panel.vala"
		panel_init_indicator (self);
#line 1301 "panel.c"
	} else {
#line 134 "panel.vala"
		panel_init_status_icon (self);
#line 1305 "panel.c"
	}
#line 140 "panel.vala"
	_tmp4_ = candidate_panel_new ();
#line 140 "panel.vala"
	g_object_ref_sink (_tmp4_);
#line 140 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 140 "panel.vala"
	self->priv->m_candidate_panel = _tmp4_;
#line 141 "panel.vala"
	_tmp5_ = self->priv->m_candidate_panel;
#line 141 "panel.vala"
	g_signal_connect_object (_tmp5_, "page-up", (GCallback) ___lambda96__candidate_panel_page_up, self, 0);
#line 142 "panel.vala"
	_tmp6_ = self->priv->m_candidate_panel;
#line 142 "panel.vala"
	g_signal_connect_object (_tmp6_, "page-down", (GCallback) ___lambda97__candidate_panel_page_down, self, 0);
#line 143 "panel.vala"
	_tmp7_ = self->priv->m_candidate_panel;
#line 143 "panel.vala"
	g_signal_connect_object (_tmp7_, "cursor-up", (GCallback) ___lambda98__candidate_panel_cursor_up, self, 0);
#line 144 "panel.vala"
	_tmp8_ = self->priv->m_candidate_panel;
#line 144 "panel.vala"
	g_signal_connect_object (_tmp8_, "cursor-down", (GCallback) ___lambda99__candidate_panel_cursor_down, self, 0);
#line 145 "panel.vala"
	_tmp9_ = self->priv->m_candidate_panel;
#line 145 "panel.vala"
	g_signal_connect_object (_tmp9_, "candidate-clicked", (GCallback) ___lambda100__candidate_panel_candidate_clicked, self, 0);
#line 148 "panel.vala"
	_tmp10_ = self->priv->m_candidate_panel;
#line 148 "panel.vala"
	g_signal_connect_object (_tmp10_, "realize-surface", (GCallback) ___lambda101__candidate_panel_realize_surface, self, 0);
#line 152 "panel.vala"
	_tmp11_ = switcher_new ();
#line 152 "panel.vala"
	g_object_ref_sink (_tmp11_);
#line 152 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 152 "panel.vala"
	self->priv->m_switcher = _tmp11_;
#line 154 "panel.vala"
	_tmp12_ = self->priv->m_switcher;
#line 154 "panel.vala"
	g_signal_connect_object (_tmp12_, "realize-surface", (GCallback) ___lambda102__switcher_realize_surface, self, 0);
#line 158 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 160 "panel.vala"
	if (self->priv->m_switcher_delay_time >= 0) {
#line 1355 "panel.c"
		Switcher* _tmp13_;
#line 161 "panel.vala"
		_tmp13_ = self->priv->m_switcher;
#line 161 "panel.vala"
		switcher_set_popup_delay_time (_tmp13_, (guint) self->priv->m_switcher_delay_time);
#line 1361 "panel.c"
	}
#line 164 "panel.vala"
	_tmp14_ = property_panel_new ();
#line 164 "panel.vala"
	g_object_ref_sink (_tmp14_);
#line 164 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 164 "panel.vala"
	self->priv->m_property_panel = _tmp14_;
#line 165 "panel.vala"
	_tmp15_ = self->priv->m_property_panel;
#line 165 "panel.vala"
	g_signal_connect_object (_tmp15_, "property-activate", (GCallback) ___lambda103__property_panel_property_activate, self, 0);
#line 169 "panel.vala"
	panel_set_version (self);
#line 170 "panel.vala"
	panel_check_wayland (self);
#line 172 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 104 "panel.vala"
	return self;
#line 1383 "panel.c"
}

Panel*
panel_new (IBusBus* bus,
           gboolean is_wayland_im)
{
#line 104 "panel.vala"
	return panel_construct (TYPE_PANEL, bus, is_wayland_im);
#line 1392 "panel.c"
}

static void
__lambda60_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 192 "panel.vala"
	g_return_if_fail (key != NULL);
#line 193 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 193 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, key);
#line 193 "panel.vala"
	_tmp3_ = _tmp2_;
#line 193 "panel.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 193 "panel.vala"
	panel_update_engines (self, _tmp3_, (gint) _vala_array_length (_tmp1_), NULL, (gint) 0);
#line 193 "panel.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 1418 "panel.c"
}

static void
___lambda60__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 192 "panel.vala"
	__lambda60_ ((Panel*) self, key);
#line 1428 "panel.c"
}

static void
__lambda63_ (Panel* self,
             const gchar* key)
{
#line 197 "panel.vala"
	g_return_if_fail (key != NULL);
#line 198 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 1439 "panel.c"
}

static void
___lambda63__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 197 "panel.vala"
	__lambda63_ ((Panel*) self, key);
#line 1449 "panel.c"
}

static void
__lambda64_ (Panel* self,
             const gchar* key)
{
#line 202 "panel.vala"
	g_return_if_fail (key != NULL);
#line 203 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 1460 "panel.c"
}

static void
___lambda64__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 201 "panel.vala"
	__lambda64_ ((Panel*) self, key);
#line 1470 "panel.c"
}

static void
__lambda65_ (Panel* self,
             const gchar* key)
{
#line 206 "panel.vala"
	g_return_if_fail (key != NULL);
#line 207 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 1481 "panel.c"
}

static void
___lambda65__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 206 "panel.vala"
	__lambda65_ ((Panel*) self, key);
#line 1491 "panel.c"
}

static void
__lambda66_ (Panel* self,
             const gchar* key)
{
#line 210 "panel.vala"
	g_return_if_fail (key != NULL);
#line 211 "panel.vala"
	panel_set_use_global_engine (self);
#line 1502 "panel.c"
}

static void
___lambda66__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 210 "panel.vala"
	__lambda66_ ((Panel*) self, key);
#line 1512 "panel.c"
}

static void
__lambda67_ (Panel* self,
             const gchar* key)
{
#line 214 "panel.vala"
	g_return_if_fail (key != NULL);
#line 215 "panel.vala"
	panel_set_use_xmodmap (self);
#line 1523 "panel.c"
}

static void
___lambda67__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 214 "panel.vala"
	__lambda67_ ((Panel*) self, key);
#line 1533 "panel.c"
}

static void
__lambda68_ (Panel* self,
             const gchar* key)
{
	GList* _tmp0_;
#line 218 "panel.vala"
	g_return_if_fail (key != NULL);
#line 219 "panel.vala"
	_tmp0_ = self->priv->m_keybindings;
#line 219 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER, _tmp0_);
#line 222 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 222 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 223 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 1553 "panel.c"
}

static void
___lambda68__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 218 "panel.vala"
	__lambda68_ ((Panel*) self, key);
#line 1563 "panel.c"
}

static void
__lambda70_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 226 "panel.vala"
	g_return_if_fail (key != NULL);
#line 227 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 227 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1577 "panel.c"
}

static void
___lambda70__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 226 "panel.vala"
	__lambda70_ ((Panel*) self, key);
#line 1587 "panel.c"
}

static void
__lambda71_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 232 "panel.vala"
	g_return_if_fail (key != NULL);
#line 233 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 233 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1601 "panel.c"
}

static void
___lambda71__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 232 "panel.vala"
	__lambda71_ ((Panel*) self, key);
#line 1611 "panel.c"
}

static void
__lambda72_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 238 "panel.vala"
	g_return_if_fail (key != NULL);
#line 239 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 239 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1625 "panel.c"
}

static void
___lambda72__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 238 "panel.vala"
	__lambda72_ ((Panel*) self, key);
#line 1635 "panel.c"
}

static void
__lambda73_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 242 "panel.vala"
	g_return_if_fail (key != NULL);
#line 243 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 243 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1649 "panel.c"
}

static void
___lambda73__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 242 "panel.vala"
	__lambda73_ ((Panel*) self, key);
#line 1659 "panel.c"
}

static void
__lambda74_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 246 "panel.vala"
	g_return_if_fail (key != NULL);
#line 247 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 247 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 1673 "panel.c"
}

static void
___lambda74__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 246 "panel.vala"
	__lambda74_ ((Panel*) self, key);
#line 1683 "panel.c"
}

static void
__lambda75_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 250 "panel.vala"
	g_return_if_fail (key != NULL);
#line 251 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 251 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 1697 "panel.c"
}

static void
___lambda75__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 250 "panel.vala"
	__lambda75_ ((Panel*) self, key);
#line 1707 "panel.c"
}

static void
__lambda76_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp1_;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* _tmp3_;
#line 254 "panel.vala"
	g_return_if_fail (key != NULL);
#line 256 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 256 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 258 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 258 "panel.vala"
	_tmp2_ = ibus_bus_get_global_engine (_tmp1_);
#line 258 "panel.vala"
	engine = _tmp2_;
#line 259 "panel.vala"
	_tmp3_ = engine;
#line 259 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1735 "panel.c"
		IBusEngineDesc* _tmp4_;
#line 260 "panel.vala"
		_tmp4_ = engine;
#line 260 "panel.vala"
		panel_set_language_from_engine (self, _tmp4_);
#line 1741 "panel.c"
	}
#line 254 "panel.vala"
	_g_object_unref0 (engine);
#line 1745 "panel.c"
}

static void
___lambda76__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 254 "panel.vala"
	__lambda76_ ((Panel*) self, key);
#line 1755 "panel.c"
}

static void
__lambda77_ (Panel* self,
             const gchar* key)
{
#line 263 "panel.vala"
	g_return_if_fail (key != NULL);
#line 264 "panel.vala"
	panel_set_show_icon_on_systray (self, TRUE);
#line 1766 "panel.c"
}

static void
___lambda77__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 263 "panel.vala"
	__lambda77_ ((Panel*) self, key);
#line 1776 "panel.c"
}

static void
__lambda78_ (Panel* self,
             const gchar* key)
{
#line 267 "panel.vala"
	g_return_if_fail (key != NULL);
#line 268 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 1787 "panel.c"
}

static void
___lambda78__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 267 "panel.vala"
	__lambda78_ ((Panel*) self, key);
#line 1797 "panel.c"
}

static void
__lambda79_ (Panel* self,
             const gchar* key)
{
#line 271 "panel.vala"
	g_return_if_fail (key != NULL);
#line 272 "panel.vala"
	panel_set_show_property_panel (self);
#line 1808 "panel.c"
}

static void
___lambda79__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 271 "panel.vala"
	__lambda79_ ((Panel*) self, key);
#line 1818 "panel.c"
}

static void
__lambda80_ (Panel* self,
             const gchar* key)
{
#line 275 "panel.vala"
	g_return_if_fail (key != NULL);
#line 276 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 1829 "panel.c"
}

static void
___lambda80__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 275 "panel.vala"
	__lambda80_ ((Panel*) self, key);
#line 1839 "panel.c"
}

static void
__lambda81_ (Panel* self,
             const gchar* key)
{
#line 280 "panel.vala"
	g_return_if_fail (key != NULL);
#line 281 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 1850 "panel.c"
}

static void
___lambda81__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 279 "panel.vala"
	__lambda81_ ((Panel*) self, key);
#line 1860 "panel.c"
}

static void
__lambda82_ (Panel* self,
             const gchar* key)
{
#line 284 "panel.vala"
	g_return_if_fail (key != NULL);
#line 285 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 1871 "panel.c"
}

static void
___lambda82__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 284 "panel.vala"
	__lambda82_ ((Panel*) self, key);
#line 1881 "panel.c"
}

static void
__lambda83_ (Panel* self,
             const gchar* key)
{
#line 288 "panel.vala"
	g_return_if_fail (key != NULL);
#line 289 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 1892 "panel.c"
}

static void
___lambda83__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 288 "panel.vala"
	__lambda83_ ((Panel*) self, key);
#line 1902 "panel.c"
}

static void
panel_init_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
#line 186 "panel.vala"
	g_return_if_fail (self != NULL);
#line 187 "panel.vala"
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.general");
#line 187 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 187 "panel.vala"
	self->priv->m_settings_general = _tmp0_;
#line 188 "panel.vala"
	_tmp1_ = g_settings_new ("org.freedesktop.ibus.general.hotkey");
#line 188 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 188 "panel.vala"
	self->priv->m_settings_hotkey = _tmp1_;
#line 190 "panel.vala"
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
#line 190 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 190 "panel.vala"
	self->priv->m_settings_panel = _tmp2_;
#line 192 "panel.vala"
	_tmp3_ = self->priv->m_settings_general;
#line 192 "panel.vala"
	g_signal_connect_object (_tmp3_, "changed::preload-engines", (GCallback) ___lambda60__g_settings_changed, self, 0);
#line 197 "panel.vala"
	_tmp4_ = self->priv->m_settings_general;
#line 197 "panel.vala"
	g_signal_connect_object (_tmp4_, "changed::switcher-delay-time", (GCallback) ___lambda63__g_settings_changed, self, 0);
#line 201 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 201 "panel.vala"
	g_signal_connect_object (_tmp5_, "changed::use-system-keyboard-layout", (GCallback) ___lambda64__g_settings_changed, self, 0);
#line 206 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 206 "panel.vala"
	g_signal_connect_object (_tmp6_, "changed::embed-preedit-text", (GCallback) ___lambda65__g_settings_changed, self, 0);
#line 210 "panel.vala"
	_tmp7_ = self->priv->m_settings_general;
#line 210 "panel.vala"
	g_signal_connect_object (_tmp7_, "changed::use-global-engine", (GCallback) ___lambda66__g_settings_changed, self, 0);
#line 214 "panel.vala"
	_tmp8_ = self->priv->m_settings_general;
#line 214 "panel.vala"
	g_signal_connect_object (_tmp8_, "changed::use-xmodmap", (GCallback) ___lambda67__g_settings_changed, self, 0);
#line 218 "panel.vala"
	_tmp9_ = self->priv->m_settings_hotkey;
#line 218 "panel.vala"
	g_signal_connect_object (_tmp9_, "changed::triggers", (GCallback) ___lambda68__g_settings_changed, self, 0);
#line 226 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 226 "panel.vala"
	g_signal_connect_object (_tmp10_, "changed::custom-font", (GCallback) ___lambda70__g_settings_changed, self, 0);
#line 232 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 232 "panel.vala"
	g_signal_connect_object (_tmp11_, "changed::use-custom-font", (GCallback) ___lambda71__g_settings_changed, self, 0);
#line 238 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 238 "panel.vala"
	g_signal_connect_object (_tmp12_, "changed::custom-theme", (GCallback) ___lambda72__g_settings_changed, self, 0);
#line 242 "panel.vala"
	_tmp13_ = self->priv->m_settings_panel;
#line 242 "panel.vala"
	g_signal_connect_object (_tmp13_, "changed::use-custom-theme", (GCallback) ___lambda73__g_settings_changed, self, 0);
#line 246 "panel.vala"
	_tmp14_ = self->priv->m_settings_panel;
#line 246 "panel.vala"
	g_signal_connect_object (_tmp14_, "changed::custom-icon", (GCallback) ___lambda74__g_settings_changed, self, 0);
#line 250 "panel.vala"
	_tmp15_ = self->priv->m_settings_panel;
#line 250 "panel.vala"
	g_signal_connect_object (_tmp15_, "changed::use-custom-icon", (GCallback) ___lambda75__g_settings_changed, self, 0);
#line 254 "panel.vala"
	_tmp16_ = self->priv->m_settings_panel;
#line 254 "panel.vala"
	g_signal_connect_object (_tmp16_, "changed::use-glyph-from-engine-lang", (GCallback) ___lambda76__g_settings_changed, self, 0);
#line 263 "panel.vala"
	_tmp17_ = self->priv->m_settings_panel;
#line 263 "panel.vala"
	g_signal_connect_object (_tmp17_, "changed::show-icon-on-systray", (GCallback) ___lambda77__g_settings_changed, self, 0);
#line 267 "panel.vala"
	_tmp18_ = self->priv->m_settings_panel;
#line 267 "panel.vala"
	g_signal_connect_object (_tmp18_, "changed::lookup-table-orientation", (GCallback) ___lambda78__g_settings_changed, self, 0);
#line 271 "panel.vala"
	_tmp19_ = self->priv->m_settings_panel;
#line 271 "panel.vala"
	g_signal_connect_object (_tmp19_, "changed::show", (GCallback) ___lambda79__g_settings_changed, self, 0);
#line 275 "panel.vala"
	_tmp20_ = self->priv->m_settings_panel;
#line 275 "panel.vala"
	g_signal_connect_object (_tmp20_, "changed::timeout", (GCallback) ___lambda80__g_settings_changed, self, 0);
#line 279 "panel.vala"
	_tmp21_ = self->priv->m_settings_panel;
#line 279 "panel.vala"
	g_signal_connect_object (_tmp21_, "changed::follow-input-cursor-when-always-shown", (GCallback) ___lambda81__g_settings_changed, self, 0);
#line 284 "panel.vala"
	_tmp22_ = self->priv->m_settings_panel;
#line 284 "panel.vala"
	g_signal_connect_object (_tmp22_, "changed::xkb-icon-rgba", (GCallback) ___lambda82__g_settings_changed, self, 0);
#line 288 "panel.vala"
	_tmp23_ = self->priv->m_settings_panel;
#line 288 "panel.vala"
	g_signal_connect_object (_tmp23_, "changed::property-icon-delay-time", (GCallback) ___lambda83__g_settings_changed, self, 0);
#line 2036 "panel.c"
}

static void
panel_popup_menu_at_area_window (Panel* self,
                                 GtkMenu* menu,
                                 GdkRectangle* area,
                                 GdkWindow* window,
                                 GtkMenuPositionFunc func,
                                 gpointer func_target)
{
	GdkGravity rect_anchor = 0;
	GdkGravity menu_anchor = 0;
	GdkRectangle _tmp0_;
#line 293 "panel.vala"
	g_return_if_fail (self != NULL);
#line 293 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 293 "panel.vala"
	g_return_if_fail (area != NULL);
#line 297 "panel.vala"
	rect_anchor = GDK_GRAVITY_SOUTH_WEST;
#line 298 "panel.vala"
	menu_anchor = GDK_GRAVITY_NORTH_WEST;
#line 307 "panel.vala"
	_tmp0_ = *area;
#line 307 "panel.vala"
	gtk_menu_popup_at_rect (menu, window, &_tmp0_, rect_anchor, menu_anchor, NULL);
#line 2064 "panel.c"
}

static gboolean
panel_is_gnome (void)
{
	const gchar* desktop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gboolean result;
#line 312 "panel.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 312 "panel.vala"
	desktop = _tmp0_;
#line 314 "panel.vala"
	_tmp1_ = desktop;
#line 314 "panel.vala"
	if (g_strcmp0 (_tmp1_, "GNOME") == 0) {
#line 315 "panel.vala"
		result = TRUE;
#line 315 "panel.vala"
		return result;
#line 2090 "panel.c"
	}
#line 316 "panel.vala"
	_tmp3_ = desktop;
#line 316 "panel.vala"
	if (_tmp3_ == NULL) {
#line 316 "panel.vala"
		_tmp2_ = TRUE;
#line 2098 "panel.c"
	} else {
		const gchar* _tmp4_;
#line 316 "panel.vala"
		_tmp4_ = desktop;
#line 316 "panel.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "(null)") == 0;
#line 2105 "panel.c"
	}
#line 316 "panel.vala"
	if (_tmp2_) {
#line 2109 "panel.c"
		const gchar* _tmp5_;
#line 317 "panel.vala"
		_tmp5_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 317 "panel.vala"
		desktop = _tmp5_;
#line 2115 "panel.c"
	}
#line 318 "panel.vala"
	_tmp7_ = desktop;
#line 318 "panel.vala"
	if (g_strcmp0 (_tmp7_, "gnome") == 0) {
#line 318 "panel.vala"
		_tmp6_ = TRUE;
#line 2123 "panel.c"
	} else {
		const gchar* _tmp8_;
#line 318 "panel.vala"
		_tmp8_ = desktop;
#line 318 "panel.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "GNOME") == 0;
#line 2130 "panel.c"
	}
#line 318 "panel.vala"
	if (_tmp6_) {
#line 319 "panel.vala"
		result = TRUE;
#line 319 "panel.vala"
		return result;
#line 2138 "panel.c"
	}
#line 320 "panel.vala"
	result = FALSE;
#line 320 "panel.vala"
	return result;
#line 2144 "panel.c"
}

static gboolean
panel_is_kde (void)
{
	const gchar* desktop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp9_;
	gboolean result;
#line 326 "panel.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 326 "panel.vala"
	desktop = _tmp0_;
#line 328 "panel.vala"
	_tmp1_ = desktop;
#line 328 "panel.vala"
	if (g_strcmp0 (_tmp1_, "KDE") == 0) {
#line 329 "panel.vala"
		result = TRUE;
#line 329 "panel.vala"
		return result;
#line 2171 "panel.c"
	}
#line 335 "panel.vala"
	_tmp3_ = desktop;
#line 335 "panel.vala"
	if (_tmp3_ == NULL) {
#line 335 "panel.vala"
		_tmp2_ = TRUE;
#line 2179 "panel.c"
	} else {
		const gchar* _tmp4_;
#line 335 "panel.vala"
		_tmp4_ = desktop;
#line 335 "panel.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "(null)") == 0;
#line 2186 "panel.c"
	}
#line 335 "panel.vala"
	if (_tmp2_) {
#line 2190 "panel.c"
		const gchar* _tmp5_;
#line 336 "panel.vala"
		_tmp5_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 336 "panel.vala"
		desktop = _tmp5_;
#line 2196 "panel.c"
	}
#line 337 "panel.vala"
	_tmp7_ = desktop;
#line 337 "panel.vala"
	if (g_strcmp0 (_tmp7_, "plasma") == 0) {
#line 337 "panel.vala"
		_tmp6_ = TRUE;
#line 2204 "panel.c"
	} else {
		const gchar* _tmp8_;
#line 337 "panel.vala"
		_tmp8_ = desktop;
#line 337 "panel.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "KDE-wayland") == 0;
#line 2211 "panel.c"
	}
#line 337 "panel.vala"
	if (_tmp6_) {
#line 338 "panel.vala"
		result = TRUE;
#line 338 "panel.vala"
		return result;
#line 2219 "panel.c"
	}
#line 339 "panel.vala"
	_tmp9_ = desktop;
#line 339 "panel.vala"
	if (_tmp9_ == NULL) {
#line 340 "panel.vala"
		g_warning ("panel.vala:340: %s", "XDG_CURRENT_DESKTOP is not exported in your desktop " "session.");
#line 2227 "panel.c"
	}
#line 343 "panel.vala"
	g_warning ("panel.vala:343: %s", "If you launch KDE5 on xterm, " "export XDG_CURRENT_DESKTOP=KDE before launch KDE5.");
#line 345 "panel.vala"
	result = FALSE;
#line 345 "panel.vala"
	return result;
#line 2235 "panel.c"
}

static void
panel_popup_menu_at_pointer_window (Panel* self,
                                    GtkMenu* menu,
                                    gint x,
                                    gint y,
                                    GdkWindow* window,
                                    GtkMenuPositionFunc func,
                                    gpointer func_target)
{
	gint win_x = 0;
	gint win_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkRectangle area = {0};
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
#line 348 "panel.vala"
	g_return_if_fail (self != NULL);
#line 348 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 353 "panel.vala"
	win_x = 0;
#line 354 "panel.vala"
	win_y = 0;
#line 355 "panel.vala"
	gdk_window_get_origin (window, &_tmp0_, &_tmp1_);
#line 355 "panel.vala"
	win_x = _tmp0_;
#line 355 "panel.vala"
	win_y = _tmp1_;
#line 356 "panel.vala"
	_tmp2_.x = x - win_x;
#line 356 "panel.vala"
	_tmp2_.y = y - win_y;
#line 356 "panel.vala"
	_tmp2_.width = 1;
#line 356 "panel.vala"
	_tmp2_.height = 1;
#line 356 "panel.vala"
	area = _tmp2_;
#line 358 "panel.vala"
	_tmp3_ = area;
#line 358 "panel.vala"
	panel_popup_menu_at_area_window (self, menu, &_tmp3_, window, func, func_target);
#line 2282 "panel.c"
}

static void
__lambda85_ (Panel* self)
{
	Indicator* _tmp0_;
#line 371 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 371 "panel.vala"
	indicator_set_status (_tmp0_, self->priv->m_indicator_show_status);
#line 372 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 2295 "panel.c"
}

static void
___lambda85__indicator_registered_status_notifier_item (Indicator* _sender,
                                                        gpointer self)
{
#line 369 "panel.vala"
	__lambda85_ ((Panel*) self);
#line 2304 "panel.c"
}

static void
__lambda86_ (Panel* self)
{
#line 376 "panel.vala"
	self->priv->m_is_context_menu = !self->priv->m_is_context_menu;
#line 377 "panel.vala"
	if (self->priv->m_is_context_menu) {
#line 2314 "panel.c"
		Indicator* _tmp0_;
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 378 "panel.vala"
		_tmp0_ = self->priv->m_indicator;
#line 378 "panel.vala"
		_tmp1_ = panel_create_context_menu (self, FALSE);
#line 378 "panel.vala"
		_tmp2_ = _tmp1_;
#line 378 "panel.vala"
		indicator_set_menu (_tmp0_, _tmp2_);
#line 378 "panel.vala"
		_g_object_unref0 (_tmp2_);
#line 2328 "panel.c"
	} else {
		Indicator* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
#line 380 "panel.vala"
		_tmp3_ = self->priv->m_indicator;
#line 380 "panel.vala"
		_tmp4_ = panel_create_activate_menu (self, FALSE);
#line 380 "panel.vala"
		_tmp5_ = _tmp4_;
#line 380 "panel.vala"
		indicator_set_menu (_tmp3_, _tmp5_);
#line 380 "panel.vala"
		_g_object_unref0 (_tmp5_);
#line 2343 "panel.c"
	}
}

static void
___lambda86__indicator_secondary_activate (Indicator* _sender,
                                           gpointer self)
{
#line 374 "panel.vala"
	__lambda86_ ((Panel*) self);
#line 2353 "panel.c"
}

static void
panel_init_indicator (Panel* self)
{
	Indicator* _tmp0_;
	Indicator* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	Indicator* _tmp4_;
	gulong _tmp5_;
	Indicator* _tmp6_;
	gulong _tmp7_;
	Indicator* _tmp8_;
	GtkMenu* _tmp9_;
	GtkMenu* _tmp10_;
#line 361 "panel.vala"
	g_return_if_fail (self != NULL);
#line 362 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_INDICATOR;
#line 363 "panel.vala"
	_tmp0_ = indicator_new ("ibus-ui-gtk3", INDICATOR_CATEGORY_APPLICATION_STATUS);
#line 363 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 363 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 363 "panel.vala"
	self->priv->m_indicator = _tmp0_;
#line 365 "panel.vala"
	_tmp1_ = self->priv->m_indicator;
#line 365 "panel.vala"
	_tmp2_ = g_strdup_printf ("%s\n%s", _ ("IBus Panel"), _ ("You can toggle the activate menu and context one with " "clicking the mouse middle button on the panel icon."));
#line 365 "panel.vala"
	_tmp3_ = _tmp2_;
#line 365 "panel.vala"
	indicator_set_title (_tmp1_, _tmp3_);
#line 365 "panel.vala"
	_g_free0 (_tmp3_);
#line 369 "panel.vala"
	_tmp4_ = self->priv->m_indicator;
#line 369 "panel.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "registered-status-notifier-item", (GCallback) ___lambda85__indicator_registered_status_notifier_item, self, 0);
#line 369 "panel.vala"
	self->priv->m_registered_status_notifier_item_id = _tmp5_;
#line 374 "panel.vala"
	_tmp6_ = self->priv->m_indicator;
#line 374 "panel.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "secondary-activate", (GCallback) ___lambda86__indicator_secondary_activate, self, 0);
#line 374 "panel.vala"
	self->priv->m_popup_menu_id = _tmp7_;
#line 382 "panel.vala"
	_tmp8_ = self->priv->m_indicator;
#line 382 "panel.vala"
	_tmp9_ = panel_create_activate_menu (self, FALSE);
#line 382 "panel.vala"
	_tmp10_ = _tmp9_;
#line 382 "panel.vala"
	indicator_set_menu (_tmp8_, _tmp10_);
#line 382 "panel.vala"
	_g_object_unref0 (_tmp10_);
#line 2414 "panel.c"
}

static void
_panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 395 "panel.vala"
	panel_init_status_icon_menu ((Panel*) self);
#line 2424 "panel.c"
}

static void
panel_init_status_icon (Panel* self)
{
	GtkStatusIcon* _tmp0_;
	GtkStatusIcon* _tmp1_;
	GtkStatusIcon* _tmp2_;
	GtkStatusIcon* _tmp3_;
#line 386 "panel.vala"
	g_return_if_fail (self != NULL);
#line 387 "panel.vala"
	_tmp0_ = gtk_status_icon_new ();
#line 387 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 387 "panel.vala"
	self->priv->m_status_icon = _tmp0_;
#line 388 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 388 "panel.vala"
	gtk_status_icon_set_name (_tmp1_, "ibus-ui-gtk");
#line 389 "panel.vala"
	_tmp2_ = self->priv->m_status_icon;
#line 389 "panel.vala"
	gtk_status_icon_set_title (_tmp2_, _ ("IBus Panel"));
#line 392 "panel.vala"
	_tmp3_ = self->priv->m_status_icon;
#line 392 "panel.vala"
	if (gtk_status_icon_get_size (_tmp3_) > 0) {
#line 393 "panel.vala"
		panel_init_status_icon_menu (self);
#line 2456 "panel.c"
	} else {
		GtkStatusIcon* _tmp4_;
#line 395 "panel.vala"
		_tmp4_ = self->priv->m_status_icon;
#line 395 "panel.vala"
		g_signal_connect_object ((GObject*) _tmp4_, "notify::size", (GCallback) _panel_init_status_icon_menu_g_object_notify, self, 0);
#line 2463 "panel.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 398 "panel.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 398 "panel.vala"
	return _data7_;
#line 2474 "panel.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 398 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2484 "panel.c"
		Panel* self;
#line 398 "panel.vala"
		self = _data7_->self;
#line 398 "panel.vala"
		(_data7_->func_target_destroy_notify == NULL) ? NULL : (_data7_->func_target_destroy_notify (_data7_->func_target), NULL);
#line 398 "panel.vala"
		_data7_->func = NULL;
#line 398 "panel.vala"
		_data7_->func_target = NULL;
#line 398 "panel.vala"
		_data7_->func_target_destroy_notify = NULL;
#line 398 "panel.vala"
		_g_object_unref0 (_data7_->window);
#line 398 "panel.vala"
		_g_object_unref0 (self);
#line 398 "panel.vala"
		g_slice_free (Block7Data, _data7_);
#line 2502 "panel.c"
	}
}

static void
__lambda94_ (Block7Data* _data7_,
             guint b,
             guint t)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 436 "panel.vala"
	self = _data7_->self;
#line 437 "panel.vala"
	_tmp0_ = panel_create_context_menu (self, TRUE);
#line 437 "panel.vala"
	_tmp1_ = _tmp0_;
#line 437 "panel.vala"
	_tmp2_ = _data7_->area;
#line 437 "panel.vala"
	_tmp3_ = _data7_->window;
#line 437 "panel.vala"
	_tmp4_ = _data7_->func;
#line 437 "panel.vala"
	_tmp4__target = _data7_->func_target;
#line 437 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 437 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2536 "panel.c"
}

static void
___lambda94__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                         guint button,
                                         guint activate_time,
                                         gpointer self)
{
#line 436 "panel.vala"
	__lambda94_ (self, button, activate_time);
#line 2547 "panel.c"
}

static void
__lambda95_ (Block7Data* _data7_)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 441 "panel.vala"
	self = _data7_->self;
#line 442 "panel.vala"
	_tmp0_ = panel_create_activate_menu (self, TRUE);
#line 442 "panel.vala"
	_tmp1_ = _tmp0_;
#line 442 "panel.vala"
	_tmp2_ = _data7_->area;
#line 442 "panel.vala"
	_tmp3_ = _data7_->window;
#line 442 "panel.vala"
	_tmp4_ = _data7_->func;
#line 442 "panel.vala"
	_tmp4__target = _data7_->func_target;
#line 442 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 442 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2578 "panel.c"
}

static void
___lambda95__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                       gpointer self)
{
#line 441 "panel.vala"
	__lambda95_ (self);
#line 2587 "panel.c"
}

static void
panel_init_status_icon_menu (Panel* self)
{
	Block7Data* _data7_;
	GdkRectangle _tmp0_ = {0};
	GtkStatusIcon* _tmp1_;
	GdkX11Display* display = NULL;
	GdkX11Display* _tmp2_;
	GdkX11Display* _tmp3_;
	GdkX11Display* _tmp4_;
	GtkStatusIcon* _tmp5_;
	GdkX11Window* _tmp6_;
	GdkWindow* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GdkWindow* _tmp9_;
	GdkWindow* _tmp19_;
	GtkOrientation orient = 0;
	GtkStatusIcon* _tmp20_;
	GdkRectangle _tmp21_ = {0};
	GtkOrientation _tmp22_ = 0;
	gint win_x = 0;
	gint win_y = 0;
	GdkWindow* _tmp23_;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GtkStatusIcon* _tmp26_;
	gulong _tmp27_;
	GtkStatusIcon* _tmp28_;
	gulong _tmp29_;
#line 398 "panel.vala"
	g_return_if_fail (self != NULL);
#line 398 "panel.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 398 "panel.vala"
	_data7_->_ref_count_ = 1;
#line 398 "panel.vala"
	_data7_->self = g_object_ref (self);
#line 399 "panel.vala"
	_tmp0_.x = 0;
#line 399 "panel.vala"
	_tmp0_.y = 0;
#line 399 "panel.vala"
	_tmp0_.width = 0;
#line 399 "panel.vala"
	_tmp0_.height = 0;
#line 399 "panel.vala"
	_data7_->area = _tmp0_;
#line 400 "panel.vala"
	_data7_->window = NULL;
#line 401 "panel.vala"
	_data7_->func = NULL;
#line 401 "panel.vala"
	_data7_->func_target = NULL;
#line 401 "panel.vala"
	_data7_->func_target_destroy_notify = NULL;
#line 402 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 402 "panel.vala"
	gtk_status_icon_set_from_icon_name (_tmp1_, "ibus-keyboard");
#line 403 "panel.vala"
	_tmp2_ = binding_common_get_xdisplay (FALSE);
#line 403 "panel.vala"
	display = _tmp2_;
#line 404 "panel.vala"
	_tmp3_ = display;
#line 404 "panel.vala"
	if (_tmp3_ == NULL) {
#line 405 "panel.vala"
		g_warning ("panel.vala:405: No Gdk.X11.Display");
#line 406 "panel.vala"
		_g_object_unref0 (display);
#line 406 "panel.vala"
		block7_data_unref (_data7_);
#line 406 "panel.vala"
		_data7_ = NULL;
#line 406 "panel.vala"
		return;
#line 2667 "panel.c"
	}
#line 408 "panel.vala"
	_tmp4_ = display;
#line 408 "panel.vala"
	_tmp5_ = self->priv->m_status_icon;
#line 408 "panel.vala"
	_tmp6_ = gdk_x11_window_lookup_for_display (_tmp4_, (Window) gtk_status_icon_get_x11_window_id (_tmp5_));
#line 408 "panel.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_window_get_type ()) ? ((GdkWindow*) _tmp6_) : NULL);
#line 408 "panel.vala"
	_g_object_unref0 (_data7_->window);
#line 408 "panel.vala"
	_data7_->window = _tmp7_;
#line 411 "panel.vala"
	_tmp9_ = _data7_->window;
#line 411 "panel.vala"
	if (_tmp9_ == NULL) {
#line 411 "panel.vala"
		_tmp8_ = !binding_common_default_is_xdisplay ();
#line 2687 "panel.c"
	} else {
#line 411 "panel.vala"
		_tmp8_ = FALSE;
#line 2691 "panel.c"
	}
#line 411 "panel.vala"
	if (_tmp8_) {
#line 2695 "panel.c"
		Display* xdisplay = NULL;
		GdkX11Display* _tmp10_;
		Display* _tmp11_;
		Window root = 0;
		Display* _tmp12_;
		GdkX11Display* _tmp13_;
		GdkX11Window* _tmp14_;
		GdkWindow* _tmp15_;
		GdkWindow* _tmp16_;
#line 412 "panel.vala"
		_tmp10_ = display;
#line 412 "panel.vala"
		_tmp11_ = gdk_x11_display_get_xdisplay (_tmp10_);
#line 412 "panel.vala"
		xdisplay = _tmp11_;
#line 413 "panel.vala"
		_tmp12_ = xdisplay;
#line 413 "panel.vala"
		root = DefaultRootWindow (_tmp12_);
#line 414 "panel.vala"
		_tmp13_ = display;
#line 414 "panel.vala"
		_tmp14_ = gdk_x11_window_lookup_for_display (_tmp13_, root);
#line 414 "panel.vala"
		_tmp15_ = _g_object_ref0 ((GdkWindow*) _tmp14_);
#line 414 "panel.vala"
		_g_object_unref0 (_data7_->window);
#line 414 "panel.vala"
		_data7_->window = _tmp15_;
#line 417 "panel.vala"
		_tmp16_ = _data7_->window;
#line 417 "panel.vala"
		if (_tmp16_ == NULL) {
#line 2729 "panel.c"
			GdkX11Display* _tmp17_;
			GdkX11Window* _tmp18_;
#line 418 "panel.vala"
			_tmp17_ = display;
#line 418 "panel.vala"
			_tmp18_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp17_, root);
#line 418 "panel.vala"
			_g_object_unref0 (_data7_->window);
#line 418 "panel.vala"
			_data7_->window = (GdkWindow*) _tmp18_;
#line 2740 "panel.c"
		}
	}
#line 423 "panel.vala"
	_tmp19_ = _data7_->window;
#line 423 "panel.vala"
	if (_tmp19_ == NULL) {
#line 424 "panel.vala"
		g_warning ("panel.vala:424: StatusIcon does not have GdkWindow");
#line 425 "panel.vala"
		_g_object_unref0 (display);
#line 425 "panel.vala"
		block7_data_unref (_data7_);
#line 425 "panel.vala"
		_data7_ = NULL;
#line 425 "panel.vala"
		return;
#line 2757 "panel.c"
	}
#line 428 "panel.vala"
	_tmp20_ = self->priv->m_status_icon;
#line 428 "panel.vala"
	gtk_status_icon_get_geometry (_tmp20_, NULL, &_tmp21_, &_tmp22_);
#line 428 "panel.vala"
	_data7_->area = _tmp21_;
#line 428 "panel.vala"
	orient = _tmp22_;
#line 429 "panel.vala"
	win_x = 0;
#line 430 "panel.vala"
	win_y = 0;
#line 431 "panel.vala"
	_tmp23_ = _data7_->window;
#line 431 "panel.vala"
	gdk_window_get_origin (_tmp23_, &_tmp24_, &_tmp25_);
#line 431 "panel.vala"
	win_x = _tmp24_;
#line 431 "panel.vala"
	win_y = _tmp25_;
#line 434 "panel.vala"
	_data7_->area.x = _data7_->area.x - win_x;
#line 435 "panel.vala"
	_data7_->area.y = _data7_->area.y - win_y;
#line 436 "panel.vala"
	_tmp26_ = self->priv->m_status_icon;
#line 436 "panel.vala"
	_tmp27_ = g_signal_connect_data (_tmp26_, "popup-menu", (GCallback) ___lambda94__gtk_status_icon_popup_menu, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 436 "panel.vala"
	self->priv->m_popup_menu_id = _tmp27_;
#line 441 "panel.vala"
	_tmp28_ = self->priv->m_status_icon;
#line 441 "panel.vala"
	_tmp29_ = g_signal_connect_data (_tmp28_, "activate", (GCallback) ___lambda95__gtk_status_icon_activate, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 441 "panel.vala"
	self->priv->m_activate_id = _tmp29_;
#line 398 "panel.vala"
	_g_object_unref0 (display);
#line 398 "panel.vala"
	block7_data_unref (_data7_);
#line 398 "panel.vala"
	_data7_ = NULL;
#line 2801 "panel.c"
}

static void
_panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                               gpointer self)
{
#line 457 "panel.vala"
	panel_handle_engine_switch_normal ((Panel*) self, event);
#line 2810 "panel.c"
}

static void
_panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                gpointer self)
{
#line 457 "panel.vala"
	panel_handle_engine_switch_reverse ((Panel*) self, event);
#line 2819 "panel.c"
}

static void
_vala_array_add18 (IBusProcessKeyEventData* * array,
                   gint* length,
                   gint* size,
                   const IBusProcessKeyEventData* value)
{
#line 472 "panel.vala"
	if ((*length) == (*size)) {
#line 472 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 472 "panel.vala"
		*array = g_renew (IBusProcessKeyEventData, *array, *size);
#line 2834 "panel.c"
	}
#line 472 "panel.vala"
	(*array)[(*length)++] = *value;
#line 2838 "panel.c"
}

static void
_vala_array_add19 (IBusProcessKeyEventData* * array,
                   gint* length,
                   gint* size,
                   const IBusProcessKeyEventData* value)
{
#line 477 "panel.vala"
	if ((*length) == (*size)) {
#line 477 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 477 "panel.vala"
		*array = g_renew (IBusProcessKeyEventData, *array, *size);
#line 2853 "panel.c"
	}
#line 477 "panel.vala"
	(*array)[(*length)++] = *value;
#line 2857 "panel.c"
}

static void
panel_bind_switch_shortcut (Panel* self)
{
	gchar** accelerators = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint accelerators_length1;
	gint _accelerators_size_;
	KeybindingManager* keybinding_manager = NULL;
	KeybindingManager* _tmp3_;
	BindingCommonKeyEventFuncType ftype = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	IBusProcessKeyEventData* keys = NULL;
	IBusProcessKeyEventData* _tmp8_;
	gint keys_length1;
	gint _keys_size_;
	IBusProcessKeyEventData key = {0};
	GList* _tmp9_;
	IBusProcessKeyEventData* _tmp23_;
	gint _tmp23__length1;
	IBusProcessKeyEventData _tmp24_ = {0};
	IBusProcessKeyEventData _tmp25_;
	IBusBus* _tmp26_;
	IBusProcessKeyEventData* _tmp27_;
	gint _tmp27__length1;
#line 448 "panel.vala"
	g_return_if_fail (self != NULL);
#line 449 "panel.vala"
	_tmp0_ = self->priv->m_settings_hotkey;
#line 449 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "triggers");
#line 449 "panel.vala"
	accelerators = _tmp2_;
#line 449 "panel.vala"
	accelerators_length1 = _vala_array_length (_tmp1_);
#line 449 "panel.vala"
	_accelerators_size_ = accelerators_length1;
#line 451 "panel.vala"
	_tmp3_ = keybinding_manager_get_instance (self->priv->m_is_wayland_im);
#line 451 "panel.vala"
	keybinding_manager = _tmp3_;
#line 454 "panel.vala"
	ftype = BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER;
#line 456 "panel.vala"
	_tmp4_ = accelerators;
#line 456 "panel.vala"
	_tmp4__length1 = accelerators_length1;
#line 2909 "panel.c"
	{
		gchar** accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 456 "panel.vala"
		accelerator_collection = _tmp4_;
#line 456 "panel.vala"
		accelerator_collection_length1 = _tmp4__length1;
#line 456 "panel.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 2921 "panel.c"
			gchar* _tmp5_;
			gchar* accelerator = NULL;
#line 456 "panel.vala"
			_tmp5_ = g_strdup (accelerator_collection[accelerator_it]);
#line 456 "panel.vala"
			accelerator = _tmp5_;
#line 2928 "panel.c"
			{
				KeybindingManager* _tmp6_;
				const gchar* _tmp7_;
#line 457 "panel.vala"
				_tmp6_ = keybinding_manager;
#line 457 "panel.vala"
				_tmp7_ = accelerator;
#line 457 "panel.vala"
				binding_common_keybinding_manager_bind (_tmp6_, &self->priv->m_keybindings, _tmp7_, ftype, _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func, self, _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func, self);
#line 456 "panel.vala"
				_g_free0 (accelerator);
#line 2940 "panel.c"
			}
		}
	}
#line 466 "panel.vala"
	if (binding_common_default_is_xdisplay ()) {
#line 467 "panel.vala"
		_g_object_unref0 (keybinding_manager);
#line 467 "panel.vala"
		accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 467 "panel.vala"
		return;
#line 2952 "panel.c"
	}
#line 468 "panel.vala"
	_tmp8_ = g_new0 (IBusProcessKeyEventData, 0);
#line 468 "panel.vala"
	keys = _tmp8_;
#line 468 "panel.vala"
	keys_length1 = 0;
#line 468 "panel.vala"
	_keys_size_ = keys_length1;
#line 470 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 2964 "panel.c"
	{
		GList* kb_collection = NULL;
		GList* kb_it = NULL;
#line 470 "panel.vala"
		kb_collection = _tmp9_;
#line 470 "panel.vala"
		for (kb_it = kb_collection; kb_it != NULL; kb_it = kb_it->next) {
#line 2972 "panel.c"
			BindingCommonKeybinding* _tmp10_;
			BindingCommonKeybinding* kb = NULL;
#line 470 "panel.vala"
			_tmp10_ = _g_object_ref0 ((BindingCommonKeybinding*) kb_it->data);
#line 470 "panel.vala"
			kb = _tmp10_;
#line 2979 "panel.c"
			{
				gint _tmp11_ = 0;
				BindingCommonKeybinding* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				BindingCommonKeybinding* _tmp15_;
				guint _tmp16_;
				guint _tmp17_;
				BindingCommonKeybinding* _tmp18_;
				GdkModifierType _tmp19_;
				GdkModifierType _tmp20_;
				IBusProcessKeyEventData _tmp21_ = {0};
				IBusProcessKeyEventData _tmp22_;
#line 471 "panel.vala"
				_tmp12_ = kb;
#line 471 "panel.vala"
				_tmp13_ = binding_common_keybinding_get_reverse (_tmp12_);
#line 471 "panel.vala"
				_tmp14_ = _tmp13_;
#line 471 "panel.vala"
				if (_tmp14_) {
#line 471 "panel.vala"
					_tmp11_ = 1;
#line 3003 "panel.c"
				} else {
#line 471 "panel.vala"
					_tmp11_ = 0;
#line 3007 "panel.c"
				}
#line 471 "panel.vala"
				_tmp15_ = kb;
#line 471 "panel.vala"
				_tmp16_ = binding_common_keybinding_get_keysym (_tmp15_);
#line 471 "panel.vala"
				_tmp17_ = _tmp16_;
#line 471 "panel.vala"
				_tmp18_ = kb;
#line 471 "panel.vala"
				_tmp19_ = binding_common_keybinding_get_modifiers (_tmp18_);
#line 471 "panel.vala"
				_tmp20_ = _tmp19_;
#line 471 "panel.vala"
				_tmp21_.keyval = _tmp17_;
#line 471 "panel.vala"
				_tmp21_.keycode = (guint) _tmp11_;
#line 471 "panel.vala"
				_tmp21_.state = (guint) _tmp20_;
#line 471 "panel.vala"
				key = _tmp21_;
#line 472 "panel.vala"
				_tmp22_ = key;
#line 472 "panel.vala"
				_vala_array_add18 (&keys, &keys_length1, &_keys_size_, &_tmp22_);
#line 470 "panel.vala"
				_g_object_unref0 (kb);
#line 3035 "panel.c"
			}
		}
	}
#line 474 "panel.vala"
	_tmp23_ = keys;
#line 474 "panel.vala"
	_tmp23__length1 = keys_length1;
#line 474 "panel.vala"
	if (_tmp23__length1 == 0) {
#line 475 "panel.vala"
		keys = (g_free (keys), NULL);
#line 475 "panel.vala"
		_g_object_unref0 (keybinding_manager);
#line 475 "panel.vala"
		accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 475 "panel.vala"
		return;
#line 3053 "panel.c"
	}
#line 476 "panel.vala"
	_tmp24_.keyval = (guint) 0;
#line 476 "panel.vala"
	key = _tmp24_;
#line 477 "panel.vala"
	_tmp25_ = key;
#line 477 "panel.vala"
	_vala_array_add19 (&keys, &keys_length1, &_keys_size_, &_tmp25_);
#line 478 "panel.vala"
	_tmp26_ = self->priv->m_bus;
#line 478 "panel.vala"
	_tmp27_ = keys;
#line 478 "panel.vala"
	_tmp27__length1 = keys_length1;
#line 478 "panel.vala"
	ibus_bus_set_global_shortcut_keys_async (_tmp26_, IBUS_BUS_GLOBAL_BINDING_TYPE_IME_SWITCHER, _tmp27_, -1, NULL, NULL, NULL);
#line 448 "panel.vala"
	keys = (g_free (keys), NULL);
#line 448 "panel.vala"
	_g_object_unref0 (keybinding_manager);
#line 448 "panel.vala"
	accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 3077 "panel.c"
}

/**
     * panel_get_engines_from_xkb:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus xkb engines
     *
     * Made ibus engines from the current XKB keymaps.
     * This returns only XKB engines whose name start with "xkb:".
     */
static GList*
panel_get_engines_from_xkb (Panel* self,
                            GList* engines)
{
	gchar* layouts = NULL;
	gchar* variants = NULL;
	gchar* option = NULL;
	XKBLayout* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GList* xkb_engines = NULL;
	IBusEngineDesc* us_engine = NULL;
	IBusEngineDesc* _tmp4_;
	gchar** layout_array = NULL;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint layout_array_length1;
	gint _layout_array_size_;
	gchar** variant_array = NULL;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint variant_array_length1;
	gint _variant_array_size_;
	GList* _tmp46_;
	GList* result;
#line 512 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 517 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 517 "panel.vala"
	xkb_layout_get_layout (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 517 "panel.vala"
	_g_free0 (layouts);
#line 517 "panel.vala"
	layouts = _tmp1_;
#line 517 "panel.vala"
	_g_free0 (variants);
#line 517 "panel.vala"
	variants = _tmp2_;
#line 517 "panel.vala"
	_g_free0 (option);
#line 517 "panel.vala"
	option = _tmp3_;
#line 519 "panel.vala"
	xkb_engines = NULL;
#line 521 "panel.vala"
	_tmp4_ = ibus_engine_desc_new ("xkb:us::eng", "", "", "", "", "", "", "");
#line 521 "panel.vala"
	g_object_ref_sink (_tmp4_);
#line 521 "panel.vala"
	us_engine = _tmp4_;
#line 524 "panel.vala"
	_tmp5_ = layouts;
#line 524 "panel.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ",", 0);
#line 524 "panel.vala"
	layout_array = _tmp7_;
#line 524 "panel.vala"
	layout_array_length1 = _vala_array_length (_tmp6_);
#line 524 "panel.vala"
	_layout_array_size_ = layout_array_length1;
#line 525 "panel.vala"
	_tmp8_ = variants;
#line 525 "panel.vala"
	_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ",", 0);
#line 525 "panel.vala"
	variant_array = _tmp10_;
#line 525 "panel.vala"
	variant_array_length1 = _vala_array_length (_tmp9_);
#line 525 "panel.vala"
	_variant_array_size_ = variant_array_length1;
#line 3163 "panel.c"
	{
		gint i = 0;
#line 527 "panel.vala"
		i = 0;
#line 3168 "panel.c"
		{
			gboolean _tmp11_ = FALSE;
#line 527 "panel.vala"
			_tmp11_ = TRUE;
#line 527 "panel.vala"
			while (TRUE) {
#line 3175 "panel.c"
				gchar** _tmp13_;
				gint _tmp13__length1;
				gchar* layout = NULL;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* variant = NULL;
				IBusEngineDesc* current_engine = NULL;
				gchar** _tmp17_;
				gint _tmp17__length1;
				const gchar* _tmp21_;
				IBusEngineDesc* _tmp36_;
#line 527 "panel.vala"
				if (!_tmp11_) {
#line 3191 "panel.c"
					gint _tmp12_;
#line 527 "panel.vala"
					_tmp12_ = i;
#line 527 "panel.vala"
					i = _tmp12_ + 1;
#line 3197 "panel.c"
				}
#line 527 "panel.vala"
				_tmp11_ = FALSE;
#line 527 "panel.vala"
				_tmp13_ = layout_array;
#line 527 "panel.vala"
				_tmp13__length1 = layout_array_length1;
#line 527 "panel.vala"
				if (!(i < _tmp13__length1)) {
#line 527 "panel.vala"
					break;
#line 3209 "panel.c"
				}
#line 528 "panel.vala"
				_tmp14_ = layout_array;
#line 528 "panel.vala"
				_tmp14__length1 = layout_array_length1;
#line 528 "panel.vala"
				_tmp15_ = _tmp14_[i];
#line 528 "panel.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 528 "panel.vala"
				layout = _tmp16_;
#line 529 "panel.vala"
				variant = NULL;
#line 530 "panel.vala"
				current_engine = NULL;
#line 532 "panel.vala"
				_tmp17_ = variant_array;
#line 532 "panel.vala"
				_tmp17__length1 = variant_array_length1;
#line 532 "panel.vala"
				if (i < _tmp17__length1) {
#line 3231 "panel.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 533 "panel.vala"
					_tmp18_ = variant_array;
#line 533 "panel.vala"
					_tmp18__length1 = variant_array_length1;
#line 533 "panel.vala"
					_tmp19_ = _tmp18_[i];
#line 533 "panel.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 533 "panel.vala"
					_g_free0 (variant);
#line 533 "panel.vala"
					variant = _tmp20_;
#line 3248 "panel.c"
				}
#line 539 "panel.vala"
				_tmp21_ = variant;
#line 539 "panel.vala"
				if (_tmp21_ == NULL) {
#line 3254 "panel.c"
					gchar* _tmp22_;
#line 540 "panel.vala"
					_tmp22_ = g_strdup ("");
#line 540 "panel.vala"
					_g_free0 (variant);
#line 540 "panel.vala"
					variant = _tmp22_;
#line 3262 "panel.c"
				}
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
#line 542 "panel.vala"
					engine_collection = engines;
#line 542 "panel.vala"
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3271 "panel.c"
						IBusEngineDesc* engine = NULL;
#line 542 "panel.vala"
						engine = (IBusEngineDesc*) engine_it->data;
#line 3275 "panel.c"
						{
							gchar* name = NULL;
							IBusEngineDesc* _tmp23_;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							const gchar* _tmp26_;
							gboolean _tmp27_ = FALSE;
							IBusEngineDesc* _tmp28_;
							const gchar* _tmp29_;
							const gchar* _tmp30_;
#line 544 "panel.vala"
							_tmp23_ = engine;
#line 544 "panel.vala"
							_tmp24_ = ibus_engine_desc_get_name (_tmp23_);
#line 544 "panel.vala"
							_tmp25_ = g_strdup (_tmp24_);
#line 544 "panel.vala"
							name = _tmp25_;
#line 545 "panel.vala"
							_tmp26_ = name;
#line 545 "panel.vala"
							if (!g_str_has_prefix (_tmp26_, "xkb:")) {
#line 546 "panel.vala"
								_g_free0 (name);
#line 546 "panel.vala"
								continue;
#line 3302 "panel.c"
							}
#line 548 "panel.vala"
							_tmp28_ = engine;
#line 548 "panel.vala"
							_tmp29_ = ibus_engine_desc_get_layout (_tmp28_);
#line 548 "panel.vala"
							_tmp30_ = layout;
#line 548 "panel.vala"
							if (g_strcmp0 (_tmp29_, _tmp30_) == 0) {
#line 3312 "panel.c"
								IBusEngineDesc* _tmp31_;
								const gchar* _tmp32_;
								const gchar* _tmp33_;
#line 549 "panel.vala"
								_tmp31_ = engine;
#line 549 "panel.vala"
								_tmp32_ = ibus_engine_desc_get_layout_variant (_tmp31_);
#line 549 "panel.vala"
								_tmp33_ = variant;
#line 549 "panel.vala"
								_tmp27_ = g_strcmp0 (_tmp32_, _tmp33_) == 0;
#line 3324 "panel.c"
							} else {
#line 548 "panel.vala"
								_tmp27_ = FALSE;
#line 3328 "panel.c"
							}
#line 548 "panel.vala"
							if (_tmp27_) {
#line 3332 "panel.c"
								IBusEngineDesc* _tmp34_;
								IBusEngineDesc* _tmp35_;
#line 550 "panel.vala"
								_tmp34_ = engine;
#line 550 "panel.vala"
								_tmp35_ = _g_object_ref0 (_tmp34_);
#line 550 "panel.vala"
								_g_object_unref0 (current_engine);
#line 550 "panel.vala"
								current_engine = _tmp35_;
#line 551 "panel.vala"
								_g_free0 (name);
#line 551 "panel.vala"
								break;
#line 3347 "panel.c"
							}
#line 542 "panel.vala"
							_g_free0 (name);
#line 3351 "panel.c"
						}
					}
				}
#line 555 "panel.vala"
				_tmp36_ = current_engine;
#line 555 "panel.vala"
				if (_tmp36_ != NULL) {
#line 3359 "panel.c"
					IBusEngineDesc* _tmp37_;
					IBusEngineDesc* _tmp38_;
#line 556 "panel.vala"
					_tmp37_ = current_engine;
#line 556 "panel.vala"
					_tmp38_ = _g_object_ref0 (_tmp37_);
#line 556 "panel.vala"
					xkb_engines = g_list_append (xkb_engines, _tmp38_);
#line 3368 "panel.c"
				} else {
					GList* _tmp39_;
					IBusEngineDesc* _tmp40_;
					GList* _tmp41_;
#line 557 "panel.vala"
					_tmp39_ = xkb_engines;
#line 557 "panel.vala"
					_tmp40_ = us_engine;
#line 557 "panel.vala"
					_tmp41_ = g_list_find (_tmp39_, _tmp40_);
#line 557 "panel.vala"
					if (_tmp41_ == NULL) {
#line 3381 "panel.c"
						const gchar* _tmp42_;
						const gchar* _tmp43_;
						IBusEngineDesc* _tmp44_;
						IBusEngineDesc* _tmp45_;
#line 558 "panel.vala"
						_tmp42_ = layout;
#line 558 "panel.vala"
						_tmp43_ = variant;
#line 558 "panel.vala"
						g_warning ("panel.vala:558: Fallback %s(%s) to us layout.", _tmp42_, _tmp43_);
#line 559 "panel.vala"
						_tmp44_ = us_engine;
#line 559 "panel.vala"
						_tmp45_ = _g_object_ref0 (_tmp44_);
#line 559 "panel.vala"
						xkb_engines = g_list_append (xkb_engines, _tmp45_);
#line 3398 "panel.c"
					}
				}
#line 527 "panel.vala"
				_g_object_unref0 (current_engine);
#line 527 "panel.vala"
				_g_free0 (variant);
#line 527 "panel.vala"
				_g_free0 (layout);
#line 3407 "panel.c"
			}
		}
	}
#line 563 "panel.vala"
	_tmp46_ = xkb_engines;
#line 563 "panel.vala"
	if (g_list_length (_tmp46_) == ((guint) 0)) {
#line 564 "panel.vala"
		g_warning ("panel.vala:564: Not found IBus XKB engines from the session.");
#line 3417 "panel.c"
	}
#line 566 "panel.vala"
	result = xkb_engines;
#line 566 "panel.vala"
	variant_array = (_vala_array_free (variant_array, variant_array_length1, (GDestroyNotify) g_free), NULL);
#line 566 "panel.vala"
	layout_array = (_vala_array_free (layout_array, layout_array_length1, (GDestroyNotify) g_free), NULL);
#line 566 "panel.vala"
	_g_object_unref0 (us_engine);
#line 566 "panel.vala"
	_g_free0 (option);
#line 566 "panel.vala"
	_g_free0 (variants);
#line 566 "panel.vala"
	_g_free0 (layouts);
#line 566 "panel.vala"
	return result;
#line 3435 "panel.c"
}

/**
     * panel_get_engines_from_locale:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus im engines
     *
     * Made ibus engines from the current locale and IBus.EngineDesc.lang .
     * This returns non-XKB engines whose name does not start "xkb:".
     */
static gint
__lambda104_ (IBusEngineDesc* a,
              IBusEngineDesc* b)
{
	gint result;
#line 618 "panel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 618 "panel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 619 "panel.vala"
	result = ((gint) ibus_engine_desc_get_rank (b)) - ((gint) ibus_engine_desc_get_rank (a));
#line 619 "panel.vala"
	return result;
#line 3460 "panel.c"
}

static gint
___lambda104__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = __lambda104_ ((IBusEngineDesc*) a, (IBusEngineDesc*) b);
#line 618 "panel.vala"
	return result;
#line 3471 "panel.c"
}

static GList*
panel_get_engines_from_locale (Panel* self,
                               GList* engines)
{
	gchar* locale = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* lang = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GList* im_engines = NULL;
	GList* _tmp22_;
	GList* _tmp40_;
	GList* result;
#line 578 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 580 "panel.vala"
	_tmp0_ = setlocale (LC_CTYPE, NULL);
#line 580 "panel.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 580 "panel.vala"
	locale = _tmp1_;
#line 582 "panel.vala"
	_tmp2_ = locale;
#line 582 "panel.vala"
	if (_tmp2_ == NULL) {
#line 3507 "panel.c"
		gchar* _tmp3_;
#line 583 "panel.vala"
		_tmp3_ = g_strdup ("C");
#line 583 "panel.vala"
		_g_free0 (locale);
#line 583 "panel.vala"
		locale = _tmp3_;
#line 3515 "panel.c"
	}
#line 585 "panel.vala"
	_tmp4_ = locale;
#line 585 "panel.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ".", 0);
#line 585 "panel.vala"
	_tmp7_ = _tmp6_;
#line 585 "panel.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 585 "panel.vala"
	_tmp8_ = _tmp7_[0];
#line 585 "panel.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 585 "panel.vala"
	_tmp10_ = _tmp9_;
#line 585 "panel.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 585 "panel.vala"
	lang = _tmp10_;
#line 586 "panel.vala"
	im_engines = NULL;
#line 3537 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 589 "panel.vala"
		engine_collection = engines;
#line 589 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3545 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 589 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3549 "panel.c"
			{
				gchar* name = NULL;
				IBusEngineDesc* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				gboolean _tmp15_ = FALSE;
				IBusEngineDesc* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 590 "panel.vala"
				_tmp11_ = engine;
#line 590 "panel.vala"
				_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
#line 590 "panel.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 590 "panel.vala"
				name = _tmp13_;
#line 592 "panel.vala"
				_tmp14_ = name;
#line 592 "panel.vala"
				if (g_str_has_prefix (_tmp14_, "xkb:")) {
#line 593 "panel.vala"
					_g_free0 (name);
#line 593 "panel.vala"
					continue;
#line 3576 "panel.c"
				}
#line 595 "panel.vala"
				_tmp16_ = engine;
#line 595 "panel.vala"
				_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
#line 595 "panel.vala"
				_tmp18_ = lang;
#line 595 "panel.vala"
				if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 3586 "panel.c"
					IBusEngineDesc* _tmp19_;
#line 596 "panel.vala"
					_tmp19_ = engine;
#line 596 "panel.vala"
					_tmp15_ = ibus_engine_desc_get_rank (_tmp19_) > ((guint) 0);
#line 3592 "panel.c"
				} else {
#line 595 "panel.vala"
					_tmp15_ = FALSE;
#line 3596 "panel.c"
				}
#line 595 "panel.vala"
				if (_tmp15_) {
#line 3600 "panel.c"
					IBusEngineDesc* _tmp20_;
					IBusEngineDesc* _tmp21_;
#line 597 "panel.vala"
					_tmp20_ = engine;
#line 597 "panel.vala"
					_tmp21_ = _g_object_ref0 (_tmp20_);
#line 597 "panel.vala"
					im_engines = g_list_append (im_engines, _tmp21_);
#line 3609 "panel.c"
				}
#line 589 "panel.vala"
				_g_free0 (name);
#line 3613 "panel.c"
			}
		}
	}
#line 600 "panel.vala"
	_tmp22_ = im_engines;
#line 600 "panel.vala"
	if (g_list_length (_tmp22_) == ((guint) 0)) {
#line 3621 "panel.c"
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 601 "panel.vala"
		_tmp23_ = lang;
#line 601 "panel.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "_", 0);
#line 601 "panel.vala"
		_tmp26_ = _tmp25_;
#line 601 "panel.vala"
		_tmp26__length1 = _vala_array_length (_tmp24_);
#line 601 "panel.vala"
		_tmp27_ = _tmp26_[0];
#line 601 "panel.vala"
		_tmp28_ = g_strdup (_tmp27_);
#line 601 "panel.vala"
		_g_free0 (lang);
#line 601 "panel.vala"
		lang = _tmp28_;
#line 601 "panel.vala"
		_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 3647 "panel.c"
		{
			GList* engine_collection = NULL;
			GList* engine_it = NULL;
#line 603 "panel.vala"
			engine_collection = engines;
#line 603 "panel.vala"
			for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3655 "panel.c"
				IBusEngineDesc* engine = NULL;
#line 603 "panel.vala"
				engine = (IBusEngineDesc*) engine_it->data;
#line 3659 "panel.c"
				{
					gchar* name = NULL;
					IBusEngineDesc* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean _tmp33_ = FALSE;
					IBusEngineDesc* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
#line 604 "panel.vala"
					_tmp29_ = engine;
#line 604 "panel.vala"
					_tmp30_ = ibus_engine_desc_get_name (_tmp29_);
#line 604 "panel.vala"
					_tmp31_ = g_strdup (_tmp30_);
#line 604 "panel.vala"
					name = _tmp31_;
#line 606 "panel.vala"
					_tmp32_ = name;
#line 606 "panel.vala"
					if (g_str_has_prefix (_tmp32_, "xkb:")) {
#line 607 "panel.vala"
						_g_free0 (name);
#line 607 "panel.vala"
						continue;
#line 3686 "panel.c"
					}
#line 609 "panel.vala"
					_tmp34_ = engine;
#line 609 "panel.vala"
					_tmp35_ = ibus_engine_desc_get_language (_tmp34_);
#line 609 "panel.vala"
					_tmp36_ = lang;
#line 609 "panel.vala"
					if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 3696 "panel.c"
						IBusEngineDesc* _tmp37_;
#line 610 "panel.vala"
						_tmp37_ = engine;
#line 610 "panel.vala"
						_tmp33_ = ibus_engine_desc_get_rank (_tmp37_) > ((guint) 0);
#line 3702 "panel.c"
					} else {
#line 609 "panel.vala"
						_tmp33_ = FALSE;
#line 3706 "panel.c"
					}
#line 609 "panel.vala"
					if (_tmp33_) {
#line 3710 "panel.c"
						IBusEngineDesc* _tmp38_;
						IBusEngineDesc* _tmp39_;
#line 611 "panel.vala"
						_tmp38_ = engine;
#line 611 "panel.vala"
						_tmp39_ = _g_object_ref0 (_tmp38_);
#line 611 "panel.vala"
						im_engines = g_list_append (im_engines, _tmp39_);
#line 3719 "panel.c"
					}
#line 603 "panel.vala"
					_g_free0 (name);
#line 3723 "panel.c"
				}
			}
		}
	}
#line 615 "panel.vala"
	_tmp40_ = im_engines;
#line 615 "panel.vala"
	if (g_list_length (_tmp40_) == ((guint) 0)) {
#line 616 "panel.vala"
		result = im_engines;
#line 616 "panel.vala"
		_g_free0 (lang);
#line 616 "panel.vala"
		_g_free0 (locale);
#line 616 "panel.vala"
		return result;
#line 3740 "panel.c"
	}
#line 618 "panel.vala"
	im_engines = g_list_sort (im_engines, ___lambda104__gcompare_func);
#line 622 "panel.vala"
	result = im_engines;
#line 622 "panel.vala"
	_g_free0 (lang);
#line 622 "panel.vala"
	_g_free0 (locale);
#line 622 "panel.vala"
	return result;
#line 3752 "panel.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 642 "panel.vala"
	if ((*length) == (*size)) {
#line 642 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 642 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3767 "panel.c"
	}
#line 642 "panel.vala"
	(*array)[(*length)++] = value;
#line 642 "panel.vala"
	(*array)[*length] = NULL;
#line 3773 "panel.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 644 "panel.vala"
	if ((*length) == (*size)) {
#line 644 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 644 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3788 "panel.c"
	}
#line 644 "panel.vala"
	(*array)[(*length)++] = value;
#line 644 "panel.vala"
	(*array)[*length] = NULL;
#line 3794 "panel.c"
}

static void
panel_init_engines_order (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_;
	GList* engines = NULL;
	IBusBus* _tmp10_;
	GList* _tmp11_;
	GList* xkb_engines = NULL;
	GList* _tmp12_;
	GList* _tmp13_;
	GList* im_engines = NULL;
	GList* _tmp14_;
	GList* _tmp15_;
	gchar** names = NULL;
	gchar** _tmp16_;
	gint names_length1;
	gint _names_size_;
	GList* _tmp17_;
	GList* _tmp21_;
	GSettings* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
#line 625 "panel.vala"
	g_return_if_fail (self != NULL);
#line 626 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 626 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 626 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "xkb-latin-layouts");
#line 626 "panel.vala"
	_tmp4_ = _tmp3_;
#line 626 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 626 "panel.vala"
	xkb_layout_set_latin_layouts (_tmp0_, _tmp4_, (gint) _vala_array_length (_tmp2_));
#line 626 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 629 "panel.vala"
	if (self->priv->inited_engines_order) {
#line 630 "panel.vala"
		return;
#line 3850 "panel.c"
	}
#line 632 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 632 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "preload-engines");
#line 632 "panel.vala"
	_tmp8_ = _tmp7_;
#line 632 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 632 "panel.vala"
	_tmp9_ = _vala_array_length (_tmp6_) > 0;
#line 632 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 632 "panel.vala"
	if (_tmp9_) {
#line 633 "panel.vala"
		return;
#line 3868 "panel.c"
	}
#line 635 "panel.vala"
	_tmp10_ = self->priv->m_bus;
#line 635 "panel.vala"
	_tmp11_ = ibus_bus_list_engines (_tmp10_);
#line 635 "panel.vala"
	engines = _tmp11_;
#line 636 "panel.vala"
	_tmp12_ = engines;
#line 636 "panel.vala"
	_tmp13_ = panel_get_engines_from_xkb (self, _tmp12_);
#line 636 "panel.vala"
	xkb_engines = _tmp13_;
#line 637 "panel.vala"
	_tmp14_ = engines;
#line 637 "panel.vala"
	_tmp15_ = panel_get_engines_from_locale (self, _tmp14_);
#line 637 "panel.vala"
	im_engines = _tmp15_;
#line 640 "panel.vala"
	_tmp16_ = g_new0 (gchar*, 0 + 1);
#line 640 "panel.vala"
	names = _tmp16_;
#line 640 "panel.vala"
	names_length1 = 0;
#line 640 "panel.vala"
	_names_size_ = names_length1;
#line 641 "panel.vala"
	_tmp17_ = xkb_engines;
#line 3898 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 641 "panel.vala"
		engine_collection = _tmp17_;
#line 641 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3906 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 641 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3910 "panel.c"
			{
				IBusEngineDesc* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
#line 642 "panel.vala"
				_tmp18_ = engine;
#line 642 "panel.vala"
				_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 642 "panel.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 642 "panel.vala"
				_vala_array_add20 (&names, &names_length1, &_names_size_, _tmp20_);
#line 3923 "panel.c"
			}
		}
	}
#line 643 "panel.vala"
	_tmp21_ = im_engines;
#line 3929 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 643 "panel.vala"
		engine_collection = _tmp21_;
#line 643 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3937 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 643 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3941 "panel.c"
			{
				IBusEngineDesc* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 644 "panel.vala"
				_tmp22_ = engine;
#line 644 "panel.vala"
				_tmp23_ = ibus_engine_desc_get_name (_tmp22_);
#line 644 "panel.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 644 "panel.vala"
				_vala_array_add21 (&names, &names_length1, &_names_size_, _tmp24_);
#line 3954 "panel.c"
			}
		}
	}
#line 646 "panel.vala"
	_tmp25_ = self->priv->m_settings_general;
#line 646 "panel.vala"
	_tmp26_ = names;
#line 646 "panel.vala"
	_tmp26__length1 = names_length1;
#line 646 "panel.vala"
	g_settings_set_strv (_tmp25_, "preload-engines", _tmp26_);
#line 625 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 625 "panel.vala"
	(im_engines == NULL) ? NULL : (im_engines = (_g_list_free__g_object_unref0_ (im_engines), NULL));
#line 625 "panel.vala"
	(xkb_engines == NULL) ? NULL : (xkb_engines = (_g_list_free__g_object_unref0_ (xkb_engines), NULL));
#line 625 "panel.vala"
	(engines == NULL) ? NULL : (engines = (_g_list_free__g_object_unref0_ (engines), NULL));
#line 3974 "panel.c"
}

static void
panel_set_switcher_delay_time (Panel* self)
{
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Switcher* _tmp2_;
#line 650 "panel.vala"
	g_return_if_fail (self != NULL);
#line 651 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 651 "panel.vala"
	self->priv->m_switcher_delay_time = g_settings_get_int (_tmp0_, "switcher-delay-time");
#line 654 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 654 "panel.vala"
	if (_tmp2_ != NULL) {
#line 654 "panel.vala"
		_tmp1_ = self->priv->m_switcher_delay_time >= 0;
#line 3995 "panel.c"
	} else {
#line 654 "panel.vala"
		_tmp1_ = FALSE;
#line 3999 "panel.c"
	}
#line 654 "panel.vala"
	if (_tmp1_) {
#line 4003 "panel.c"
		Switcher* _tmp3_;
#line 655 "panel.vala"
		_tmp3_ = self->priv->m_switcher;
#line 655 "panel.vala"
		switcher_set_popup_delay_time (_tmp3_, (guint) self->priv->m_switcher_delay_time);
#line 4009 "panel.c"
	}
}

static void
panel_set_use_system_keyboard_layout (Panel* self)
{
	GSettings* _tmp0_;
#line 659 "panel.vala"
	g_return_if_fail (self != NULL);
#line 660 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 660 "panel.vala"
	self->priv->m_use_system_keyboard_layout = g_settings_get_boolean (_tmp0_, "use-system-keyboard-layout");
#line 4023 "panel.c"
}

static void
panel_set_embed_preedit_text (Panel* self)
{
	GVariant* variant = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	IBusBus* _tmp3_;
	GVariant* _tmp4_;
#line 664 "panel.vala"
	g_return_if_fail (self != NULL);
#line 665 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 665 "panel.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "embed-preedit-text");
#line 665 "panel.vala"
	variant = _tmp1_;
#line 668 "panel.vala"
	_tmp2_ = variant;
#line 668 "panel.vala"
	if (_tmp2_ == NULL) {
#line 669 "panel.vala"
		_g_variant_unref0 (variant);
#line 669 "panel.vala"
		return;
#line 4051 "panel.c"
	}
#line 672 "panel.vala"
	_tmp3_ = self->priv->m_bus;
#line 672 "panel.vala"
	_tmp4_ = variant;
#line 672 "panel.vala"
	ibus_bus_set_ibus_property (_tmp3_, "EmbedPreeditText", _tmp4_);
#line 664 "panel.vala"
	_g_variant_unref0 (variant);
#line 4061 "panel.c"
}

static void
panel_set_use_global_engine (Panel* self)
{
	GSettings* _tmp0_;
#line 675 "panel.vala"
	g_return_if_fail (self != NULL);
#line 676 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 676 "panel.vala"
	self->priv->m_use_global_engine = g_settings_get_boolean (_tmp0_, "use-global-engine");
#line 4074 "panel.c"
}

static void
panel_set_use_xmodmap (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
#line 680 "panel.vala"
	g_return_if_fail (self != NULL);
#line 681 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 681 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 681 "panel.vala"
	xkb_layout_set_use_xmodmap (_tmp0_, g_settings_get_boolean (_tmp1_, "use-xmodmap"));
#line 4090 "panel.c"
}

static void
panel_set_show_icon_on_systray (Panel* self,
                                gboolean update_now)
{
#line 685 "panel.vala"
	g_return_if_fail (self != NULL);
#line 686 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4101 "panel.c"
		GtkStatusIcon* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GSettings* _tmp2_;
#line 687 "panel.vala"
		_tmp0_ = self->priv->m_status_icon;
#line 687 "panel.vala"
		if (_tmp0_ == NULL) {
#line 688 "panel.vala"
			return;
#line 4111 "panel.c"
		}
#line 691 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 691 "panel.vala"
		_tmp2_ = self->priv->m_settings_panel;
#line 691 "panel.vala"
		gtk_status_icon_set_visible (_tmp1_, g_settings_get_boolean (_tmp2_, "show-icon-on-systray"));
#line 4119 "panel.c"
	} else {
#line 695 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4123 "panel.c"
			Indicator* _tmp3_;
			GSettings* _tmp4_;
#line 696 "panel.vala"
			_tmp3_ = self->priv->m_indicator;
#line 696 "panel.vala"
			if (_tmp3_ == NULL) {
#line 697 "panel.vala"
				return;
#line 4132 "panel.c"
			}
#line 699 "panel.vala"
			_tmp4_ = self->priv->m_settings_panel;
#line 699 "panel.vala"
			if (g_settings_get_boolean (_tmp4_, "show-icon-on-systray")) {
#line 700 "panel.vala"
				self->priv->m_indicator_show_status = INDICATOR_STATUS_ACTIVE;
#line 4140 "panel.c"
			} else {
#line 702 "panel.vala"
				self->priv->m_indicator_show_status = INDICATOR_STATUS_PASSIVE;
#line 4144 "panel.c"
			}
#line 706 "panel.vala"
			if (update_now) {
#line 4148 "panel.c"
				Indicator* _tmp5_;
#line 707 "panel.vala"
				_tmp5_ = self->priv->m_indicator;
#line 707 "panel.vala"
				indicator_set_status (_tmp5_, self->priv->m_indicator_show_status);
#line 4154 "panel.c"
			}
		}
	}
}

static void
panel_set_lookup_table_orientation (Panel* self)
{
	CandidatePanel* _tmp0_;
	CandidatePanel* _tmp1_;
	GSettings* _tmp2_;
#line 712 "panel.vala"
	g_return_if_fail (self != NULL);
#line 713 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 713 "panel.vala"
	if (_tmp0_ == NULL) {
#line 714 "panel.vala"
		return;
#line 4174 "panel.c"
	}
#line 716 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 716 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 716 "panel.vala"
	candidate_panel_set_vertical (_tmp1_, g_settings_get_int (_tmp2_, "lookup-table-orientation") == ((gint) IBUS_ORIENTATION_VERTICAL));
#line 4182 "panel.c"
}

static void
panel_set_show_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 721 "panel.vala"
	g_return_if_fail (self != NULL);
#line 722 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 722 "panel.vala"
	if (_tmp0_ == NULL) {
#line 723 "panel.vala"
		return;
#line 4199 "panel.c"
	}
#line 725 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 725 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 725 "panel.vala"
	property_panel_set_show (_tmp1_, g_settings_get_int (_tmp2_, "show"));
#line 4207 "panel.c"
}

static void
panel_set_timeout_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 728 "panel.vala"
	g_return_if_fail (self != NULL);
#line 729 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 729 "panel.vala"
	if (_tmp0_ == NULL) {
#line 730 "panel.vala"
		return;
#line 4224 "panel.c"
	}
#line 732 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 732 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 732 "panel.vala"
	property_panel_set_auto_hide_timeout (_tmp1_, (guint) g_settings_get_int (_tmp2_, "auto-hide-timeout"));
#line 4232 "panel.c"
}

static void
panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 736 "panel.vala"
	g_return_if_fail (self != NULL);
#line 737 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 737 "panel.vala"
	if (_tmp0_ == NULL) {
#line 738 "panel.vala"
		return;
#line 4249 "panel.c"
	}
#line 740 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 740 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 740 "panel.vala"
	property_panel_set_follow_input_cursor_when_always_shown (_tmp1_, g_settings_get_boolean (_tmp2_, "follow-input-cursor-when-always-shown"));
#line 4257 "panel.c"
}

static void
panel_set_xkb_icon_rgba (Panel* self)
{
	gchar* spec = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp2_ = {0};
	const gchar* _tmp3_;
#line 745 "panel.vala"
	g_return_if_fail (self != NULL);
#line 746 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 746 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "xkb-icon-rgba");
#line 746 "panel.vala"
	spec = _tmp1_;
#line 748 "panel.vala"
	_tmp2_.red = (gdouble) 0;
#line 748 "panel.vala"
	rgba = _tmp2_;
#line 750 "panel.vala"
	_tmp3_ = spec;
#line 750 "panel.vala"
	if (!gdk_rgba_parse (&rgba, _tmp3_)) {
#line 4285 "panel.c"
		const gchar* _tmp4_;
		GdkRGBA _tmp5_ = {0};
#line 751 "panel.vala"
		_tmp4_ = spec;
#line 751 "panel.vala"
		g_warning ("panel.vala:751: invalid format of xkb-icon-rgba: %s", _tmp4_);
#line 752 "panel.vala"
		memset (&_tmp5_, 0, sizeof (GdkRGBA));
#line 752 "panel.vala"
		_tmp5_.red = 0.0;
#line 752 "panel.vala"
		_tmp5_.green = 0.0;
#line 752 "panel.vala"
		_tmp5_.blue = 0.0;
#line 752 "panel.vala"
		_tmp5_.alpha = 1.0;
#line 752 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp5_;
#line 4304 "panel.c"
	} else {
		GdkRGBA _tmp6_;
#line 755 "panel.vala"
		_tmp6_ = rgba;
#line 755 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp6_;
#line 4311 "panel.c"
	}
#line 757 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4315 "panel.c"
		GHashTable* _tmp7_;
#line 758 "panel.vala"
		_tmp7_ = self->priv->m_xkb_icon_pixbufs;
#line 758 "panel.vala"
		if (g_hash_table_size (_tmp7_) > ((guint) 0)) {
#line 4321 "panel.c"
			GHashTable* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GtkStatusIcon* _tmp10_;
#line 759 "panel.vala"
			_tmp8_ = self->priv->m_xkb_icon_pixbufs;
#line 759 "panel.vala"
			g_hash_table_remove_all (_tmp8_);
#line 761 "panel.vala"
			_tmp10_ = self->priv->m_status_icon;
#line 761 "panel.vala"
			if (_tmp10_ != NULL) {
#line 4333 "panel.c"
				Switcher* _tmp11_;
#line 761 "panel.vala"
				_tmp11_ = self->priv->m_switcher;
#line 761 "panel.vala"
				_tmp9_ = _tmp11_ != NULL;
#line 4339 "panel.c"
			} else {
#line 761 "panel.vala"
				_tmp9_ = FALSE;
#line 4343 "panel.c"
			}
#line 761 "panel.vala"
			if (_tmp9_) {
#line 762 "panel.vala"
				g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4349 "panel.c"
			}
		}
	} else {
#line 766 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4355 "panel.c"
			GHashTable* _tmp12_;
#line 767 "panel.vala"
			_tmp12_ = self->priv->m_xkb_icon_image;
#line 767 "panel.vala"
			if (g_hash_table_size (_tmp12_) > ((guint) 0)) {
#line 4361 "panel.c"
				GHashTable* _tmp13_;
				gboolean _tmp14_ = FALSE;
				Indicator* _tmp15_;
#line 768 "panel.vala"
				_tmp13_ = self->priv->m_xkb_icon_image;
#line 768 "panel.vala"
				g_hash_table_remove_all (_tmp13_);
#line 770 "panel.vala"
				_tmp15_ = self->priv->m_indicator;
#line 770 "panel.vala"
				if (_tmp15_ != NULL) {
#line 4373 "panel.c"
					Switcher* _tmp16_;
#line 770 "panel.vala"
					_tmp16_ = self->priv->m_switcher;
#line 770 "panel.vala"
					_tmp14_ = _tmp16_ != NULL;
#line 4379 "panel.c"
				} else {
#line 770 "panel.vala"
					_tmp14_ = FALSE;
#line 4383 "panel.c"
				}
#line 770 "panel.vala"
				if (_tmp14_) {
#line 771 "panel.vala"
					g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4389 "panel.c"
				}
			}
		}
	}
#line 745 "panel.vala"
	_g_free0 (spec);
#line 4396 "panel.c"
}

static void
panel_set_property_icon_delay_time (Panel* self)
{
	GSettings* _tmp0_;
#line 777 "panel.vala"
	g_return_if_fail (self != NULL);
#line 778 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 778 "panel.vala"
	self->priv->m_property_icon_delay_time = g_settings_get_int (_tmp0_, "property-icon-delay-time");
#line 4409 "panel.c"
}

static gint
panel_compare_versions (Panel* self,
                        const gchar* version1,
                        const gchar* version2)
{
	gchar** version1_list = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint version1_list_length1;
	gint _version1_list_size_;
	gchar** version2_list = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint version2_list_length1;
	gint _version2_list_size_;
	gint major1 = 0;
	gint minor1 = 0;
	gint micro1 = 0;
	gint major2 = 0;
	gint minor2 = 0;
	gint micro2 = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gint result;
#line 783 "panel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 783 "panel.vala"
	g_return_val_if_fail (version1 != NULL, 0);
#line 783 "panel.vala"
	g_return_val_if_fail (version2 != NULL, 0);
#line 784 "panel.vala"
	_tmp1_ = _tmp0_ = g_strsplit (version1, ".", 0);
#line 784 "panel.vala"
	version1_list = _tmp1_;
#line 784 "panel.vala"
	version1_list_length1 = _vala_array_length (_tmp0_);
#line 784 "panel.vala"
	_version1_list_size_ = version1_list_length1;
#line 785 "panel.vala"
	_tmp3_ = _tmp2_ = g_strsplit (version2, ".", 0);
#line 785 "panel.vala"
	version2_list = _tmp3_;
#line 785 "panel.vala"
	version2_list_length1 = _vala_array_length (_tmp2_);
#line 785 "panel.vala"
	_version2_list_size_ = version2_list_length1;
#line 788 "panel.vala"
	if (g_strcmp0 (version1, version2) == 0) {
#line 789 "panel.vala"
		result = 0;
#line 789 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 789 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 789 "panel.vala"
		return result;
#line 4492 "panel.c"
	}
#line 793 "panel.vala"
	if (g_strcmp0 (version1, "") == 0) {
#line 794 "panel.vala"
		result = -1;
#line 794 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 794 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 794 "panel.vala"
		return result;
#line 4504 "panel.c"
	}
#line 796 "panel.vala"
	if (g_strcmp0 (version2, "") == 0) {
#line 797 "panel.vala"
		result = 1;
#line 797 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 797 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 797 "panel.vala"
		return result;
#line 4516 "panel.c"
	}
#line 800 "panel.vala"
	_tmp4_ = version1_list;
#line 800 "panel.vala"
	_tmp4__length1 = version1_list_length1;
#line 800 "panel.vala"
	_vala_assert (_tmp4__length1 >= 3, "version1_list.length >= 3");
#line 801 "panel.vala"
	_tmp5_ = version2_list;
#line 801 "panel.vala"
	_tmp5__length1 = version2_list_length1;
#line 801 "panel.vala"
	_vala_assert (_tmp5__length1 >= 3, "version2_list.length >= 3");
#line 803 "panel.vala"
	_tmp6_ = version1_list;
#line 803 "panel.vala"
	_tmp6__length1 = version1_list_length1;
#line 803 "panel.vala"
	_tmp7_ = _tmp6_[0];
#line 803 "panel.vala"
	major1 = atoi (_tmp7_);
#line 804 "panel.vala"
	_tmp8_ = version1_list;
#line 804 "panel.vala"
	_tmp8__length1 = version1_list_length1;
#line 804 "panel.vala"
	_tmp9_ = _tmp8_[1];
#line 804 "panel.vala"
	minor1 = atoi (_tmp9_);
#line 805 "panel.vala"
	_tmp10_ = version1_list;
#line 805 "panel.vala"
	_tmp10__length1 = version1_list_length1;
#line 805 "panel.vala"
	_tmp11_ = _tmp10_[2];
#line 805 "panel.vala"
	micro1 = atoi (_tmp11_);
#line 807 "panel.vala"
	_tmp12_ = version2_list;
#line 807 "panel.vala"
	_tmp12__length1 = version2_list_length1;
#line 807 "panel.vala"
	_tmp13_ = _tmp12_[0];
#line 807 "panel.vala"
	major2 = atoi (_tmp13_);
#line 808 "panel.vala"
	_tmp14_ = version2_list;
#line 808 "panel.vala"
	_tmp14__length1 = version2_list_length1;
#line 808 "panel.vala"
	_tmp15_ = _tmp14_[1];
#line 808 "panel.vala"
	minor2 = atoi (_tmp15_);
#line 809 "panel.vala"
	_tmp16_ = version2_list;
#line 809 "panel.vala"
	_tmp16__length1 = version2_list_length1;
#line 809 "panel.vala"
	_tmp17_ = _tmp16_[2];
#line 809 "panel.vala"
	micro2 = atoi (_tmp17_);
#line 811 "panel.vala"
	if (major1 == minor1) {
#line 811 "panel.vala"
		_tmp19_ = minor1 == minor2;
#line 4582 "panel.c"
	} else {
#line 811 "panel.vala"
		_tmp19_ = FALSE;
#line 4586 "panel.c"
	}
#line 811 "panel.vala"
	if (_tmp19_) {
#line 811 "panel.vala"
		_tmp18_ = micro1 == micro2;
#line 4592 "panel.c"
	} else {
#line 811 "panel.vala"
		_tmp18_ = FALSE;
#line 4596 "panel.c"
	}
#line 811 "panel.vala"
	if (_tmp18_) {
#line 812 "panel.vala"
		result = 0;
#line 812 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 812 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 812 "panel.vala"
		return result;
#line 4608 "panel.c"
	}
#line 814 "panel.vala"
	if (major1 > major2) {
#line 814 "panel.vala"
		_tmp21_ = TRUE;
#line 4614 "panel.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 815 "panel.vala"
		if (major1 == major2) {
#line 815 "panel.vala"
			_tmp22_ = minor1 > minor2;
#line 4621 "panel.c"
		} else {
#line 815 "panel.vala"
			_tmp22_ = FALSE;
#line 4625 "panel.c"
		}
#line 815 "panel.vala"
		_tmp21_ = _tmp22_;
#line 4629 "panel.c"
	}
#line 814 "panel.vala"
	if (_tmp21_) {
#line 814 "panel.vala"
		_tmp20_ = TRUE;
#line 4635 "panel.c"
	} else {
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
#line 816 "panel.vala"
		if (major1 == major2) {
#line 816 "panel.vala"
			_tmp24_ = minor1 == minor2;
#line 4643 "panel.c"
		} else {
#line 816 "panel.vala"
			_tmp24_ = FALSE;
#line 4647 "panel.c"
		}
#line 816 "panel.vala"
		if (_tmp24_) {
#line 817 "panel.vala"
			_tmp23_ = micro1 > micro2;
#line 4653 "panel.c"
		} else {
#line 816 "panel.vala"
			_tmp23_ = FALSE;
#line 4657 "panel.c"
		}
#line 816 "panel.vala"
		_tmp20_ = _tmp23_;
#line 4661 "panel.c"
	}
#line 814 "panel.vala"
	if (_tmp20_) {
#line 818 "panel.vala"
		result = 1;
#line 818 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 818 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 818 "panel.vala"
		return result;
#line 4673 "panel.c"
	}
#line 820 "panel.vala"
	result = -1;
#line 820 "panel.vala"
	version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 820 "panel.vala"
	version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 820 "panel.vala"
	return result;
#line 4683 "panel.c"
}

static void
panel_update_version_1_5_8 (Panel* self)
{
#line 824 "panel.vala"
	g_return_if_fail (self != NULL);
#line 825 "panel.vala"
	self->priv->inited_engines_order = FALSE;
#line 4693 "panel.c"
}

static void
panel_set_version (Panel* self)
{
	gchar* prev_version = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* current_version = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
#line 829 "panel.vala"
	g_return_if_fail (self != NULL);
#line 830 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 830 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "version");
#line 830 "panel.vala"
	prev_version = _tmp1_;
#line 831 "panel.vala"
	current_version = NULL;
#line 833 "panel.vala"
	_tmp2_ = prev_version;
#line 833 "panel.vala"
	if (panel_compare_versions (self, _tmp2_, "1.5.8") < 0) {
#line 834 "panel.vala"
		panel_update_version_1_5_8 (self);
#line 4725 "panel.c"
	}
#line 836 "panel.vala"
	_tmp3_ = g_strdup_printf ("%d.%d.%d", IBUS_MAJOR_VERSION, IBUS_MINOR_VERSION, IBUS_MICRO_VERSION);
#line 836 "panel.vala"
	_g_free0 (current_version);
#line 836 "panel.vala"
	current_version = _tmp3_;
#line 840 "panel.vala"
	_tmp4_ = prev_version;
#line 840 "panel.vala"
	_tmp5_ = current_version;
#line 840 "panel.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 841 "panel.vala"
		_g_free0 (current_version);
#line 841 "panel.vala"
		_g_free0 (prev_version);
#line 841 "panel.vala"
		return;
#line 4745 "panel.c"
	}
#line 844 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 844 "panel.vala"
	_tmp7_ = current_version;
#line 844 "panel.vala"
	g_settings_set_string (_tmp6_, "version", _tmp7_);
#line 829 "panel.vala"
	_g_free0 (current_version);
#line 829 "panel.vala"
	_g_free0 (prev_version);
#line 4757 "panel.c"
}

static void
panel_check_wayland (Panel* self)
{
	gchar* message = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp19_;
	NotifyNotification* notification = NULL;
	const gchar* _tmp20_;
	NotifyNotification* _tmp21_;
	NotifyNotification* _tmp22_;
	NotifyNotification* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 848 "panel.vala"
	g_return_if_fail (self != NULL);
#line 849 "panel.vala"
	message = NULL;
#line 850 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 850 "panel.vala"
		_tmp1_ = !self->priv->m_is_wayland_im;
#line 4782 "panel.c"
	} else {
#line 850 "panel.vala"
		_tmp1_ = FALSE;
#line 4786 "panel.c"
	}
#line 850 "panel.vala"
	if (_tmp1_) {
#line 850 "panel.vala"
		_tmp0_ = !panel_is_gnome ();
#line 4792 "panel.c"
	} else {
#line 850 "panel.vala"
		_tmp0_ = FALSE;
#line 4796 "panel.c"
	}
#line 850 "panel.vala"
	if (_tmp0_) {
#line 4800 "panel.c"
		gchar* format = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 851 "panel.vala"
		_tmp2_ = g_strdup (_ ("IBus should be called from the desktop session in " "%s. For KDE, you can launch '%s' " "utility and go to \"Input Devices\" -> " "\"Virtual Keyboard\" section and select " "\"%s\" icon and click \"Apply\" button to " "configure IBus in %s. For other desktop " "sessions, you can copy the 'Exec=' line in %s file " "to a configuration file of the session. " "Please refer each document about the \"Wayland " "input method\" configuration. Before you configure " "the \"Wayland input method\", you should make sure " "that QT_IM_MODULE and GTK_IM_MODULE environment " "variables are unset in the desktop session."));
#line 851 "panel.vala"
		format = _tmp2_;
#line 865 "panel.vala"
		_tmp3_ = format;
#line 865 "panel.vala"
		_tmp4_ = g_strdup_printf (_tmp3_, "Wayland", "systemsettings5", "IBus Wayland", "Wayland", "org.freedesktop.IBus.Panel.Wayland.Gtk3.desktop");
#line 865 "panel.vala"
		_g_free0 (message);
#line 865 "panel.vala"
		message = _tmp4_;
#line 850 "panel.vala"
		_g_free0 (format);
#line 4819 "panel.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 871 "panel.vala"
		if (self->priv->m_is_wayland) {
#line 871 "panel.vala"
			_tmp6_ = self->priv->m_is_wayland_im;
#line 4827 "panel.c"
		} else {
#line 871 "panel.vala"
			_tmp6_ = FALSE;
#line 4831 "panel.c"
		}
#line 871 "panel.vala"
		if (_tmp6_) {
#line 871 "panel.vala"
			_tmp5_ = !panel_is_gnome ();
#line 4837 "panel.c"
		} else {
#line 871 "panel.vala"
			_tmp5_ = FALSE;
#line 4841 "panel.c"
		}
#line 871 "panel.vala"
		if (_tmp5_) {
#line 4845 "panel.c"
			const gchar* _tmp7_;
#line 872 "panel.vala"
			_tmp7_ = g_getenv ("QT_IM_MODULE");
#line 872 "panel.vala"
			if (g_strcmp0 (_tmp7_, "ibus") == 0) {
#line 4851 "panel.c"
				gchar* format = NULL;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 873 "panel.vala"
				_tmp8_ = g_strdup (_ ("Please unset QT_IM_MODULE and GTK_IM_MODULE " "environment variables and 'ibus-daemon --panel " "disable' should be executed as a child process " "of %s component."));
#line 873 "panel.vala"
				format = _tmp8_;
#line 878 "panel.vala"
				_tmp9_ = format;
#line 878 "panel.vala"
				_tmp10_ = g_get_prgname ();
#line 878 "panel.vala"
				_tmp11_ = g_strdup_printf (_tmp9_, _tmp10_);
#line 878 "panel.vala"
				_g_free0 (message);
#line 878 "panel.vala"
				message = _tmp11_;
#line 872 "panel.vala"
				_g_free0 (format);
#line 4873 "panel.c"
			}
		}
	}
#line 881 "panel.vala"
	if (!self->priv->m_is_wayland) {
#line 881 "panel.vala"
		_tmp12_ = self->priv->m_is_wayland_im;
#line 4881 "panel.c"
	} else {
#line 881 "panel.vala"
		_tmp12_ = FALSE;
#line 4885 "panel.c"
	}
#line 881 "panel.vala"
	if (_tmp12_) {
#line 4889 "panel.c"
		gchar* format = NULL;
		gchar* _tmp13_;
		const gchar* prgname = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 882 "panel.vala"
		_tmp13_ = g_strdup (_ ("Seems you run %s with '--enable-wayland-im' " "option but your display server is Xorg so the Wayland " "feature is disabled. You would be better off running " "ibus-daemon directly instead or %s without that " "option."));
#line 882 "panel.vala"
		format = _tmp13_;
#line 888 "panel.vala"
		_tmp14_ = g_get_prgname ();
#line 888 "panel.vala"
		prgname = _tmp14_;
#line 889 "panel.vala"
		_tmp15_ = format;
#line 889 "panel.vala"
		_tmp16_ = prgname;
#line 889 "panel.vala"
		_tmp17_ = prgname;
#line 889 "panel.vala"
		_tmp18_ = g_strdup_printf (_tmp15_, _tmp16_, _tmp17_);
#line 889 "panel.vala"
		_g_free0 (message);
#line 889 "panel.vala"
		message = _tmp18_;
#line 881 "panel.vala"
		_g_free0 (format);
#line 4920 "panel.c"
	}
#line 891 "panel.vala"
	_tmp19_ = message;
#line 891 "panel.vala"
	if (_tmp19_ == NULL) {
#line 892 "panel.vala"
		_g_free0 (message);
#line 892 "panel.vala"
		return;
#line 4930 "panel.c"
	}
#line 894 "panel.vala"
	if (!notify_is_initted ()) {
#line 895 "panel.vala"
		notify_init ("ibus");
#line 4936 "panel.c"
	}
#line 898 "panel.vala"
	_tmp20_ = message;
#line 898 "panel.vala"
	_tmp21_ = notify_notification_new (_ ("IBus Notification"), _tmp20_, "ibus");
#line 898 "panel.vala"
	notification = _tmp21_;
#line 902 "panel.vala"
	_tmp22_ = notification;
#line 902 "panel.vala"
	notify_notification_set_timeout (_tmp22_, 60 * 1000);
#line 903 "panel.vala"
	_tmp23_ = notification;
#line 903 "panel.vala"
	notify_notification_set_category (_tmp23_, "wayland");
#line 4952 "panel.c"
	{
		NotifyNotification* _tmp24_;
#line 906 "panel.vala"
		_tmp24_ = notification;
#line 906 "panel.vala"
		notify_notification_show (_tmp24_, &_inner_error0_);
#line 906 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4961 "panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp25_;
#line 905 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 908 "panel.vala"
		_tmp25_ = message;
#line 908 "panel.vala"
		g_warning ("panel.vala:908: %s", _tmp25_);
#line 4975 "panel.c"
	}
	__finally0:
#line 905 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 905 "panel.vala"
		_g_object_unref0 (notification);
#line 905 "panel.vala"
		_g_free0 (message);
#line 905 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 905 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 905 "panel.vala"
		return;
#line 4990 "panel.c"
	}
#line 848 "panel.vala"
	_g_object_unref0 (notification);
#line 848 "panel.vala"
	_g_free0 (message);
#line 4996 "panel.c"
}

static void
panel_save_log (Panel* self,
                const gchar* format)
{
	FILE* _tmp0_;
	FILE* _tmp1_;
	FILE* _tmp2_;
#line 916 "panel.vala"
	g_return_if_fail (self != NULL);
#line 916 "panel.vala"
	g_return_if_fail (format != NULL);
#line 917 "panel.vala"
	_tmp0_ = self->priv->m_log;
#line 917 "panel.vala"
	if (_tmp0_ == NULL) {
#line 918 "panel.vala"
		return;
#line 5016 "panel.c"
	}
#line 919 "panel.vala"
	_tmp1_ = self->priv->m_log;
#line 919 "panel.vala"
	fputs (format, _tmp1_);
#line 920 "panel.vala"
	_tmp2_ = self->priv->m_log;
#line 920 "panel.vala"
	fflush (_tmp2_);
#line 5026 "panel.c"
}

void
panel_load_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GList* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
#line 924 "panel.vala"
	g_return_if_fail (self != NULL);
#line 925 "panel.vala"
	panel_init_engines_order (self);
#line 929 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 930 "panel.vala"
	panel_set_use_global_engine (self);
#line 931 "panel.vala"
	panel_set_use_xmodmap (self);
#line 932 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 932 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 934 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 934 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "preload-engines");
#line 934 "panel.vala"
	_tmp4_ = _tmp3_;
#line 934 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 934 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 934 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "engines-order");
#line 934 "panel.vala"
	_tmp8_ = _tmp7_;
#line 934 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 934 "panel.vala"
	panel_update_engines (self, _tmp4_, (gint) _vala_array_length (_tmp2_), _tmp8_, (gint) _vala_array_length (_tmp6_));
#line 934 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 934 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 936 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 936 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp9_);
#line 939 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 939 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 940 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 941 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 942 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 943 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 943 "panel.vala"
	binding_common_set_custom_font (_tmp10_, NULL, &self->priv->m_css_provider);
#line 946 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 946 "panel.vala"
	binding_common_set_custom_theme (_tmp11_);
#line 947 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 947 "panel.vala"
	binding_common_set_custom_icon (_tmp12_);
#line 948 "panel.vala"
	panel_set_show_icon_on_systray (self, FALSE);
#line 949 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 950 "panel.vala"
	panel_set_show_property_panel (self);
#line 951 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 952 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 953 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 954 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 5123 "panel.c"
}

/**
     * disconnect_signals:
     *
     * Call this API before m_panel = null so that the ref_count becomes 0
     */
void
panel_disconnect_signals (Panel* self)
{
	GObject* object = NULL;
	GtkStatusIcon* _tmp0_;
#line 962 "panel.vala"
	g_return_if_fail (self != NULL);
#line 963 "panel.vala"
	_tmp0_ = self->priv->m_status_icon;
#line 963 "panel.vala"
	object = (GObject*) _tmp0_;
#line 965 "panel.vala"
	if (self->priv->m_is_kde) {
#line 5144 "panel.c"
		Indicator* _tmp1_;
#line 966 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 966 "panel.vala"
		object = (GObject*) _tmp1_;
#line 5150 "panel.c"
	}
#line 968 "panel.vala"
	if (self->priv->m_popup_menu_id > ((gulong) 0)) {
#line 5154 "panel.c"
		GObject* _tmp2_;
#line 970 "panel.vala"
		_tmp2_ = object;
#line 970 "panel.vala"
		if (g_signal_handler_is_connected (_tmp2_, self->priv->m_popup_menu_id)) {
#line 5160 "panel.c"
			GObject* _tmp3_;
#line 971 "panel.vala"
			_tmp3_ = object;
#line 971 "panel.vala"
			g_signal_handler_disconnect (_tmp3_, self->priv->m_popup_menu_id);
#line 5166 "panel.c"
		}
#line 972 "panel.vala"
		self->priv->m_popup_menu_id = (gulong) 0;
#line 5170 "panel.c"
	}
#line 974 "panel.vala"
	if (self->priv->m_activate_id > ((gulong) 0)) {
#line 5174 "panel.c"
		GObject* _tmp4_;
#line 975 "panel.vala"
		_tmp4_ = object;
#line 975 "panel.vala"
		if (g_signal_handler_is_connected (_tmp4_, self->priv->m_activate_id)) {
#line 5180 "panel.c"
			GObject* _tmp5_;
#line 976 "panel.vala"
			_tmp5_ = object;
#line 976 "panel.vala"
			g_signal_handler_disconnect (_tmp5_, self->priv->m_activate_id);
#line 5186 "panel.c"
		}
#line 977 "panel.vala"
		self->priv->m_activate_id = (gulong) 0;
#line 5190 "panel.c"
	}
#line 979 "panel.vala"
	if (self->priv->m_registered_status_notifier_item_id > ((gulong) 0)) {
#line 5194 "panel.c"
		GObject* _tmp6_;
#line 980 "panel.vala"
		_tmp6_ = object;
#line 980 "panel.vala"
		if (g_signal_handler_is_connected (_tmp6_, self->priv->m_registered_status_notifier_item_id)) {
#line 5200 "panel.c"
			GObject* _tmp7_;
#line 983 "panel.vala"
			_tmp7_ = object;
#line 983 "panel.vala"
			g_signal_handler_disconnect (_tmp7_, self->priv->m_registered_status_notifier_item_id);
#line 5206 "panel.c"
		}
#line 985 "panel.vala"
		self->priv->m_registered_status_notifier_item_id = (gulong) 0;
#line 5210 "panel.c"
	}
#line 987 "panel.vala"
	if (self->priv->m_preload_engines_id > ((guint) 0)) {
#line 988 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 989 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 5218 "panel.c"
	}
}

/**
     * set_global_shortcut_key_state:
     *
     * Handle IME switcher dialog or Emojier on the focused context only
     * so this API is assumed to use in Wayland.
     */
void
panel_set_global_shortcut_key_state (Panel* self,
                                     IBusBusGlobalBindingType type,
                                     gboolean is_pressed,
                                     gboolean is_backward)
{
#line 1000 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1004 "panel.vala"
	switch (type) {
#line 1004 "panel.vala"
		case IBUS_BUS_GLOBAL_BINDING_TYPE_IME_SWITCHER:
#line 5240 "panel.c"
		{
#line 1006 "panel.vala"
			panel_handle_engine_switch_focused (self, is_pressed, is_backward);
#line 1007 "panel.vala"
			break;
#line 5246 "panel.c"
		}
		default:
		{
#line 1008 "panel.vala"
			break;
#line 5252 "panel.c"
		}
	}
}

void
panel_set_log (Panel* self,
               FILE* log,
               gboolean verbose)
{
#line 1013 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1013 "panel.vala"
	g_return_if_fail (log != NULL);
#line 1014 "panel.vala"
	self->priv->m_log = log;
#line 1015 "panel.vala"
	self->priv->m_verbose = verbose;
#line 5270 "panel.c"
}

static void
panel_engine_contexts_insert (Panel* self,
                              IBusEngineDesc* engine)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	IBusEngineDesc* _tmp5_;
#line 1019 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1019 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1020 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1021 "panel.vala"
		return;
#line 5290 "panel.c"
	}
#line 1023 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1023 "panel.vala"
	if (g_hash_table_size (_tmp0_) >= ((guint) 200)) {
#line 5296 "panel.c"
		GHashTable* _tmp1_;
#line 1024 "panel.vala"
		g_warning ("panel.vala:1024: Contexts by windows are too much counted!");
#line 1025 "panel.vala"
		_tmp1_ = self->priv->m_engine_contexts;
#line 1025 "panel.vala"
		g_hash_table_remove_all (_tmp1_);
#line 5304 "panel.c"
	}
#line 1028 "panel.vala"
	_tmp2_ = self->priv->m_engine_contexts;
#line 1028 "panel.vala"
	_tmp3_ = self->priv->m_current_context_path;
#line 1028 "panel.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 1028 "panel.vala"
	_tmp5_ = _g_object_ref0 (engine);
#line 1028 "panel.vala"
	g_hash_table_replace (_tmp2_, _tmp4_, _tmp5_);
#line 5316 "panel.c"
}

static void
panel_set_language_from_engine (Panel* self,
                                IBusEngineDesc* engine)
{
#line 1031 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1031 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1032 "panel.vala"
	if (self->priv->m_use_engine_lang) {
#line 5329 "panel.c"
		CandidatePanel* _tmp0_;
		const gchar* _tmp1_;
		PangoLanguage* _tmp2_;
		PangoAttrLanguage* _tmp3_;
		PangoAttrLanguage* _tmp4_;
#line 1033 "panel.vala"
		_tmp0_ = self->priv->m_candidate_panel;
#line 1033 "panel.vala"
		_tmp1_ = ibus_engine_desc_get_language (engine);
#line 1033 "panel.vala"
		_tmp2_ = pango_language_from_string (_tmp1_);
#line 1033 "panel.vala"
		_tmp3_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp2_);
#line 1033 "panel.vala"
		_tmp4_ = _tmp3_;
#line 1033 "panel.vala"
		candidate_panel_set_language (_tmp0_, (PangoAttribute*) _tmp4_);
#line 1033 "panel.vala"
		_pango_attribute_destroy0 (_tmp4_);
#line 5349 "panel.c"
	} else {
		CandidatePanel* _tmp5_;
		PangoLanguage* _tmp6_;
		PangoAttrLanguage* _tmp7_;
		PangoAttrLanguage* _tmp8_;
#line 1036 "panel.vala"
		_tmp5_ = self->priv->m_candidate_panel;
#line 1036 "panel.vala"
		_tmp6_ = pango_language_from_string (NULL);
#line 1036 "panel.vala"
		_tmp7_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp6_);
#line 1036 "panel.vala"
		_tmp8_ = _tmp7_;
#line 1036 "panel.vala"
		candidate_panel_set_language (_tmp5_, (PangoAttribute*) _tmp8_);
#line 1036 "panel.vala"
		_pango_attribute_destroy0 (_tmp8_);
#line 5367 "panel.c"
	}
}

static void
panel_set_engine (Panel* self,
                  IBusEngineDesc* engine)
{
	IBusBus* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 1042 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1042 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1043 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1044 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1045 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 5389 "panel.c"
	}
#line 1048 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1048 "panel.vala"
	_tmp1_ = ibus_engine_desc_get_name (engine);
#line 1048 "panel.vala"
	if (!ibus_bus_set_global_engine (_tmp0_, _tmp1_)) {
#line 5397 "panel.c"
		const gchar* _tmp2_;
#line 1049 "panel.vala"
		_tmp2_ = ibus_engine_desc_get_name (engine);
#line 1049 "panel.vala"
		g_warning ("panel.vala:1049: Switch engine to %s failed.", _tmp2_);
#line 1050 "panel.vala"
		return;
#line 5405 "panel.c"
	}
#line 1057 "panel.vala"
	_tmp3_ = g_strdup ("");
#line 1057 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 1057 "panel.vala"
	self->priv->m_icon_prop_key = _tmp3_;
#line 1060 "panel.vala"
	if (!self->priv->m_use_system_keyboard_layout) {
#line 1060 "panel.vala"
		_tmp4_ = !self->priv->m_is_wayland;
#line 5417 "panel.c"
	} else {
#line 1060 "panel.vala"
		_tmp4_ = FALSE;
#line 5421 "panel.c"
	}
#line 1060 "panel.vala"
	if (_tmp4_) {
#line 5425 "panel.c"
		XKBLayout* _tmp5_;
#line 1061 "panel.vala"
		_tmp5_ = self->priv->m_xkblayout;
#line 1061 "panel.vala"
		xkb_layout_set_layout (_tmp5_, engine);
#line 5431 "panel.c"
	}
#line 1063 "panel.vala"
	panel_set_language_from_engine (self, engine);
#line 1064 "panel.vala"
	panel_engine_contexts_insert (self, engine);
#line 5437 "panel.c"
}

static void
panel_switch_engine (Panel* self,
                     gint i,
                     gboolean force)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	IBusEngineDesc* engine = NULL;
	IBusEngineDesc** _tmp3_;
	gint _tmp3__length1;
	IBusEngineDesc* _tmp4_;
	IBusEngineDesc* _tmp5_;
	IBusEngineDesc* _tmp6_;
#line 1067 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1068 "panel.vala"
	if (i >= 0) {
#line 5457 "panel.c"
		IBusEngineDesc** _tmp1_;
		gint _tmp1__length1;
#line 1068 "panel.vala"
		_tmp1_ = self->priv->m_engines;
#line 1068 "panel.vala"
		_tmp1__length1 = self->priv->m_engines_length1;
#line 1068 "panel.vala"
		_tmp0_ = i < _tmp1__length1;
#line 5466 "panel.c"
	} else {
#line 1068 "panel.vala"
		_tmp0_ = FALSE;
#line 5470 "panel.c"
	}
#line 1068 "panel.vala"
	_vala_assert (_tmp0_, "i >= 0 && i < m_engines.length");
#line 1071 "panel.vala"
	if (i == 0) {
#line 1071 "panel.vala"
		_tmp2_ = !force;
#line 5478 "panel.c"
	} else {
#line 1071 "panel.vala"
		_tmp2_ = FALSE;
#line 5482 "panel.c"
	}
#line 1071 "panel.vala"
	if (_tmp2_) {
#line 1072 "panel.vala"
		return;
#line 5488 "panel.c"
	}
#line 1074 "panel.vala"
	_tmp3_ = self->priv->m_engines;
#line 1074 "panel.vala"
	_tmp3__length1 = self->priv->m_engines_length1;
#line 1074 "panel.vala"
	_tmp4_ = _tmp3_[i];
#line 1074 "panel.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1074 "panel.vala"
	engine = _tmp5_;
#line 1076 "panel.vala"
	_tmp6_ = engine;
#line 1076 "panel.vala"
	panel_set_engine (self, _tmp6_);
#line 1067 "panel.vala"
	_g_object_unref0 (engine);
#line 5506 "panel.c"
}

static void
panel_handle_engine_switch_normal (Panel* self,
                                   GdkEvent* event)
{
#line 1079 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1079 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1080 "panel.vala"
	panel_handle_engine_switch (self, event, FALSE);
#line 5519 "panel.c"
}

static void
panel_handle_engine_switch_reverse (Panel* self,
                                    GdkEvent* event)
{
#line 1083 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1083 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1084 "panel.vala"
	panel_handle_engine_switch (self, event, TRUE);
#line 5532 "panel.c"
}

static void
panel_handle_engine_switch (Panel* self,
                            GdkEvent* event,
                            gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
	guint keyval = 0U;
	GdkEventKey* _tmp1_;
	GdkEventKey* _tmp2_;
	guint modifiers = 0U;
	GdkEventKey* _tmp3_;
	GdkEventKey* _tmp4_;
	guint primary_modifiers = 0U;
	GdkEventKey* _tmp5_;
	GdkEventKey* _tmp6_;
	gboolean pressed = FALSE;
	gboolean _tmp7_ = FALSE;
#line 1087 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1087 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1089 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 1089 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 1089 "panel.vala"
	if (_tmp0__length1 <= 1) {
#line 1090 "panel.vala"
		return;
#line 5565 "panel.c"
	}
#line 1092 "panel.vala"
	_tmp1_ = (GdkEventKey *) (event);
#line 1092 "panel.vala"
	_tmp2_ = _tmp1_;
#line 1092 "panel.vala"
	keyval = _tmp2_->keyval;
#line 1093 "panel.vala"
	_tmp3_ = (GdkEventKey *) (event);
#line 1093 "panel.vala"
	_tmp4_ = _tmp3_;
#line 1093 "panel.vala"
	modifiers = KEYBINDING_MANAGER_MODIFIER_FILTER & _tmp4_->state;
#line 1095 "panel.vala"
	_tmp5_ = (GdkEventKey *) (event);
#line 1095 "panel.vala"
	_tmp6_ = _tmp5_;
#line 1095 "panel.vala"
	primary_modifiers = (guint) keybinding_manager_get_primary_modifier ((guint) _tmp6_->state);
#line 1098 "panel.vala"
	pressed = keybinding_manager_primary_modifier_still_pressed (event, primary_modifiers);
#line 1101 "panel.vala"
	if (reverse) {
#line 1102 "panel.vala"
		modifiers &= (guint) (~GDK_SHIFT_MASK);
#line 5591 "panel.c"
	}
#line 1105 "panel.vala"
	if (pressed) {
#line 1105 "panel.vala"
		_tmp7_ = self->priv->m_switcher_delay_time >= 0;
#line 5597 "panel.c"
	} else {
#line 1105 "panel.vala"
		_tmp7_ = FALSE;
#line 5601 "panel.c"
	}
#line 1105 "panel.vala"
	if (_tmp7_) {
#line 5605 "panel.c"
		gint _tmp8_ = 0;
		gint i = 0;
		Switcher* _tmp10_;
		IBusEngineDesc** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
#line 1106 "panel.vala"
		if (reverse) {
#line 5614 "panel.c"
			IBusEngineDesc** _tmp9_;
			gint _tmp9__length1;
#line 1106 "panel.vala"
			_tmp9_ = self->priv->m_engines;
#line 1106 "panel.vala"
			_tmp9__length1 = self->priv->m_engines_length1;
#line 1106 "panel.vala"
			_tmp8_ = _tmp9__length1 - 1;
#line 5623 "panel.c"
		} else {
#line 1106 "panel.vala"
			_tmp8_ = 1;
#line 5627 "panel.c"
		}
#line 1106 "panel.vala"
		i = _tmp8_;
#line 1117 "panel.vala"
		_tmp10_ = self->priv->m_switcher;
#line 1117 "panel.vala"
		_tmp11_ = self->priv->m_engines;
#line 1117 "panel.vala"
		_tmp11__length1 = self->priv->m_engines_length1;
#line 1117 "panel.vala"
		_tmp12_ = self->priv->m_real_current_context_path;
#line 1117 "panel.vala"
		i = switcher_run (_tmp10_, keyval, modifiers, event, _tmp11_, (gint) _tmp11__length1, i, _tmp12_);
#line 1120 "panel.vala"
		if (i < 0) {
#line 1121 "panel.vala"
			g_debug ("panel.vala:1121: switch cancelled");
#line 5645 "panel.c"
		} else {
#line 1122 "panel.vala"
			if (i == 0) {
#line 1123 "panel.vala"
				g_debug ("panel.vala:1123: do not have to switch");
#line 5651 "panel.c"
			} else {
#line 1125 "panel.vala"
				panel_switcher_focus_set_engine (self);
#line 5655 "panel.c"
			}
		}
	} else {
		gint _tmp13_ = 0;
		gint i = 0;
#line 1128 "panel.vala"
		if (reverse) {
#line 5663 "panel.c"
			IBusEngineDesc** _tmp14_;
			gint _tmp14__length1;
#line 1128 "panel.vala"
			_tmp14_ = self->priv->m_engines;
#line 1128 "panel.vala"
			_tmp14__length1 = self->priv->m_engines_length1;
#line 1128 "panel.vala"
			_tmp13_ = _tmp14__length1 - 1;
#line 5672 "panel.c"
		} else {
#line 1128 "panel.vala"
			_tmp13_ = 1;
#line 5676 "panel.c"
		}
#line 1128 "panel.vala"
		i = _tmp13_;
#line 1129 "panel.vala"
		panel_switch_engine (self, i, FALSE);
#line 5682 "panel.c"
	}
}

static gboolean
___lambda105_ (Panel* self)
{
	gboolean result;
#line 1164 "panel.vala"
	g_usleep ((gulong) 5000000);
#line 1165 "panel.vala"
	panel_handle_engine_switch_release (self, TRUE);
#line 1166 "panel.vala"
	_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1166 "panel.vala"
	self->priv->m_switcher_waiting_release = NULL;
#line 1167 "panel.vala"
	result = TRUE;
#line 1167 "panel.vala"
	return result;
#line 5702 "panel.c"
}

static gpointer
____lambda105__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda105_ ((Panel*) self));
#line 1162 "panel.vala"
	g_object_unref (self);
#line 1162 "panel.vala"
	return result;
#line 5714 "panel.c"
}

static void
panel_handle_engine_switch_focused (Panel* self,
                                    gboolean pressed,
                                    gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
#line 1134 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1136 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 1136 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 1136 "panel.vala"
	if (_tmp0__length1 < 2) {
#line 1137 "panel.vala"
		return;
#line 5734 "panel.c"
	}
#line 1138 "panel.vala"
	if (pressed) {
#line 5738 "panel.c"
		gint _tmp1_ = 0;
		gint i = 0;
		GThread* _tmp12_;
#line 1139 "panel.vala"
		if (reverse) {
#line 5744 "panel.c"
			IBusEngineDesc** _tmp2_;
			gint _tmp2__length1;
#line 1139 "panel.vala"
			_tmp2_ = self->priv->m_engines;
#line 1139 "panel.vala"
			_tmp2__length1 = self->priv->m_engines_length1;
#line 1139 "panel.vala"
			_tmp1_ = _tmp2__length1 - 1;
#line 5753 "panel.c"
		} else {
#line 1139 "panel.vala"
			_tmp1_ = 1;
#line 5757 "panel.c"
		}
#line 1139 "panel.vala"
		i = _tmp1_;
#line 1140 "panel.vala"
		if (self->priv->m_switcher_selected_index >= 0) {
#line 5763 "panel.c"
			gint _tmp3_ = 0;
			gint _tmp4_ = 0;
#line 1141 "panel.vala"
			if (reverse) {
#line 1141 "panel.vala"
				_tmp3_ = self->priv->m_switcher_selected_index - 1;
#line 5770 "panel.c"
			} else {
#line 1142 "panel.vala"
				_tmp3_ = self->priv->m_switcher_selected_index + 1;
#line 5774 "panel.c"
			}
#line 1141 "panel.vala"
			i = _tmp3_;
#line 1143 "panel.vala"
			if (i < 0) {
#line 5780 "panel.c"
				IBusEngineDesc** _tmp5_;
				gint _tmp5__length1;
#line 1143 "panel.vala"
				_tmp5_ = self->priv->m_engines;
#line 1143 "panel.vala"
				_tmp5__length1 = self->priv->m_engines_length1;
#line 1143 "panel.vala"
				_tmp4_ = _tmp5__length1 - 1;
#line 5789 "panel.c"
			} else {
				gint _tmp6_ = 0;
				IBusEngineDesc** _tmp7_;
				gint _tmp7__length1;
#line 1144 "panel.vala"
				_tmp7_ = self->priv->m_engines;
#line 1144 "panel.vala"
				_tmp7__length1 = self->priv->m_engines_length1;
#line 1144 "panel.vala"
				if (i == _tmp7__length1) {
#line 1144 "panel.vala"
					_tmp6_ = 0;
#line 5802 "panel.c"
				} else {
#line 1144 "panel.vala"
					_tmp6_ = i;
#line 5806 "panel.c"
				}
#line 1144 "panel.vala"
				_tmp4_ = _tmp6_;
#line 5810 "panel.c"
			}
#line 1143 "panel.vala"
			i = _tmp4_;
#line 5814 "panel.c"
		}
#line 1146 "panel.vala"
		if (self->priv->m_switcher_delay_time >= 0) {
#line 5818 "panel.c"
			Switcher* _tmp8_;
			IBusEngineDesc** _tmp9_;
			gint _tmp9__length1;
#line 1147 "panel.vala"
			_tmp8_ = self->priv->m_switcher;
#line 1147 "panel.vala"
			_tmp9_ = self->priv->m_engines;
#line 1147 "panel.vala"
			_tmp9__length1 = self->priv->m_engines_length1;
#line 1147 "panel.vala"
			self->priv->m_switcher_selected_index = switcher_run_popup (_tmp8_, _tmp9_, (gint) _tmp9__length1, i);
#line 5830 "panel.c"
		} else {
#line 1149 "panel.vala"
			self->priv->m_switcher_selected_index = i;
#line 5834 "panel.c"
		}
#line 1150 "panel.vala"
		if (self->priv->m_verbose) {
#line 5838 "panel.c"
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 1151 "panel.vala"
			_tmp10_ = g_strdup_printf ("Panel.%s switcher release %d timer\n", G_STRFUNC, self->priv->m_switcher_selected_index);
#line 1151 "panel.vala"
			_tmp11_ = _tmp10_;
#line 1151 "panel.vala"
			panel_save_log (self, _tmp11_);
#line 1151 "panel.vala"
			_g_free0 (_tmp11_);
#line 5849 "panel.c"
		}
#line 1154 "panel.vala"
		_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1154 "panel.vala"
		self->priv->m_switcher_waiting_release = NULL;
#line 1162 "panel.vala"
		_tmp12_ = g_thread_new ("wait release", ____lambda105__gthread_func, g_object_ref (self));
#line 1162 "panel.vala"
		_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1162 "panel.vala"
		self->priv->m_switcher_waiting_release = _tmp12_;
#line 5861 "panel.c"
	} else {
#line 1170 "panel.vala"
		_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1170 "panel.vala"
		self->priv->m_switcher_waiting_release = NULL;
#line 1171 "panel.vala"
		panel_handle_engine_switch_release (self, FALSE);
#line 5869 "panel.c"
	}
}

static void
panel_handle_engine_switch_release (Panel* self,
                                    gboolean is_timeout)
{
	Switcher* _tmp3_;
#line 1175 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1176 "panel.vala"
	if (self->priv->m_verbose) {
#line 5882 "panel.c"
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1179 "panel.vala"
		if (is_timeout) {
#line 1179 "panel.vala"
			_tmp0_ = "timeout";
#line 5890 "panel.c"
		} else {
#line 1179 "panel.vala"
			_tmp0_ = "normal";
#line 5894 "panel.c"
		}
#line 1177 "panel.vala"
		_tmp1_ = g_strdup_printf ("Panel.%s switcher release %d %s\n", G_STRFUNC, self->priv->m_switcher_selected_index, _tmp0_);
#line 1177 "panel.vala"
		_tmp2_ = _tmp1_;
#line 1177 "panel.vala"
		panel_save_log (self, _tmp2_);
#line 1177 "panel.vala"
		_g_free0 (_tmp2_);
#line 5904 "panel.c"
	}
#line 1183 "panel.vala"
	_tmp3_ = self->priv->m_switcher;
#line 1183 "panel.vala"
	gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1184 "panel.vala"
	while (TRUE) {
#line 1184 "panel.vala"
		if (!gtk_events_pending ()) {
#line 1184 "panel.vala"
			break;
#line 5916 "panel.c"
		}
#line 1185 "panel.vala"
		gtk_main_iteration ();
#line 5920 "panel.c"
	}
#line 1187 "panel.vala"
	if (self->priv->m_switcher_selected_index < 0) {
#line 1188 "panel.vala"
		return;
#line 5926 "panel.c"
	}
#line 1189 "panel.vala"
	panel_switch_engine (self, self->priv->m_switcher_selected_index, FALSE);
#line 1190 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 5932 "panel.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 1194 "panel.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 1194 "panel.vala"
	return _data8_;
#line 5942 "panel.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 1194 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 5952 "panel.c"
		Panel* self;
#line 1194 "panel.vala"
		self = _data8_->self;
#line 1194 "panel.vala"
		_data8_->names = (_vala_array_free (_data8_->names, _data8_->names_length1, (GDestroyNotify) g_free), NULL);
#line 1194 "panel.vala"
		_g_object_unref0 (self);
#line 1194 "panel.vala"
		g_slice_free (Block8Data, _data8_);
#line 5962 "panel.c"
	}
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1206 "panel.vala"
	if ((*length) == (*size)) {
#line 1206 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1206 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5978 "panel.c"
	}
#line 1206 "panel.vala"
	(*array)[(*length)++] = value;
#line 1206 "panel.vala"
	(*array)[*length] = NULL;
#line 5984 "panel.c"
}

static gboolean
__lambda62_ (Block8Data* _data8_)
{
	Panel* self;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 1210 "panel.vala"
	self = _data8_->self;
#line 1211 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1211 "panel.vala"
	if (!ibus_bus_is_connected (_tmp0_)) {
#line 1212 "panel.vala"
		result = FALSE;
#line 1212 "panel.vala"
		return result;
#line 6006 "panel.c"
	}
#line 1213 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 1213 "panel.vala"
	_tmp2_ = _data8_->names;
#line 1213 "panel.vala"
	_tmp2__length1 = _data8_->names_length1;
#line 1213 "panel.vala"
	ibus_bus_preload_engines_async (_tmp1_, _tmp2_, -1, NULL, NULL, NULL);
#line 1216 "panel.vala"
	result = FALSE;
#line 1216 "panel.vala"
	return result;
#line 6020 "panel.c"
}

static gboolean
___lambda62__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda62_ (self);
#line 1207 "panel.vala"
	return result;
#line 6030 "panel.c"
}

static void
panel_run_preload_engines (Panel* self,
                           IBusEngineDesc** engines,
                           gint engines_length1,
                           gint index)
{
	Block8Data* _data8_;
	gchar** _tmp0_;
	IBusEngineDesc* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 1194 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1194 "panel.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 1194 "panel.vala"
	_data8_->_ref_count_ = 1;
#line 1194 "panel.vala"
	_data8_->self = g_object_ref (self);
#line 1195 "panel.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 1195 "panel.vala"
	_data8_->names = _tmp0_;
#line 1195 "panel.vala"
	_data8_->names_length1 = 0;
#line 1195 "panel.vala"
	_data8_->_names_size_ = _data8_->names_length1;
#line 1197 "panel.vala"
	if (engines_length1 <= index) {
#line 1198 "panel.vala"
		block8_data_unref (_data8_);
#line 1198 "panel.vala"
		_data8_ = NULL;
#line 1198 "panel.vala"
		return;
#line 6068 "panel.c"
	}
#line 1201 "panel.vala"
	if (self->priv->m_preload_engines_id != ((guint) 0)) {
#line 1202 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 1203 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 6076 "panel.c"
	}
#line 1206 "panel.vala"
	_tmp1_ = engines[index];
#line 1206 "panel.vala"
	_tmp2_ = ibus_engine_desc_get_name (_tmp1_);
#line 1206 "panel.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1206 "panel.vala"
	_vala_array_add22 (&_data8_->names, &_data8_->names_length1, &_data8_->_names_size_, _tmp3_);
#line 1207 "panel.vala"
	self->priv->m_preload_engines_id = g_timeout_add_full (G_PRIORITY_DEFAULT, PANEL_PRELOAD_ENGINES_DELAY_TIME, ___lambda62__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 1194 "panel.vala"
	block8_data_unref (_data8_);
#line 1194 "panel.vala"
	_data8_ = NULL;
#line 6092 "panel.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 1222 "panel.vala"
	if (length >= 0) {
#line 6101 "panel.c"
		gchar** result;
		gssize i;
#line 1222 "panel.vala"
		result = g_new0 (gchar*, length + 1);
#line 1222 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6108 "panel.c"
			gchar* _tmp0_;
#line 1222 "panel.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1222 "panel.vala"
			result[i] = _tmp0_;
#line 6114 "panel.c"
		}
#line 1222 "panel.vala"
		return result;
#line 6118 "panel.c"
	}
#line 1222 "panel.vala"
	return NULL;
#line 6122 "panel.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 1230 "panel.vala"
	for (i = 0; i < stack_length; i++) {
#line 1230 "panel.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 1230 "panel.vala"
			return TRUE;
#line 6137 "panel.c"
		}
	}
#line 1230 "panel.vala"
	return FALSE;
#line 6142 "panel.c"
}

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1231 "panel.vala"
	if ((*length) == (*size)) {
#line 1231 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1231 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6157 "panel.c"
	}
#line 1231 "panel.vala"
	(*array)[(*length)++] = value;
#line 1231 "panel.vala"
	(*array)[*length] = NULL;
#line 6163 "panel.c"
}

static void
_vala_array_add24 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1237 "panel.vala"
	if ((*length) == (*size)) {
#line 1237 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1237 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6178 "panel.c"
	}
#line 1237 "panel.vala"
	(*array)[(*length)++] = value;
#line 1237 "panel.vala"
	(*array)[*length] = NULL;
#line 6184 "panel.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 1245 "panel.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 1245 "panel.vala"
	return _data9_;
#line 6194 "panel.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 1245 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 6204 "panel.c"
		Panel* self;
#line 1245 "panel.vala"
		self = _data9_->self;
#line 1245 "panel.vala"
		_g_object_unref0 (_data9_->dialog);
#line 1245 "panel.vala"
		_g_object_unref0 (self);
#line 1245 "panel.vala"
		g_slice_free (Block9Data, _data9_);
#line 6214 "panel.c"
	}
}

static void
___lambda61_ (Block9Data* _data9_,
              gint id)
{
	Panel* self;
	GtkMessageDialog* _tmp0_;
#line 1268 "panel.vala"
	self = _data9_->self;
#line 1269 "panel.vala"
	_tmp0_ = _data9_->dialog;
#line 1269 "panel.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 6230 "panel.c"
}

static void
____lambda61__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 1268 "panel.vala"
	___lambda61_ (self, response_id);
#line 6240 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup3 (IBusEngineDesc** self,
                  gssize length)
{
#line 1275 "panel.vala"
	if (length >= 0) {
#line 6249 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1275 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1275 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6256 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1275 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1275 "panel.vala"
			result[i] = _tmp0_;
#line 6262 "panel.c"
		}
#line 1275 "panel.vala"
		return result;
#line 6266 "panel.c"
	}
#line 1275 "panel.vala"
	return NULL;
#line 6270 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup4 (IBusEngineDesc** self,
                  gssize length)
{
#line 1280 "panel.vala"
	if (length >= 0) {
#line 6279 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1280 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1280 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6286 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1280 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1280 "panel.vala"
			result[i] = _tmp0_;
#line 6292 "panel.c"
		}
#line 1280 "panel.vala"
		return result;
#line 6296 "panel.c"
	}
#line 1280 "panel.vala"
	return NULL;
#line 6300 "panel.c"
}

static void
panel_update_engines (Panel* self,
                      gchar** unowned_engine_names,
                      gint unowned_engine_names_length1,
                      gchar** order_names,
                      gint order_names_length1)
{
	gchar** engine_names = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint engine_names_length1;
	gint _engine_names_size_;
	gboolean _tmp1_ = FALSE;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** names = NULL;
	gchar** _tmp6_;
	gint names_length1;
	gint _names_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	IBusEngineDesc** engines = NULL;
	IBusBus* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	IBusEngineDesc** _tmp20_;
	IBusEngineDesc** _tmp21_;
	gint engines_length1;
	gint _engines_size_;
	IBusEngineDesc** _tmp22_;
	gint _tmp22__length1;
	gchar** _tmp23_;
	gint _tmp23__length1;
	IBusEngineDesc** _tmp43_;
	gint _tmp43__length1;
#line 1220 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1222 "panel.vala"
	_tmp0_ = (unowned_engine_names != NULL) ? _vala_array_dup2 (unowned_engine_names, unowned_engine_names_length1) : unowned_engine_names;
#line 1222 "panel.vala"
	_tmp0__length1 = unowned_engine_names_length1;
#line 1222 "panel.vala"
	engine_names = _tmp0_;
#line 1222 "panel.vala"
	engine_names_length1 = _tmp0__length1;
#line 1222 "panel.vala"
	_engine_names_size_ = engine_names_length1;
#line 1224 "panel.vala"
	_tmp2_ = engine_names;
#line 1224 "panel.vala"
	_tmp2__length1 = engine_names_length1;
#line 1224 "panel.vala"
	if (_tmp2_ == NULL) {
#line 1224 "panel.vala"
		_tmp1_ = TRUE;
#line 6358 "panel.c"
	} else {
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 1224 "panel.vala"
		_tmp3_ = engine_names;
#line 1224 "panel.vala"
		_tmp3__length1 = engine_names_length1;
#line 1224 "panel.vala"
		_tmp1_ = _tmp3__length1 == 0;
#line 6368 "panel.c"
	}
#line 1224 "panel.vala"
	if (_tmp1_) {
#line 6372 "panel.c"
		gchar* _tmp4_;
		gchar** _tmp5_;
#line 1225 "panel.vala"
		_tmp4_ = g_strdup ("xkb:us::eng");
#line 1225 "panel.vala"
		_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 1225 "panel.vala"
		_tmp5_[0] = _tmp4_;
#line 1225 "panel.vala"
		engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1225 "panel.vala"
		engine_names = _tmp5_;
#line 1225 "panel.vala"
		engine_names_length1 = 1;
#line 1225 "panel.vala"
		_engine_names_size_ = engine_names_length1;
#line 6389 "panel.c"
	}
#line 1227 "panel.vala"
	_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 1227 "panel.vala"
	names = _tmp6_;
#line 1227 "panel.vala"
	names_length1 = 0;
#line 1227 "panel.vala"
	_names_size_ = names_length1;
#line 6399 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1229 "panel.vala"
		name_collection = order_names;
#line 1229 "panel.vala"
		name_collection_length1 = order_names_length1;
#line 1229 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 6411 "panel.c"
			gchar* _tmp7_;
			gchar* name = NULL;
#line 1229 "panel.vala"
			_tmp7_ = g_strdup (name_collection[name_it]);
#line 1229 "panel.vala"
			name = _tmp7_;
#line 6418 "panel.c"
			{
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
#line 1230 "panel.vala"
				_tmp8_ = name;
#line 1230 "panel.vala"
				_tmp9_ = engine_names;
#line 1230 "panel.vala"
				_tmp9__length1 = engine_names_length1;
#line 1230 "panel.vala"
				if (_vala_string_array_contains (_tmp9_, _tmp9__length1, _tmp8_)) {
#line 6431 "panel.c"
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 1231 "panel.vala"
					_tmp10_ = name;
#line 1231 "panel.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 1231 "panel.vala"
					_vala_array_add23 (&names, &names_length1, &_names_size_, _tmp11_);
#line 6440 "panel.c"
				}
#line 1229 "panel.vala"
				_g_free0 (name);
#line 6444 "panel.c"
			}
		}
	}
#line 1234 "panel.vala"
	_tmp12_ = engine_names;
#line 1234 "panel.vala"
	_tmp12__length1 = engine_names_length1;
#line 6452 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1234 "panel.vala"
		name_collection = _tmp12_;
#line 1234 "panel.vala"
		name_collection_length1 = _tmp12__length1;
#line 1234 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 6464 "panel.c"
			gchar* _tmp13_;
			gchar* name = NULL;
#line 1234 "panel.vala"
			_tmp13_ = g_strdup (name_collection[name_it]);
#line 1234 "panel.vala"
			name = _tmp13_;
#line 6471 "panel.c"
			{
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 1235 "panel.vala"
				_tmp14_ = name;
#line 1235 "panel.vala"
				_tmp15_ = names;
#line 1235 "panel.vala"
				_tmp15__length1 = names_length1;
#line 1235 "panel.vala"
				if (_vala_string_array_contains (_tmp15_, _tmp15__length1, _tmp14_)) {
#line 1236 "panel.vala"
					_g_free0 (name);
#line 1236 "panel.vala"
					continue;
#line 6490 "panel.c"
				}
#line 1237 "panel.vala"
				_tmp16_ = name;
#line 1237 "panel.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 1237 "panel.vala"
				_vala_array_add24 (&names, &names_length1, &_names_size_, _tmp17_);
#line 1234 "panel.vala"
				_g_free0 (name);
#line 6500 "panel.c"
			}
		}
	}
#line 1240 "panel.vala"
	_tmp18_ = self->priv->m_bus;
#line 1240 "panel.vala"
	_tmp19_ = names;
#line 1240 "panel.vala"
	_tmp19__length1 = names_length1;
#line 1240 "panel.vala"
	_tmp21_ = _tmp20_ = ibus_bus_get_engines_by_names (_tmp18_, _tmp19_);
#line 1240 "panel.vala"
	engines = _tmp21_;
#line 1240 "panel.vala"
	engines_length1 = _vala_array_length (_tmp20_);
#line 1240 "panel.vala"
	_engines_size_ = engines_length1;
#line 1245 "panel.vala"
	_tmp22_ = engines;
#line 1245 "panel.vala"
	_tmp22__length1 = engines_length1;
#line 1245 "panel.vala"
	_tmp23_ = names;
#line 1245 "panel.vala"
	_tmp23__length1 = names_length1;
#line 1245 "panel.vala"
	if (_tmp22__length1 < _tmp23__length1) {
#line 6528 "panel.c"
		Block9Data* _data9_;
		gchar* message1 = NULL;
		IBusEngineDesc** _tmp24_;
		gint _tmp24__length1;
		gchar* message2 = NULL;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		GtkMessageDialog* _tmp40_;
		GtkMessageDialog* _tmp41_;
		GtkMessageDialog* _tmp42_;
#line 1245 "panel.vala"
		_data9_ = g_slice_new0 (Block9Data);
#line 1245 "panel.vala"
		_data9_->_ref_count_ = 1;
#line 1245 "panel.vala"
		_data9_->self = g_object_ref (self);
#line 1247 "panel.vala"
		_tmp24_ = engines;
#line 1247 "panel.vala"
		_tmp24__length1 = engines_length1;
#line 1247 "panel.vala"
		if (_tmp24__length1 == 0) {
#line 6552 "panel.c"
			gchar** fallback_names = NULL;
			gchar* _tmp25_;
			gchar** _tmp26_;
			gint fallback_names_length1;
			gint _fallback_names_size_;
			GSettings* _tmp27_;
			gchar** _tmp28_;
			gint _tmp28__length1;
			IBusBus* _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			IBusEngineDesc** _tmp31_;
			IBusEngineDesc** _tmp32_;
			gchar** _tmp33_;
			gint _tmp33__length1;
			const gchar* _tmp34_;
			gchar* _tmp35_;
#line 1248 "panel.vala"
			_tmp25_ = g_strdup ("xkb:us::eng");
#line 1248 "panel.vala"
			_tmp26_ = g_new0 (gchar*, 1 + 1);
#line 1248 "panel.vala"
			_tmp26_[0] = _tmp25_;
#line 1248 "panel.vala"
			fallback_names = _tmp26_;
#line 1248 "panel.vala"
			fallback_names_length1 = 1;
#line 1248 "panel.vala"
			_fallback_names_size_ = fallback_names_length1;
#line 1249 "panel.vala"
			_tmp27_ = self->priv->m_settings_general;
#line 1249 "panel.vala"
			_tmp28_ = fallback_names;
#line 1249 "panel.vala"
			_tmp28__length1 = fallback_names_length1;
#line 1249 "panel.vala"
			g_settings_set_strv (_tmp27_, "preload-engines", _tmp28_);
#line 1250 "panel.vala"
			_tmp29_ = self->priv->m_bus;
#line 1250 "panel.vala"
			_tmp30_ = fallback_names;
#line 1250 "panel.vala"
			_tmp30__length1 = fallback_names_length1;
#line 1250 "panel.vala"
			_tmp32_ = _tmp31_ = ibus_bus_get_engines_by_names (_tmp29_, _tmp30_);
#line 1250 "panel.vala"
			engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1250 "panel.vala"
			engines = _tmp32_;
#line 1250 "panel.vala"
			engines_length1 = _vala_array_length (_tmp31_);
#line 1250 "panel.vala"
			_engines_size_ = engines_length1;
#line 1251 "panel.vala"
			_tmp33_ = names;
#line 1251 "panel.vala"
			_tmp33__length1 = names_length1;
#line 1251 "panel.vala"
			_tmp34_ = _tmp33_[0];
#line 1251 "panel.vala"
			_tmp35_ = g_strdup_printf (_ ("Your configured input method %s does not exist " "in IBus input methods so \"US\" layout was " "configured instead of your input method."), _tmp34_);
#line 1251 "panel.vala"
			_g_free0 (message1);
#line 1251 "panel.vala"
			message1 = _tmp35_;
#line 1247 "panel.vala"
			fallback_names = (_vala_array_free (fallback_names, fallback_names_length1, (GDestroyNotify) g_free), NULL);
#line 6620 "panel.c"
		} else {
			gchar* _tmp36_;
#line 1256 "panel.vala"
			_tmp36_ = g_strdup (_ ("At least one of your configured input methods " "does not exist in IBus input methods."));
#line 1256 "panel.vala"
			_g_free0 (message1);
#line 1256 "panel.vala"
			message1 = _tmp36_;
#line 6629 "panel.c"
		}
#line 1259 "panel.vala"
		_tmp37_ = g_strdup (_ ("Please run `ibus-setup` command, open \"Input " "Method\" tab, and configure your input methods " "again."));
#line 1259 "panel.vala"
		message2 = _tmp37_;
#line 1262 "panel.vala"
		_tmp38_ = message1;
#line 1262 "panel.vala"
		_tmp39_ = message2;
#line 1262 "panel.vala"
		_tmp40_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "%s %s", _tmp38_, _tmp39_);
#line 1262 "panel.vala"
		g_object_ref_sink (_tmp40_);
#line 1262 "panel.vala"
		_data9_->dialog = _tmp40_;
#line 1268 "panel.vala"
		_tmp41_ = _data9_->dialog;
#line 1268 "panel.vala"
		g_signal_connect_data ((GtkDialog*) _tmp41_, "response", (GCallback) ____lambda61__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 1271 "panel.vala"
		_tmp42_ = _data9_->dialog;
#line 1271 "panel.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp42_);
#line 1245 "panel.vala"
		_g_free0 (message2);
#line 1245 "panel.vala"
		_g_free0 (message1);
#line 1245 "panel.vala"
		block9_data_unref (_data9_);
#line 1245 "panel.vala"
		_data9_ = NULL;
#line 6661 "panel.c"
	}
#line 1274 "panel.vala"
	_tmp43_ = self->priv->m_engines;
#line 1274 "panel.vala"
	_tmp43__length1 = self->priv->m_engines_length1;
#line 1274 "panel.vala"
	if (_tmp43__length1 == 0) {
#line 6669 "panel.c"
		IBusEngineDesc** _tmp44_;
		gint _tmp44__length1;
		IBusEngineDesc** _tmp45_;
		gint _tmp45__length1;
		IBusEngineDesc** _tmp46_;
		gint _tmp46__length1;
#line 1275 "panel.vala"
		_tmp44_ = engines;
#line 1275 "panel.vala"
		_tmp44__length1 = engines_length1;
#line 1275 "panel.vala"
		_tmp45_ = (_tmp44_ != NULL) ? _vala_array_dup3 (_tmp44_, _tmp44__length1) : _tmp44_;
#line 1275 "panel.vala"
		_tmp45__length1 = _tmp44__length1;
#line 1275 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1275 "panel.vala"
		self->priv->m_engines = _tmp45_;
#line 1275 "panel.vala"
		self->priv->m_engines_length1 = _tmp45__length1;
#line 1275 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 1276 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1277 "panel.vala"
		_tmp46_ = self->priv->m_engines;
#line 1277 "panel.vala"
		_tmp46__length1 = self->priv->m_engines_length1;
#line 1277 "panel.vala"
		panel_run_preload_engines (self, _tmp46_, (gint) _tmp46__length1, 1);
#line 6700 "panel.c"
	} else {
		IBusEngineDesc* current_engine = NULL;
		IBusEngineDesc** _tmp47_;
		gint _tmp47__length1;
		IBusEngineDesc* _tmp48_;
		IBusEngineDesc* _tmp49_;
		IBusEngineDesc** _tmp50_;
		gint _tmp50__length1;
		IBusEngineDesc** _tmp51_;
		gint _tmp51__length1;
		gint i = 0;
		IBusEngineDesc** _tmp62_;
		gint _tmp62__length1;
#line 1279 "panel.vala"
		_tmp47_ = self->priv->m_engines;
#line 1279 "panel.vala"
		_tmp47__length1 = self->priv->m_engines_length1;
#line 1279 "panel.vala"
		_tmp48_ = _tmp47_[0];
#line 1279 "panel.vala"
		_tmp49_ = _g_object_ref0 (_tmp48_);
#line 1279 "panel.vala"
		current_engine = _tmp49_;
#line 1280 "panel.vala"
		_tmp50_ = engines;
#line 1280 "panel.vala"
		_tmp50__length1 = engines_length1;
#line 1280 "panel.vala"
		_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup4 (_tmp50_, _tmp50__length1) : _tmp50_;
#line 1280 "panel.vala"
		_tmp51__length1 = _tmp50__length1;
#line 1280 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1280 "panel.vala"
		self->priv->m_engines = _tmp51_;
#line 1280 "panel.vala"
		self->priv->m_engines_length1 = _tmp51__length1;
#line 1280 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 6740 "panel.c"
		{
			gboolean _tmp52_ = FALSE;
#line 1282 "panel.vala"
			i = 0;
#line 1282 "panel.vala"
			_tmp52_ = TRUE;
#line 1282 "panel.vala"
			while (TRUE) {
#line 6749 "panel.c"
				IBusEngineDesc** _tmp54_;
				gint _tmp54__length1;
				IBusEngineDesc* _tmp55_;
				const gchar* _tmp56_;
				IBusEngineDesc** _tmp57_;
				gint _tmp57__length1;
				IBusEngineDesc* _tmp58_;
				const gchar* _tmp59_;
#line 1282 "panel.vala"
				if (!_tmp52_) {
#line 6760 "panel.c"
					gint _tmp53_;
#line 1282 "panel.vala"
					_tmp53_ = i;
#line 1282 "panel.vala"
					i = _tmp53_ + 1;
#line 6766 "panel.c"
				}
#line 1282 "panel.vala"
				_tmp52_ = FALSE;
#line 1282 "panel.vala"
				_tmp54_ = self->priv->m_engines;
#line 1282 "panel.vala"
				_tmp54__length1 = self->priv->m_engines_length1;
#line 1282 "panel.vala"
				if (!(i < _tmp54__length1)) {
#line 1282 "panel.vala"
					break;
#line 6778 "panel.c"
				}
#line 1283 "panel.vala"
				_tmp55_ = current_engine;
#line 1283 "panel.vala"
				_tmp56_ = ibus_engine_desc_get_name (_tmp55_);
#line 1283 "panel.vala"
				_tmp57_ = engines;
#line 1283 "panel.vala"
				_tmp57__length1 = engines_length1;
#line 1283 "panel.vala"
				_tmp58_ = _tmp57_[i];
#line 1283 "panel.vala"
				_tmp59_ = ibus_engine_desc_get_name (_tmp58_);
#line 1283 "panel.vala"
				if (g_strcmp0 (_tmp56_, _tmp59_) == 0) {
#line 1284 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1285 "panel.vala"
					if (i != 0) {
#line 6798 "panel.c"
						IBusEngineDesc** _tmp60_;
						gint _tmp60__length1;
#line 1286 "panel.vala"
						_tmp60_ = engines;
#line 1286 "panel.vala"
						_tmp60__length1 = engines_length1;
#line 1286 "panel.vala"
						panel_run_preload_engines (self, _tmp60_, (gint) _tmp60__length1, 0);
#line 6807 "panel.c"
					} else {
						IBusEngineDesc** _tmp61_;
						gint _tmp61__length1;
#line 1288 "panel.vala"
						_tmp61_ = engines;
#line 1288 "panel.vala"
						_tmp61__length1 = engines_length1;
#line 1288 "panel.vala"
						panel_run_preload_engines (self, _tmp61_, (gint) _tmp61__length1, 1);
#line 6817 "panel.c"
					}
#line 1290 "panel.vala"
					_g_object_unref0 (current_engine);
#line 1290 "panel.vala"
					engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1290 "panel.vala"
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1290 "panel.vala"
					engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1290 "panel.vala"
					return;
#line 6829 "panel.c"
				}
			}
		}
#line 1293 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1294 "panel.vala"
		_tmp62_ = engines;
#line 1294 "panel.vala"
		_tmp62__length1 = engines_length1;
#line 1294 "panel.vala"
		panel_run_preload_engines (self, _tmp62_, (gint) _tmp62__length1, 1);
#line 1274 "panel.vala"
		_g_object_unref0 (current_engine);
#line 6843 "panel.c"
	}
#line 1220 "panel.vala"
	engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1220 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1220 "panel.vala"
	engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 6851 "panel.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 1309 "panel.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 6859 "panel.c"
}

static void
panel_context_render_string (Panel* self,
                             cairo_t* cr,
                             const gchar* symbol,
                             gint image_width,
                             gint image_height)
{
	gint lwidth = 0;
	gint lheight = 0;
	PangoFontDescription* desc = NULL;
	PangoFontDescription* _tmp0_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	PangoLayout* _tmp5_;
	PangoFontDescription* _tmp6_;
	PangoLayout* _tmp7_;
	PangoLayout* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	PangoLayout* _tmp15_;
#line 1299 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1299 "panel.vala"
	g_return_if_fail (cr != NULL);
#line 1299 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1303 "panel.vala"
	lwidth = 0;
#line 1304 "panel.vala"
	lheight = 0;
#line 1305 "panel.vala"
	_tmp0_ = pango_font_description_from_string ("Monospace Bold 22");
#line 1305 "panel.vala"
	desc = _tmp0_;
#line 1306 "panel.vala"
	_tmp1_ = pango_cairo_create_layout (cr);
#line 1306 "panel.vala"
	layout = _tmp1_;
#line 1308 "panel.vala"
	_tmp2_ = strlen (symbol);
#line 1308 "panel.vala"
	_tmp3_ = _tmp2_;
#line 1308 "panel.vala"
	if (_tmp3_ >= 3) {
#line 6912 "panel.c"
		PangoFontDescription* _tmp4_;
#line 1309 "panel.vala"
		_tmp4_ = pango_font_description_from_string ("Monospace Bold 18");
#line 1309 "panel.vala"
		__vala_PangoFontDescription_free0 (desc);
#line 1309 "panel.vala"
		desc = _tmp4_;
#line 6920 "panel.c"
	}
#line 1311 "panel.vala"
	_tmp5_ = layout;
#line 1311 "panel.vala"
	_tmp6_ = desc;
#line 1311 "panel.vala"
	pango_layout_set_font_description (_tmp5_, _tmp6_);
#line 1312 "panel.vala"
	_tmp7_ = layout;
#line 1312 "panel.vala"
	pango_layout_set_text (_tmp7_, symbol, -1);
#line 1313 "panel.vala"
	_tmp8_ = layout;
#line 1313 "panel.vala"
	pango_layout_get_size (_tmp8_, &_tmp9_, &_tmp10_);
#line 1313 "panel.vala"
	lwidth = _tmp9_;
#line 1313 "panel.vala"
	lheight = _tmp10_;
#line 1314 "panel.vala"
	cairo_move_to (cr, (gdouble) ((image_width - (lwidth / PANGO_SCALE)) / 2), (gdouble) ((image_height - (lheight / PANGO_SCALE)) / 2));
#line 1316 "panel.vala"
	_tmp11_ = self->priv->m_xkb_icon_rgba;
#line 1316 "panel.vala"
	_tmp12_ = self->priv->m_xkb_icon_rgba;
#line 1316 "panel.vala"
	_tmp13_ = self->priv->m_xkb_icon_rgba;
#line 1316 "panel.vala"
	_tmp14_ = self->priv->m_xkb_icon_rgba;
#line 1316 "panel.vala"
	cairo_set_source_rgba (cr, _tmp11_.red, _tmp12_.green, _tmp13_.blue, _tmp14_.alpha);
#line 1320 "panel.vala"
	_tmp15_ = layout;
#line 1320 "panel.vala"
	pango_cairo_show_layout (cr, _tmp15_);
#line 1299 "panel.vala"
	_g_object_unref0 (layout);
#line 1299 "panel.vala"
	__vala_PangoFontDescription_free0 (desc);
#line 6960 "panel.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 1328 "panel.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 6968 "panel.c"
}

static cairo_surface_t*
panel_create_cairo_image_surface_with_string (Panel* self,
                                              const gchar* symbol,
                                              gboolean cache)
{
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	gint width = 0;
	cairo_surface_t* _tmp7_;
	gint height = 0;
	cairo_surface_t* _tmp8_;
	gint stride = 0;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_surface_t* _tmp15_;
	cairo_surface_t* result;
#line 1323 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1325 "panel.vala"
	image = NULL;
#line 1327 "panel.vala"
	if (cache) {
#line 7002 "panel.c"
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
#line 1328 "panel.vala"
		_tmp0_ = self->priv->m_xkb_icon_image;
#line 1328 "panel.vala"
		_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1328 "panel.vala"
		_tmp2_ = _cairo_surface_reference0 ((cairo_surface_t*) _tmp1_);
#line 1328 "panel.vala"
		_cairo_surface_destroy0 (image);
#line 1328 "panel.vala"
		image = _tmp2_;
#line 1330 "panel.vala"
		_tmp3_ = image;
#line 1330 "panel.vala"
		if (_tmp3_ != NULL) {
#line 1331 "panel.vala"
			result = image;
#line 1331 "panel.vala"
			return result;
#line 7025 "panel.c"
		}
	}
#line 1334 "panel.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 48, 48);
#line 1334 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1334 "panel.vala"
	image = _tmp4_;
#line 1335 "panel.vala"
	_tmp5_ = image;
#line 1335 "panel.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 1335 "panel.vala"
	cr = _tmp6_;
#line 1336 "panel.vala"
	_tmp7_ = image;
#line 1336 "panel.vala"
	width = cairo_image_surface_get_width (_tmp7_);
#line 1337 "panel.vala"
	_tmp8_ = image;
#line 1337 "panel.vala"
	height = cairo_image_surface_get_height (_tmp8_);
#line 1338 "panel.vala"
	_tmp9_ = image;
#line 1338 "panel.vala"
	stride = cairo_image_surface_get_stride (_tmp9_);
#line 1340 "panel.vala"
	_tmp10_ = cr;
#line 1340 "panel.vala"
	cairo_set_source_rgba (_tmp10_, 0.0, 0.0, 0.0, 0.0);
#line 1341 "panel.vala"
	_tmp11_ = cr;
#line 1341 "panel.vala"
	cairo_set_operator (_tmp11_, CAIRO_OPERATOR_SOURCE);
#line 1342 "panel.vala"
	_tmp12_ = cr;
#line 1342 "panel.vala"
	cairo_paint (_tmp12_);
#line 1343 "panel.vala"
	_tmp13_ = cr;
#line 1343 "panel.vala"
	cairo_set_operator (_tmp13_, CAIRO_OPERATOR_OVER);
#line 1344 "panel.vala"
	_tmp14_ = cr;
#line 1344 "panel.vala"
	panel_context_render_string (self, _tmp14_, symbol, width, height);
#line 1345 "panel.vala"
	_tmp15_ = image;
#line 1345 "panel.vala"
	cairo_surface_flush (_tmp15_);
#line 1347 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 1348 "panel.vala"
		if (G_BYTE_ORDER == G_LITTLE_ENDIAN) {
#line 7080 "panel.c"
			guint* data = NULL;
			cairo_surface_t* _tmp16_;
			guchar* _tmp17_;
			gint data_length1;
			gint _data_size_;
			gint length = 0;
#line 1349 "panel.vala"
			_tmp16_ = image;
#line 1349 "panel.vala"
			_tmp17_ = cairo_image_surface_get_data (_tmp16_);
#line 1349 "panel.vala"
			data = (guint*) _tmp17_;
#line 1349 "panel.vala"
			data_length1 = (-1 * sizeof (guchar)) / sizeof (guint);
#line 1349 "panel.vala"
			_data_size_ = data_length1;
#line 1350 "panel.vala"
			length = (stride * height) / ((gint) sizeof (guint));
#line 7099 "panel.c"
			{
				gint i = 0;
#line 1351 "panel.vala"
				i = 0;
#line 7104 "panel.c"
				{
					gboolean _tmp18_ = FALSE;
#line 1351 "panel.vala"
					_tmp18_ = TRUE;
#line 1351 "panel.vala"
					while (TRUE) {
#line 7111 "panel.c"
						guint* _tmp20_;
						gint _tmp20__length1;
						guint* _tmp21_;
						gint _tmp21__length1;
						guint _tmp22_;
#line 1351 "panel.vala"
						if (!_tmp18_) {
#line 7119 "panel.c"
							gint _tmp19_;
#line 1351 "panel.vala"
							_tmp19_ = i;
#line 1351 "panel.vala"
							i = _tmp19_ + 1;
#line 7125 "panel.c"
						}
#line 1351 "panel.vala"
						_tmp18_ = FALSE;
#line 1351 "panel.vala"
						if (!(i < length)) {
#line 1351 "panel.vala"
							break;
#line 7133 "panel.c"
						}
#line 1352 "panel.vala"
						_tmp20_ = data;
#line 1352 "panel.vala"
						_tmp20__length1 = data_length1;
#line 1352 "panel.vala"
						_tmp21_ = data;
#line 1352 "panel.vala"
						_tmp21__length1 = data_length1;
#line 1352 "panel.vala"
						_tmp22_ = _tmp21_[i];
#line 1352 "panel.vala"
						_tmp20_[i] = GUINT_TO_BE (_tmp22_);
#line 7147 "panel.c"
					}
				}
			}
		}
	}
#line 1356 "panel.vala"
	if (cache) {
#line 7155 "panel.c"
		GHashTable* _tmp23_;
		gchar* _tmp24_;
		cairo_surface_t* _tmp25_;
		cairo_surface_t* _tmp26_;
#line 1357 "panel.vala"
		_tmp23_ = self->priv->m_xkb_icon_image;
#line 1357 "panel.vala"
		_tmp24_ = g_strdup (symbol);
#line 1357 "panel.vala"
		_tmp25_ = image;
#line 1357 "panel.vala"
		_tmp26_ = _cairo_surface_reference0 (_tmp25_);
#line 1357 "panel.vala"
		g_hash_table_insert (_tmp23_, _tmp24_, _tmp26_);
#line 7170 "panel.c"
	}
#line 1359 "panel.vala"
	result = image;
#line 1359 "panel.vala"
	_cairo_destroy0 (cr);
#line 1359 "panel.vala"
	return result;
#line 7178 "panel.c"
}

static GdkPixbuf*
panel_create_icon_pixbuf_with_string (Panel* self,
                                      const gchar* symbol)
{
	GdkPixbuf* pixbuf = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	gint width = 0;
	cairo_surface_t* _tmp5_;
	gint height = 0;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	GdkPixbuf* _tmp8_;
	GHashTable* _tmp9_;
	gchar* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* result;
#line 1362 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1362 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1363 "panel.vala"
	_tmp0_ = self->priv->m_xkb_icon_pixbufs;
#line 1363 "panel.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1363 "panel.vala"
	_tmp2_ = _g_object_ref0 ((GdkPixbuf*) _tmp1_);
#line 1363 "panel.vala"
	pixbuf = _tmp2_;
#line 1365 "panel.vala"
	_tmp3_ = pixbuf;
#line 1365 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1366 "panel.vala"
		result = pixbuf;
#line 1366 "panel.vala"
		return result;
#line 7223 "panel.c"
	}
#line 1368 "panel.vala"
	_tmp4_ = panel_create_cairo_image_surface_with_string (self, symbol, FALSE);
#line 1368 "panel.vala"
	image = _tmp4_;
#line 1369 "panel.vala"
	_tmp5_ = image;
#line 1369 "panel.vala"
	width = cairo_image_surface_get_width (_tmp5_);
#line 1370 "panel.vala"
	_tmp6_ = image;
#line 1370 "panel.vala"
	height = cairo_image_surface_get_height (_tmp6_);
#line 1371 "panel.vala"
	_tmp7_ = image;
#line 1371 "panel.vala"
	_tmp8_ = gdk_pixbuf_get_from_surface (_tmp7_, 0, 0, width, height);
#line 1371 "panel.vala"
	_g_object_unref0 (pixbuf);
#line 1371 "panel.vala"
	pixbuf = _tmp8_;
#line 1372 "panel.vala"
	_tmp9_ = self->priv->m_xkb_icon_pixbufs;
#line 1372 "panel.vala"
	_tmp10_ = g_strdup (symbol);
#line 1372 "panel.vala"
	_tmp11_ = pixbuf;
#line 1372 "panel.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1372 "panel.vala"
	g_hash_table_insert (_tmp9_, _tmp10_, _tmp12_);
#line 1373 "panel.vala"
	result = pixbuf;
#line 1373 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1373 "panel.vala"
	return result;
#line 7261 "panel.c"
}

static void
__lambda88_ (Panel* self,
             GPid pid,
             gint state)
{
#line 1397 "panel.vala"
	if (pid != self->priv->m_setup_pid) {
#line 1398 "panel.vala"
		return;
#line 7273 "panel.c"
	}
#line 1399 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 1400 "panel.vala"
	g_spawn_close_pid (pid);
#line 7279 "panel.c"
}

static void
___lambda88__gchild_watch_func (GPid pid,
                                gint wait_status,
                                gpointer self)
{
#line 1396 "panel.vala"
	__lambda88_ ((Panel*) self, pid, wait_status);
#line 7289 "panel.c"
}

static void
panel_show_setup_dialog (Panel* self)
{
	gchar* binary = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1376 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1377 "panel.vala"
	if (self->priv->m_setup_pid != ((GPid) 0)) {
#line 1378 "panel.vala"
		if (kill ((pid_t) self->priv->m_setup_pid, (gint) SIGUSR1) == 0) {
#line 1379 "panel.vala"
			return;
#line 7306 "panel.c"
		}
#line 1380 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 7310 "panel.c"
	}
#line 1383 "panel.vala"
	_tmp0_ = g_build_filename (BINDIR, "ibus-setup", NULL);
#line 1383 "panel.vala"
	binary = _tmp0_;
#line 7316 "panel.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		GPid _tmp6_ = 0;
#line 1385 "panel.vala"
		_tmp1_ = binary;
#line 1385 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1385 "panel.vala"
		_tmp3_ = g_strdup ("ibus-setup");
#line 1385 "panel.vala"
		_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 1385 "panel.vala"
		_tmp4_[0] = _tmp2_;
#line 1385 "panel.vala"
		_tmp4_[1] = _tmp3_;
#line 1385 "panel.vala"
		_tmp5_ = _tmp4_;
#line 1385 "panel.vala"
		_tmp5__length1 = 2;
#line 1385 "panel.vala"
		g_spawn_async (NULL, _tmp5_, NULL, G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp6_, &_inner_error0_);
#line 1385 "panel.vala"
		self->priv->m_setup_pid = _tmp6_;
#line 1385 "panel.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 1385 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1385 "panel.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 7351 "panel.c"
				goto __catch0_g_spawn_error;
			}
#line 1385 "panel.vala"
			_g_free0 (binary);
#line 1385 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1385 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 1385 "panel.vala"
			return;
#line 7362 "panel.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1384 "panel.vala"
		e = _inner_error0_;
#line 1384 "panel.vala"
		_inner_error0_ = NULL;
#line 1392 "panel.vala"
		_tmp7_ = binary;
#line 1392 "panel.vala"
		_tmp8_ = e;
#line 1392 "panel.vala"
		_tmp9_ = _tmp8_->message;
#line 1392 "panel.vala"
		g_warning ("panel.vala:1392: Execute %s failed! %s", _tmp7_, _tmp9_);
#line 1393 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 1384 "panel.vala"
		_g_error_free0 (e);
#line 7388 "panel.c"
	}
	__finally0:
#line 1384 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1384 "panel.vala"
		_g_free0 (binary);
#line 1384 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1384 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 1384 "panel.vala"
		return;
#line 7401 "panel.c"
	}
#line 1396 "panel.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->m_setup_pid, ___lambda88__gchild_watch_func, g_object_ref (self), g_object_unref);
#line 1376 "panel.vala"
	_g_free0 (binary);
#line 7407 "panel.c"
}

static void
panel_show_about_dialog (Panel* self)
{
	GtkAboutDialog* _tmp0_;
	GtkAboutDialog* _tmp21_;
#line 1404 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1405 "panel.vala"
	_tmp0_ = self->priv->m_about_dialog;
#line 1405 "panel.vala"
	if (_tmp0_ == NULL) {
#line 7421 "panel.c"
		GtkAboutDialog* _tmp1_;
		GtkAboutDialog* _tmp2_;
		GtkAboutDialog* _tmp3_;
		gchar* copyright = NULL;
		gchar* _tmp4_;
		GtkAboutDialog* _tmp5_;
		const gchar* _tmp6_;
		GtkAboutDialog* _tmp7_;
		GtkAboutDialog* _tmp8_;
		GtkAboutDialog* _tmp9_;
		GtkAboutDialog* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GtkAboutDialog* _tmp14_;
		gchar* _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		GtkAboutDialog* _tmp18_;
		GtkAboutDialog* _tmp19_;
		GtkAboutDialog* _tmp20_;
#line 1406 "panel.vala"
		_tmp1_ = (GtkAboutDialog*) gtk_about_dialog_new ();
#line 1406 "panel.vala"
		g_object_ref_sink (_tmp1_);
#line 1406 "panel.vala"
		_g_object_unref0 (self->priv->m_about_dialog);
#line 1406 "panel.vala"
		self->priv->m_about_dialog = _tmp1_;
#line 1407 "panel.vala"
		_tmp2_ = self->priv->m_about_dialog;
#line 1407 "panel.vala"
		gtk_about_dialog_set_program_name (_tmp2_, "IBus");
#line 1408 "panel.vala"
		_tmp3_ = self->priv->m_about_dialog;
#line 1408 "panel.vala"
		gtk_about_dialog_set_version (_tmp3_, PACKAGE_VERSION);
#line 1410 "panel.vala"
		_tmp4_ = g_strdup ("Copyright © 2007-2015 Peng Huang\n" "Copyright © 2015-2022 Takao Fujiwara\n" "Copyright © 2007-2015 Red Hat, Inc.\n");
#line 1410 "panel.vala"
		copyright = _tmp4_;
#line 1415 "panel.vala"
		_tmp5_ = self->priv->m_about_dialog;
#line 1415 "panel.vala"
		_tmp6_ = copyright;
#line 1415 "panel.vala"
		gtk_about_dialog_set_copyright (_tmp5_, _tmp6_);
#line 1416 "panel.vala"
		_tmp7_ = self->priv->m_about_dialog;
#line 1416 "panel.vala"
		gtk_about_dialog_set_license (_tmp7_, "LGPL");
#line 1417 "panel.vala"
		_tmp8_ = self->priv->m_about_dialog;
#line 1417 "panel.vala"
		gtk_about_dialog_set_comments (_tmp8_, _ ("IBus is an intelligent input bus for Linux/Unix."));
#line 1418 "panel.vala"
		_tmp9_ = self->priv->m_about_dialog;
#line 1418 "panel.vala"
		gtk_about_dialog_set_website (_tmp9_, "https://github.com/ibus/ibus/wiki");
#line 1419 "panel.vala"
		_tmp10_ = self->priv->m_about_dialog;
#line 1419 "panel.vala"
		_tmp11_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1419 "panel.vala"
		_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 1419 "panel.vala"
		_tmp12_[0] = _tmp11_;
#line 1419 "panel.vala"
		_tmp13_ = _tmp12_;
#line 1419 "panel.vala"
		_tmp13__length1 = 1;
#line 1419 "panel.vala"
		gtk_about_dialog_set_authors (_tmp10_, _tmp13_);
#line 1419 "panel.vala"
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 1420 "panel.vala"
		_tmp14_ = self->priv->m_about_dialog;
#line 1420 "panel.vala"
		_tmp15_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1420 "panel.vala"
		_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 1420 "panel.vala"
		_tmp16_[0] = _tmp15_;
#line 1420 "panel.vala"
		_tmp17_ = _tmp16_;
#line 1420 "panel.vala"
		_tmp17__length1 = 1;
#line 1420 "panel.vala"
		gtk_about_dialog_set_documenters (_tmp14_, _tmp17_);
#line 1420 "panel.vala"
		_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 1421 "panel.vala"
		_tmp18_ = self->priv->m_about_dialog;
#line 1421 "panel.vala"
		gtk_about_dialog_set_translator_credits (_tmp18_, _ ("translator-credits"));
#line 1422 "panel.vala"
		_tmp19_ = self->priv->m_about_dialog;
#line 1422 "panel.vala"
		gtk_about_dialog_set_logo_icon_name (_tmp19_, "ibus");
#line 1423 "panel.vala"
		_tmp20_ = self->priv->m_about_dialog;
#line 1423 "panel.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp20_, "ibus");
#line 1405 "panel.vala"
		_g_free0 (copyright);
#line 7529 "panel.c"
	}
#line 1426 "panel.vala"
	_tmp21_ = self->priv->m_about_dialog;
#line 1426 "panel.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) _tmp21_)) {
#line 7535 "panel.c"
		GtkAboutDialog* _tmp22_;
		GtkAboutDialog* _tmp23_;
#line 1427 "panel.vala"
		_tmp22_ = self->priv->m_about_dialog;
#line 1427 "panel.vala"
		gtk_dialog_run ((GtkDialog*) _tmp22_);
#line 1428 "panel.vala"
		_tmp23_ = self->priv->m_about_dialog;
#line 1428 "panel.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 7546 "panel.c"
	} else {
		GtkAboutDialog* _tmp24_;
#line 1430 "panel.vala"
		_tmp24_ = self->priv->m_about_dialog;
#line 1430 "panel.vala"
		gtk_window_present ((GtkWindow*) _tmp24_);
#line 7553 "panel.c"
	}
}

static void
_vala_array_add25 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1438 "panel.vala"
	if ((*length) == (*size)) {
#line 1438 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1438 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7569 "panel.c"
	}
#line 1438 "panel.vala"
	(*array)[(*length)++] = value;
#line 1438 "panel.vala"
	(*array)[*length] = NULL;
#line 7575 "panel.c"
}

static void
_vala_array_add26 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1439 "panel.vala"
	if ((*length) == (*size)) {
#line 1439 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1439 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7590 "panel.c"
	}
#line 1439 "panel.vala"
	(*array)[(*length)++] = value;
#line 1439 "panel.vala"
	(*array)[*length] = NULL;
#line 7596 "panel.c"
}

static void
_vala_array_add27 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1441 "panel.vala"
	if ((*length) == (*size)) {
#line 1441 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1441 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7611 "panel.c"
	}
#line 1441 "panel.vala"
	(*array)[(*length)++] = value;
#line 1441 "panel.vala"
	(*array)[*length] = NULL;
#line 7617 "panel.c"
}

static void
panel_run_ibus_command (Panel* self,
                        const gchar* args)
{
	gchar* binary = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1434 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1434 "panel.vala"
	g_return_if_fail (args != NULL);
#line 1435 "panel.vala"
	_tmp0_ = g_build_filename (BINDIR, "ibus", NULL);
#line 1435 "panel.vala"
	binary = _tmp0_;
#line 7635 "panel.c"
	{
		gchar** _args = NULL;
		gchar** _tmp1_;
		gint _args_length1;
		gint __args_size_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gchar* standard_out = NULL;
		gchar* standard_error = NULL;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		const gchar* _tmp13_;
		const gchar* _tmp15_;
#line 1437 "panel.vala"
		_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 1437 "panel.vala"
		_args = _tmp1_;
#line 1437 "panel.vala"
		_args_length1 = 0;
#line 1437 "panel.vala"
		__args_size_ = _args_length1;
#line 1438 "panel.vala"
		_tmp2_ = binary;
#line 1438 "panel.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 1438 "panel.vala"
		_vala_array_add25 (&_args, &_args_length1, &__args_size_, _tmp3_);
#line 1439 "panel.vala"
		_tmp4_ = g_strdup (args);
#line 1439 "panel.vala"
		_vala_array_add26 (&_args, &_args_length1, &__args_size_, _tmp4_);
#line 1440 "panel.vala"
		if (g_strcmp0 (args, "exit") == 0) {
#line 1440 "panel.vala"
			_tmp5_ = TRUE;
#line 7679 "panel.c"
		} else {
#line 1440 "panel.vala"
			_tmp5_ = g_strcmp0 (args, "restart") == 0;
#line 7683 "panel.c"
		}
#line 1440 "panel.vala"
		if (_tmp5_) {
#line 7687 "panel.c"
			gchar* _tmp6_;
#line 1441 "panel.vala"
			_tmp6_ = g_strdup ("--type=kde-wayland");
#line 1441 "panel.vala"
			_vala_array_add27 (&_args, &_args_length1, &__args_size_, _tmp6_);
#line 7693 "panel.c"
		}
#line 1442 "panel.vala"
		standard_out = NULL;
#line 1443 "panel.vala"
		standard_error = NULL;
#line 1444 "panel.vala"
		_tmp7_ = _args;
#line 1444 "panel.vala"
		_tmp7__length1 = _args_length1;
#line 1444 "panel.vala"
		_tmp9_ = _tmp8_ = g_get_environ ();
#line 1444 "panel.vala"
		_tmp10_ = _tmp9_;
#line 1444 "panel.vala"
		_tmp10__length1 = _vala_array_length (_tmp8_);
#line 1444 "panel.vala"
		g_spawn_sync (NULL, _tmp7_, _tmp10_, 0, NULL, NULL, &_tmp11_, &_tmp12_, NULL, &_inner_error0_);
#line 1444 "panel.vala"
		_g_free0 (standard_out);
#line 1444 "panel.vala"
		standard_out = _tmp11_;
#line 1444 "panel.vala"
		_g_free0 (standard_error);
#line 1444 "panel.vala"
		standard_error = _tmp12_;
#line 1444 "panel.vala"
		_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 1444 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1444 "panel.vala"
			_g_free0 (standard_error);
#line 1444 "panel.vala"
			_g_free0 (standard_out);
#line 1444 "panel.vala"
			_args = (_vala_array_free (_args, _args_length1, (GDestroyNotify) g_free), NULL);
#line 1444 "panel.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 7731 "panel.c"
				goto __catch0_g_spawn_error;
			}
#line 1444 "panel.vala"
			_g_free0 (binary);
#line 1444 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1444 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 1444 "panel.vala"
			return;
#line 7742 "panel.c"
		}
#line 1452 "panel.vala"
		_tmp13_ = standard_out;
#line 1452 "panel.vala"
		if (_tmp13_ != NULL) {
#line 7748 "panel.c"
			const gchar* _tmp14_;
#line 1453 "panel.vala"
			_tmp14_ = standard_out;
#line 1453 "panel.vala"
			g_print ("%s", _tmp14_);
#line 7754 "panel.c"
		}
#line 1454 "panel.vala"
		_tmp15_ = standard_error;
#line 1454 "panel.vala"
		if (_tmp15_ != NULL) {
#line 7760 "panel.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 1455 "panel.vala"
			_tmp16_ = binary;
#line 1455 "panel.vala"
			_tmp17_ = standard_error;
#line 1455 "panel.vala"
			g_warning ("panel.vala:1455: Execute %s failed! %s", _tmp16_, _tmp17_);
#line 7769 "panel.c"
		}
#line 1436 "panel.vala"
		_g_free0 (standard_error);
#line 1436 "panel.vala"
		_g_free0 (standard_out);
#line 1436 "panel.vala"
		_args = (_vala_array_free (_args, _args_length1, (GDestroyNotify) g_free), NULL);
#line 7777 "panel.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 1436 "panel.vala"
		e = _inner_error0_;
#line 1436 "panel.vala"
		_inner_error0_ = NULL;
#line 1457 "panel.vala"
		_tmp18_ = binary;
#line 1457 "panel.vala"
		_tmp19_ = e;
#line 1457 "panel.vala"
		_tmp20_ = _tmp19_->message;
#line 1457 "panel.vala"
		g_warning ("panel.vala:1457: Execute %s failed! %s", _tmp18_, _tmp20_);
#line 1436 "panel.vala"
		_g_error_free0 (e);
#line 7800 "panel.c"
	}
	__finally0:
#line 1436 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1436 "panel.vala"
		_g_free0 (binary);
#line 1436 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1436 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 1436 "panel.vala"
		return;
#line 7813 "panel.c"
	}
#line 1434 "panel.vala"
	_g_free0 (binary);
#line 7817 "panel.c"
}

static void
__lambda87_ (Panel* self,
             GtkMenuItem* i)
{
#line 1463 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1463 "panel.vala"
	panel_show_setup_dialog (self);
#line 7828 "panel.c"
}

static void
___lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1463 "panel.vala"
	__lambda87_ ((Panel*) self, _sender);
#line 7837 "panel.c"
}

static void
panel_append_preferences_menu (Panel* self,
                               GtkMenu* menu)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
#line 1461 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1461 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 1462 "panel.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Preferences"));
#line 1462 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1462 "panel.vala"
	item = _tmp0_;
#line 1463 "panel.vala"
	g_signal_connect_object (item, "activate", (GCallback) ___lambda87__gtk_menu_item_activate, self, 0);
#line 1465 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, (GtkWidget*) item, -1);
#line 1461 "panel.vala"
	_g_object_unref0 (item);
#line 7862 "panel.c"
}

static void
__lambda89_ (Panel* self,
             GtkMenuItem* i)
{
	IBusExtensionEvent* event = NULL;
	IBusExtensionEvent* _tmp0_;
	IBusExtensionEvent* _tmp1_;
#line 1471 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1472 "panel.vala"
	_tmp0_ = ibus_extension_event_new ("name", "emoji", "is-enabled", TRUE, "params", "category-list", NULL);
#line 1472 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1472 "panel.vala"
	event = _tmp0_;
#line 1480 "panel.vala"
	_tmp1_ = _g_object_ref0 (event);
#line 1480 "panel.vala"
	ibus_panel_service_panel_extension ((IBusPanelService*) self, _tmp1_);
#line 1471 "panel.vala"
	_g_object_unref0 (event);
#line 7886 "panel.c"
}

static void
___lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1471 "panel.vala"
	__lambda89_ ((Panel*) self, _sender);
#line 7895 "panel.c"
}

static void
panel_append_emoji_menu (Panel* self,
                         GtkMenu* menu)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
#line 1468 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1468 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 1470 "panel.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Emoji Choice"));
#line 1470 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1470 "panel.vala"
	item = _tmp0_;
#line 1471 "panel.vala"
	g_signal_connect_object (item, "activate", (GCallback) ___lambda89__gtk_menu_item_activate, self, 0);
#line 1483 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, (GtkWidget*) item, -1);
#line 1468 "panel.vala"
	_g_object_unref0 (item);
#line 7920 "panel.c"
}

static void
__lambda90_ (Panel* self,
             GtkMenuItem* i)
{
#line 1510 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1510 "panel.vala"
	panel_show_about_dialog (self);
#line 7931 "panel.c"
}

static void
___lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1510 "panel.vala"
	__lambda90_ ((Panel*) self, _sender);
#line 7940 "panel.c"
}

static void
__lambda91_ (Panel* self,
             GtkMenuItem* i)
{
	gboolean _tmp0_ = FALSE;
#line 1516 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1517 "panel.vala"
	if (self->priv->m_is_kde) {
#line 1517 "panel.vala"
		_tmp0_ = !binding_common_default_is_xdisplay ();
#line 7954 "panel.c"
	} else {
#line 1517 "panel.vala"
		_tmp0_ = FALSE;
#line 7958 "panel.c"
	}
#line 1517 "panel.vala"
	if (_tmp0_) {
#line 1518 "panel.vala"
		panel_run_ibus_command (self, "restart");
#line 7964 "panel.c"
	} else {
		IBusBus* _tmp1_;
#line 1520 "panel.vala"
		_tmp1_ = self->priv->m_bus;
#line 1520 "panel.vala"
		ibus_bus_exit (_tmp1_, TRUE);
#line 7971 "panel.c"
	}
}

static void
___lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1516 "panel.vala"
	__lambda91_ ((Panel*) self, _sender);
#line 7981 "panel.c"
}

static void
__lambda92_ (Panel* self,
             GtkMenuItem* i)
{
	gboolean _tmp0_ = FALSE;
#line 1525 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1526 "panel.vala"
	if (self->priv->m_is_kde) {
#line 1526 "panel.vala"
		_tmp0_ = !binding_common_default_is_xdisplay ();
#line 7995 "panel.c"
	} else {
#line 1526 "panel.vala"
		_tmp0_ = FALSE;
#line 7999 "panel.c"
	}
#line 1526 "panel.vala"
	if (_tmp0_) {
#line 1527 "panel.vala"
		panel_run_ibus_command (self, "exit");
#line 8005 "panel.c"
	} else {
		IBusBus* _tmp1_;
#line 1529 "panel.vala"
		_tmp1_ = self->priv->m_bus;
#line 1529 "panel.vala"
		ibus_bus_exit (_tmp1_, FALSE);
#line 8012 "panel.c"
	}
}

static void
___lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1525 "panel.vala"
	__lambda92_ ((Panel*) self, _sender);
#line 8022 "panel.c"
}

static GtkMenu*
panel_create_context_menu (Panel* self,
                           gboolean use_x11)
{
	GtkMenu* _tmp0_;
	GdkDisplay* display_backup = NULL;
	gboolean _tmp3_ = FALSE;
	GtkMenuItem* item = NULL;
	GtkMenu* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenu* _tmp17_;
	GtkSeparatorMenuItem* _tmp18_;
	GtkSeparatorMenuItem* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenu* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenu* _tmp28_;
	GdkDisplay* _tmp29_;
	GtkMenu* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenu* result;
#line 1488 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "panel.vala"
	_tmp0_ = self->priv->m_sys_menu;
#line 1489 "panel.vala"
	if (_tmp0_ != NULL) {
#line 8062 "panel.c"
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 1490 "panel.vala"
		_tmp1_ = self->priv->m_sys_menu;
#line 1490 "panel.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1490 "panel.vala"
		result = _tmp2_;
#line 1490 "panel.vala"
		return result;
#line 8073 "panel.c"
	}
#line 1492 "panel.vala"
	display_backup = NULL;
#line 1493 "panel.vala"
	if (use_x11) {
#line 1493 "panel.vala"
		_tmp3_ = !binding_common_default_is_xdisplay ();
#line 8081 "panel.c"
	} else {
#line 1493 "panel.vala"
		_tmp3_ = FALSE;
#line 8085 "panel.c"
	}
#line 1493 "panel.vala"
	if (_tmp3_) {
#line 8089 "panel.c"
		GdkX11Display* display = NULL;
		GdkX11Display* _tmp4_;
		GdkDisplay* _tmp5_;
		GdkDisplay* _tmp6_;
		GdkX11Display* _tmp7_;
#line 1494 "panel.vala"
		_tmp4_ = binding_common_get_xdisplay (FALSE);
#line 1494 "panel.vala"
		display = _tmp4_;
#line 1495 "panel.vala"
		_tmp5_ = gdk_display_get_default ();
#line 1495 "panel.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1495 "panel.vala"
		_g_object_unref0 (display_backup);
#line 1495 "panel.vala"
		display_backup = _tmp6_;
#line 1496 "panel.vala"
		_tmp7_ = display;
#line 1496 "panel.vala"
		if (_tmp7_ != NULL) {
#line 8111 "panel.c"
			GdkDisplayManager* _tmp8_;
			GdkX11Display* _tmp9_;
#line 1497 "panel.vala"
			_tmp8_ = gdk_display_manager_get ();
#line 1497 "panel.vala"
			_tmp9_ = display;
#line 1497 "panel.vala"
			gdk_display_manager_set_default_display (_tmp8_, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gdk_display_get_type (), GdkDisplay));
#line 8120 "panel.c"
		}
#line 1493 "panel.vala"
		_g_object_unref0 (display);
#line 8124 "panel.c"
	}
#line 1504 "panel.vala"
	_tmp10_ = (GtkMenu*) gtk_menu_new ();
#line 1504 "panel.vala"
	g_object_ref_sink (_tmp10_);
#line 1504 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 1504 "panel.vala"
	self->priv->m_sys_menu = _tmp10_;
#line 1506 "panel.vala"
	_tmp11_ = self->priv->m_sys_menu;
#line 1506 "panel.vala"
	panel_append_preferences_menu (self, _tmp11_);
#line 1507 "panel.vala"
	_tmp12_ = self->priv->m_sys_menu;
#line 1507 "panel.vala"
	panel_append_emoji_menu (self, _tmp12_);
#line 1509 "panel.vala"
	_tmp13_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("About"));
#line 1509 "panel.vala"
	g_object_ref_sink (_tmp13_);
#line 1509 "panel.vala"
	_g_object_unref0 (item);
#line 1509 "panel.vala"
	item = _tmp13_;
#line 1510 "panel.vala"
	_tmp14_ = item;
#line 1510 "panel.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) ___lambda90__gtk_menu_item_activate, self, 0);
#line 1511 "panel.vala"
	_tmp15_ = self->priv->m_sys_menu;
#line 1511 "panel.vala"
	_tmp16_ = item;
#line 1511 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp15_, (GtkWidget*) _tmp16_, -1);
#line 1513 "panel.vala"
	_tmp17_ = self->priv->m_sys_menu;
#line 1513 "panel.vala"
	_tmp18_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1513 "panel.vala"
	g_object_ref_sink (_tmp18_);
#line 1513 "panel.vala"
	_tmp19_ = _tmp18_;
#line 1513 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp17_, (GtkWidget*) _tmp19_, -1);
#line 1513 "panel.vala"
	_g_object_unref0 (_tmp19_);
#line 1515 "panel.vala"
	_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restart"));
#line 1515 "panel.vala"
	g_object_ref_sink (_tmp20_);
#line 1515 "panel.vala"
	_g_object_unref0 (item);
#line 1515 "panel.vala"
	item = _tmp20_;
#line 1516 "panel.vala"
	_tmp21_ = item;
#line 1516 "panel.vala"
	g_signal_connect_object (_tmp21_, "activate", (GCallback) ___lambda91__gtk_menu_item_activate, self, 0);
#line 1522 "panel.vala"
	_tmp22_ = self->priv->m_sys_menu;
#line 1522 "panel.vala"
	_tmp23_ = item;
#line 1522 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp22_, (GtkWidget*) _tmp23_, -1);
#line 1524 "panel.vala"
	_tmp24_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Quit"));
#line 1524 "panel.vala"
	g_object_ref_sink (_tmp24_);
#line 1524 "panel.vala"
	_g_object_unref0 (item);
#line 1524 "panel.vala"
	item = _tmp24_;
#line 1525 "panel.vala"
	_tmp25_ = item;
#line 1525 "panel.vala"
	g_signal_connect_object (_tmp25_, "activate", (GCallback) ___lambda92__gtk_menu_item_activate, self, 0);
#line 1531 "panel.vala"
	_tmp26_ = self->priv->m_sys_menu;
#line 1531 "panel.vala"
	_tmp27_ = item;
#line 1531 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp26_, (GtkWidget*) _tmp27_, -1);
#line 1533 "panel.vala"
	_tmp28_ = self->priv->m_sys_menu;
#line 1533 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
#line 1535 "panel.vala"
	_tmp29_ = display_backup;
#line 1535 "panel.vala"
	if (_tmp29_ != NULL) {
#line 8216 "panel.c"
		GdkDisplayManager* _tmp30_;
		GdkDisplay* _tmp31_;
#line 1536 "panel.vala"
		_tmp30_ = gdk_display_manager_get ();
#line 1536 "panel.vala"
		_tmp31_ = display_backup;
#line 1536 "panel.vala"
		gdk_display_manager_set_default_display (_tmp30_, _tmp31_);
#line 8225 "panel.c"
	}
#line 1538 "panel.vala"
	_tmp32_ = self->priv->m_sys_menu;
#line 1538 "panel.vala"
	_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1538 "panel.vala"
	result = _tmp33_;
#line 1538 "panel.vala"
	_g_object_unref0 (item);
#line 1538 "panel.vala"
	_g_object_unref0 (display_backup);
#line 1538 "panel.vala"
	return result;
#line 8239 "panel.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1560 "panel.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1560 "panel.vala"
	return _data10_;
#line 8249 "panel.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1560 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 8259 "panel.c"
		Panel* self;
#line 1560 "panel.vala"
		self = _data10_->self;
#line 1560 "panel.vala"
		_g_object_unref0 (_data10_->e);
#line 1560 "panel.vala"
		_g_object_unref0 (self);
#line 1560 "panel.vala"
		g_slice_free (Block10Data, _data10_);
#line 8269 "panel.c"
	}
}

static void
____lambda93_ (Block10Data* _data10_,
               GtkMenuItem* item)
{
	Panel* self;
#line 1570 "panel.vala"
	self = _data10_->self;
#line 1570 "panel.vala"
	g_return_if_fail (item != NULL);
#line 8282 "panel.c"
	{
		gint i = 0;
#line 1571 "panel.vala"
		i = 0;
#line 8287 "panel.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1571 "panel.vala"
			_tmp0_ = TRUE;
#line 1571 "panel.vala"
			while (TRUE) {
#line 8294 "panel.c"
				IBusEngineDesc** _tmp2_;
				gint _tmp2__length1;
				IBusEngineDesc* _tmp3_;
				IBusEngineDesc** _tmp4_;
				gint _tmp4__length1;
				IBusEngineDesc* _tmp5_;
#line 1571 "panel.vala"
				if (!_tmp0_) {
#line 8303 "panel.c"
					gint _tmp1_;
#line 1571 "panel.vala"
					_tmp1_ = i;
#line 1571 "panel.vala"
					i = _tmp1_ + 1;
#line 8309 "panel.c"
				}
#line 1571 "panel.vala"
				_tmp0_ = FALSE;
#line 1571 "panel.vala"
				_tmp2_ = self->priv->m_engines;
#line 1571 "panel.vala"
				_tmp2__length1 = self->priv->m_engines_length1;
#line 1571 "panel.vala"
				if (!(i < _tmp2__length1)) {
#line 1571 "panel.vala"
					break;
#line 8321 "panel.c"
				}
#line 1572 "panel.vala"
				_tmp3_ = _data10_->e;
#line 1572 "panel.vala"
				_tmp4_ = self->priv->m_engines;
#line 1572 "panel.vala"
				_tmp4__length1 = self->priv->m_engines_length1;
#line 1572 "panel.vala"
				_tmp5_ = _tmp4_[i];
#line 1572 "panel.vala"
				if (_tmp3_ == _tmp5_) {
#line 1573 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1574 "panel.vala"
					break;
#line 8337 "panel.c"
				}
			}
		}
	}
}

static void
_____lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 1570 "panel.vala"
	____lambda93_ (self, _sender);
#line 8350 "panel.c"
}

static GtkMenu*
panel_create_activate_menu (Panel* self,
                            gboolean use_x11)
{
	GdkDisplay* display_backup = NULL;
	gboolean _tmp0_ = FALSE;
	GtkMenu* _tmp7_;
	PropertyManager* _tmp8_;
	GtkMenu* _tmp9_;
	GtkMenu* _tmp10_;
	GtkSeparatorMenuItem* _tmp11_;
	GtkSeparatorMenuItem* _tmp12_;
	IBusEngineDesc** _tmp13_;
	gint _tmp13__length1;
	GtkMenu* _tmp45_;
	GtkMenu* _tmp46_;
	GdkDisplay* _tmp47_;
	GtkMenu* _tmp50_;
	GtkMenu* _tmp51_;
	GtkMenu* result;
#line 1541 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "panel.vala"
	display_backup = NULL;
#line 1543 "panel.vala"
	if (use_x11) {
#line 1543 "panel.vala"
		_tmp0_ = !binding_common_default_is_xdisplay ();
#line 8381 "panel.c"
	} else {
#line 1543 "panel.vala"
		_tmp0_ = FALSE;
#line 8385 "panel.c"
	}
#line 1543 "panel.vala"
	if (_tmp0_) {
#line 8389 "panel.c"
		GdkX11Display* display = NULL;
		GdkX11Display* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkDisplay* _tmp3_;
		GdkX11Display* _tmp4_;
#line 1544 "panel.vala"
		_tmp1_ = binding_common_get_xdisplay (FALSE);
#line 1544 "panel.vala"
		display = _tmp1_;
#line 1545 "panel.vala"
		_tmp2_ = gdk_display_get_default ();
#line 1545 "panel.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1545 "panel.vala"
		_g_object_unref0 (display_backup);
#line 1545 "panel.vala"
		display_backup = _tmp3_;
#line 1546 "panel.vala"
		_tmp4_ = display;
#line 1546 "panel.vala"
		if (_tmp4_ != NULL) {
#line 8411 "panel.c"
			GdkDisplayManager* _tmp5_;
			GdkX11Display* _tmp6_;
#line 1547 "panel.vala"
			_tmp5_ = gdk_display_manager_get ();
#line 1547 "panel.vala"
			_tmp6_ = display;
#line 1547 "panel.vala"
			gdk_display_manager_set_default_display (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gdk_display_get_type (), GdkDisplay));
#line 8420 "panel.c"
		}
#line 1543 "panel.vala"
		_g_object_unref0 (display);
#line 8424 "panel.c"
	}
#line 1551 "panel.vala"
	_tmp7_ = (GtkMenu*) gtk_menu_new ();
#line 1551 "panel.vala"
	g_object_ref_sink (_tmp7_);
#line 1551 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 1551 "panel.vala"
	self->priv->m_ime_menu = _tmp7_;
#line 1554 "panel.vala"
	_tmp8_ = self->priv->m_property_manager;
#line 1554 "panel.vala"
	_tmp9_ = self->priv->m_ime_menu;
#line 1554 "panel.vala"
	property_manager_create_menu_items (_tmp8_, _tmp9_);
#line 1557 "panel.vala"
	_tmp10_ = self->priv->m_ime_menu;
#line 1557 "panel.vala"
	_tmp11_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1557 "panel.vala"
	g_object_ref_sink (_tmp11_);
#line 1557 "panel.vala"
	_tmp12_ = _tmp11_;
#line 1557 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp10_, (GtkWidget*) _tmp12_, -1);
#line 1557 "panel.vala"
	_g_object_unref0 (_tmp12_);
#line 1560 "panel.vala"
	_tmp13_ = self->priv->m_engines;
#line 1560 "panel.vala"
	_tmp13__length1 = self->priv->m_engines_length1;
#line 8456 "panel.c"
	{
		IBusEngineDesc** engine_collection = NULL;
		gint engine_collection_length1 = 0;
		gint _engine_collection_size_ = 0;
		gint engine_it = 0;
#line 1560 "panel.vala"
		engine_collection = _tmp13_;
#line 1560 "panel.vala"
		engine_collection_length1 = _tmp13__length1;
#line 1560 "panel.vala"
		for (engine_it = 0; engine_it < engine_collection_length1; engine_it = engine_it + 1) {
#line 8468 "panel.c"
			IBusEngineDesc* _tmp14_;
			IBusEngineDesc* engine = NULL;
#line 1560 "panel.vala"
			_tmp14_ = _g_object_ref0 (engine_collection[engine_it]);
#line 1560 "panel.vala"
			engine = _tmp14_;
#line 8475 "panel.c"
			{
				Block10Data* _data10_;
				gchar* language = NULL;
				IBusEngineDesc* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* longname = NULL;
				IBusEngineDesc* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* textdomain = NULL;
				IBusEngineDesc* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* transname = NULL;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				GtkMenuItem* item = NULL;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				GtkMenuItem* _tmp33_;
				GtkMenuItem* _tmp34_;
				IBusEngineDesc* _tmp35_;
				IBusEngineDesc* _tmp36_;
				GtkMenuItem* _tmp37_;
				GtkMenu* _tmp38_;
				GtkMenuItem* _tmp39_;
#line 1560 "panel.vala"
				_data10_ = g_slice_new0 (Block10Data);
#line 1560 "panel.vala"
				_data10_->_ref_count_ = 1;
#line 1560 "panel.vala"
				_data10_->self = g_object_ref (self);
#line 1561 "panel.vala"
				_tmp15_ = engine;
#line 1561 "panel.vala"
				_tmp16_ = ibus_engine_desc_get_language (_tmp15_);
#line 1561 "panel.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 1561 "panel.vala"
				language = _tmp17_;
#line 1562 "panel.vala"
				_tmp18_ = engine;
#line 1562 "panel.vala"
				_tmp19_ = ibus_engine_desc_get_longname (_tmp18_);
#line 1562 "panel.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 1562 "panel.vala"
				longname = _tmp20_;
#line 1563 "panel.vala"
				_tmp21_ = engine;
#line 1563 "panel.vala"
				_tmp22_ = ibus_engine_desc_get_textdomain (_tmp21_);
#line 1563 "panel.vala"
				_tmp23_ = g_strdup (_tmp22_);
#line 1563 "panel.vala"
				textdomain = _tmp23_;
#line 1564 "panel.vala"
				_tmp24_ = textdomain;
#line 1564 "panel.vala"
				_tmp25_ = longname;
#line 1564 "panel.vala"
				_tmp26_ = g_strdup (g_dgettext (_tmp24_, _tmp25_));
#line 1564 "panel.vala"
				transname = _tmp26_;
#line 1565 "panel.vala"
				_tmp27_ = language;
#line 1565 "panel.vala"
				_tmp28_ = ibus_get_language_name (_tmp27_);
#line 1565 "panel.vala"
				_tmp29_ = _tmp28_;
#line 1565 "panel.vala"
				_tmp30_ = transname;
#line 1565 "panel.vala"
				_tmp31_ = g_strdup_printf ("%s - %s", _tmp29_, _tmp30_);
#line 1565 "panel.vala"
				_tmp32_ = _tmp31_;
#line 1565 "panel.vala"
				_tmp33_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp32_);
#line 1565 "panel.vala"
				g_object_ref_sink (_tmp33_);
#line 1565 "panel.vala"
				_tmp34_ = _tmp33_;
#line 1565 "panel.vala"
				_g_free0 (_tmp32_);
#line 1565 "panel.vala"
				_g_free0 (_tmp29_);
#line 1565 "panel.vala"
				item = _tmp34_;
#line 1569 "panel.vala"
				_tmp35_ = engine;
#line 1569 "panel.vala"
				_tmp36_ = _g_object_ref0 (_tmp35_);
#line 1569 "panel.vala"
				_data10_->e = _tmp36_;
#line 1570 "panel.vala"
				_tmp37_ = item;
#line 1570 "panel.vala"
				g_signal_connect_data (_tmp37_, "activate", (GCallback) _____lambda93__gtk_menu_item_activate, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 1578 "panel.vala"
				_tmp38_ = self->priv->m_ime_menu;
#line 1578 "panel.vala"
				_tmp39_ = item;
#line 1578 "panel.vala"
				gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 1560 "panel.vala"
				_g_object_unref0 (item);
#line 1560 "panel.vala"
				_g_free0 (transname);
#line 1560 "panel.vala"
				_g_free0 (textdomain);
#line 1560 "panel.vala"
				_g_free0 (longname);
#line 1560 "panel.vala"
				_g_free0 (language);
#line 1560 "panel.vala"
				_g_object_unref0 (engine);
#line 1560 "panel.vala"
				block10_data_unref (_data10_);
#line 1560 "panel.vala"
				_data10_ = NULL;
#line 8602 "panel.c"
			}
		}
	}
#line 1582 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 8608 "panel.c"
		GtkMenu* _tmp40_;
		GtkSeparatorMenuItem* _tmp41_;
		GtkSeparatorMenuItem* _tmp42_;
		GtkMenu* _tmp43_;
		GtkMenu* _tmp44_;
#line 1583 "panel.vala"
		_tmp40_ = self->priv->m_ime_menu;
#line 1583 "panel.vala"
		_tmp41_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1583 "panel.vala"
		g_object_ref_sink (_tmp41_);
#line 1583 "panel.vala"
		_tmp42_ = _tmp41_;
#line 1583 "panel.vala"
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp40_, (GtkWidget*) _tmp42_, -1);
#line 1583 "panel.vala"
		_g_object_unref0 (_tmp42_);
#line 1584 "panel.vala"
		_tmp43_ = self->priv->m_ime_menu;
#line 1584 "panel.vala"
		panel_append_preferences_menu (self, _tmp43_);
#line 1585 "panel.vala"
		_tmp44_ = self->priv->m_ime_menu;
#line 1585 "panel.vala"
		panel_append_emoji_menu (self, _tmp44_);
#line 8634 "panel.c"
	}
#line 1589 "panel.vala"
	_tmp45_ = self->priv->m_ime_menu;
#line 1589 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp45_);
#line 1592 "panel.vala"
	_tmp46_ = self->priv->m_ime_menu;
#line 1592 "panel.vala"
	gtk_menu_shell_set_take_focus ((GtkMenuShell*) _tmp46_, FALSE);
#line 1594 "panel.vala"
	_tmp47_ = display_backup;
#line 1594 "panel.vala"
	if (_tmp47_ != NULL) {
#line 8648 "panel.c"
		GdkDisplayManager* _tmp48_;
		GdkDisplay* _tmp49_;
#line 1595 "panel.vala"
		_tmp48_ = gdk_display_manager_get ();
#line 1595 "panel.vala"
		_tmp49_ = display_backup;
#line 1595 "panel.vala"
		gdk_display_manager_set_default_display (_tmp48_, _tmp49_);
#line 8657 "panel.c"
	}
#line 1596 "panel.vala"
	_tmp50_ = self->priv->m_ime_menu;
#line 1596 "panel.vala"
	_tmp51_ = _g_object_ref0 (_tmp50_);
#line 1596 "panel.vala"
	result = _tmp51_;
#line 1596 "panel.vala"
	_g_object_unref0 (display_backup);
#line 1596 "panel.vala"
	return result;
#line 8669 "panel.c"
}

static void
panel_set_properties (Panel* self,
                      IBusPropList* props)
{
	gint i = 0;
#line 1599 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1599 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1600 "panel.vala"
	i = 0;
#line 1601 "panel.vala"
	while (TRUE) {
#line 8685 "panel.c"
		IBusProperty* prop = NULL;
		IBusProperty* _tmp0_;
		IBusProperty* _tmp1_;
		IBusProperty* _tmp2_;
		IBusProperty* _tmp3_;
		gint _tmp4_;
#line 1602 "panel.vala"
		_tmp0_ = ibus_prop_list_get (props, (guint) i);
#line 1602 "panel.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1602 "panel.vala"
		prop = _tmp1_;
#line 1603 "panel.vala"
		_tmp2_ = prop;
#line 1603 "panel.vala"
		if (_tmp2_ == NULL) {
#line 1604 "panel.vala"
			_g_object_unref0 (prop);
#line 1604 "panel.vala"
			break;
#line 8706 "panel.c"
		}
#line 1605 "panel.vala"
		_tmp3_ = ibus_prop_list_get (props, (guint) i);
#line 1605 "panel.vala"
		panel_set_property (self, _tmp3_, TRUE);
#line 1606 "panel.vala"
		_tmp4_ = i;
#line 1606 "panel.vala"
		i = _tmp4_ + 1;
#line 1601 "panel.vala"
		_g_object_unref0 (prop);
#line 8718 "panel.c"
	}
}

static void
panel_set_property (Panel* self,
                    IBusProperty* prop,
                    gboolean all_update)
{
	gchar* symbol = NULL;
	IBusText* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 1610 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1610 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1611 "panel.vala"
	_tmp0_ = ibus_property_get_symbol (prop);
#line 1611 "panel.vala"
	_tmp1_ = ibus_text_get_text (_tmp0_);
#line 1611 "panel.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1611 "panel.vala"
	symbol = _tmp2_;
#line 1613 "panel.vala"
	_tmp5_ = self->priv->m_icon_prop_key;
#line 1613 "panel.vala"
	if (g_strcmp0 (_tmp5_, "") != 0) {
#line 8750 "panel.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1613 "panel.vala"
		_tmp6_ = ibus_property_get_key (prop);
#line 1613 "panel.vala"
		_tmp7_ = self->priv->m_icon_prop_key;
#line 1613 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 8759 "panel.c"
	} else {
#line 1613 "panel.vala"
		_tmp4_ = FALSE;
#line 8763 "panel.c"
	}
#line 1613 "panel.vala"
	if (_tmp4_) {
#line 8767 "panel.c"
		const gchar* _tmp8_;
#line 1614 "panel.vala"
		_tmp8_ = symbol;
#line 1614 "panel.vala"
		_tmp3_ = g_strcmp0 (_tmp8_, "") != 0;
#line 8773 "panel.c"
	} else {
#line 1613 "panel.vala"
		_tmp3_ = FALSE;
#line 8777 "panel.c"
	}
#line 1613 "panel.vala"
	if (_tmp3_) {
#line 8781 "panel.c"
		const gchar* _tmp9_;
#line 1615 "panel.vala"
		_tmp9_ = symbol;
#line 1615 "panel.vala"
		panel_animate_icon (self, _tmp9_, all_update);
#line 8787 "panel.c"
	}
#line 1610 "panel.vala"
	_g_free0 (symbol);
#line 8791 "panel.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 1618 "panel.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 1618 "panel.vala"
	return _data11_;
#line 8801 "panel.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 1618 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 8811 "panel.c"
		Panel* self;
#line 1618 "panel.vala"
		self = _data11_->self;
#line 1618 "panel.vala"
		_g_free0 (_data11_->symbol);
#line 1618 "panel.vala"
		_g_object_unref0 (self);
#line 1618 "panel.vala"
		g_slice_free (Block11Data, _data11_);
#line 8821 "panel.c"
	}
}

static gboolean
__lambda106_ (Block11Data* _data11_)
{
	Panel* self;
	gboolean result;
#line 1631 "panel.vala"
	self = _data11_->self;
#line 1632 "panel.vala"
	self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 1634 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 8836 "panel.c"
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 1635 "panel.vala"
		_tmp0_ = panel_create_icon_pixbuf_with_string (self, _data11_->symbol);
#line 1635 "panel.vala"
		pixbuf = _tmp0_;
#line 1636 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 1636 "panel.vala"
		_tmp2_ = pixbuf;
#line 1636 "panel.vala"
		gtk_status_icon_set_from_pixbuf (_tmp1_, _tmp2_);
#line 1634 "panel.vala"
		_g_object_unref0 (pixbuf);
#line 8853 "panel.c"
	} else {
#line 1639 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 8857 "panel.c"
			cairo_surface_t* image = NULL;
			cairo_surface_t* _tmp3_;
			Indicator* _tmp4_;
			cairo_surface_t* _tmp5_;
#line 1640 "panel.vala"
			_tmp3_ = panel_create_cairo_image_surface_with_string (self, _data11_->symbol, TRUE);
#line 1640 "panel.vala"
			image = _tmp3_;
#line 1642 "panel.vala"
			_tmp4_ = self->priv->m_indicator;
#line 1642 "panel.vala"
			_tmp5_ = image;
#line 1642 "panel.vala"
			indicator_set_cairo_image_surface_full (_tmp4_, _tmp5_, "");
#line 1639 "panel.vala"
			_cairo_surface_destroy0 (image);
#line 8874 "panel.c"
		}
	}
#line 1646 "panel.vala"
	result = FALSE;
#line 1646 "panel.vala"
	return result;
#line 8881 "panel.c"
}

static gboolean
___lambda106__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda106_ (self);
#line 1631 "panel.vala"
	return result;
#line 8891 "panel.c"
}

static void
panel_animate_icon (Panel* self,
                    const gchar* symbol,
                    gboolean all_update)
{
	Block11Data* _data11_;
	gchar* _tmp0_;
	guint timeout = 0U;
#line 1618 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1618 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1618 "panel.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 1618 "panel.vala"
	_data11_->_ref_count_ = 1;
#line 1618 "panel.vala"
	_data11_->self = g_object_ref (self);
#line 1618 "panel.vala"
	_tmp0_ = g_strdup (symbol);
#line 1618 "panel.vala"
	_g_free0 (_data11_->symbol);
#line 1618 "panel.vala"
	_data11_->symbol = _tmp0_;
#line 1619 "panel.vala"
	if (self->priv->m_property_icon_delay_time < 0) {
#line 1620 "panel.vala"
		block11_data_unref (_data11_);
#line 1620 "panel.vala"
		_data11_ = NULL;
#line 1620 "panel.vala"
		return;
#line 8926 "panel.c"
	}
#line 1622 "panel.vala"
	timeout = (guint) 0;
#line 1623 "panel.vala"
	if (all_update) {
#line 1624 "panel.vala"
		timeout = (guint) self->priv->m_property_icon_delay_time;
#line 8934 "panel.c"
	}
#line 1626 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1627 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1628 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 8942 "panel.c"
	}
#line 1631 "panel.vala"
	self->priv->m_property_icon_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, timeout, ___lambda106__gsource_func, block11_data_ref (_data11_), block11_data_unref);
#line 1618 "panel.vala"
	block11_data_unref (_data11_);
#line 1618 "panel.vala"
	_data11_ = NULL;
#line 8950 "panel.c"
}

static void
panel_real_set_cursor_location (IBusPanelService* base,
                                gint x,
                                gint y,
                                gint width,
                                gint height)
{
	Panel * self;
	CandidatePanel* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1651 "panel.vala"
	self = (Panel*) base;
#line 1653 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1653 "panel.vala"
	candidate_panel_set_cursor_location (_tmp0_, x, y, width, height);
#line 1654 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1654 "panel.vala"
	property_panel_set_cursor_location (_tmp1_, x, y, width, height);
#line 8973 "panel.c"
}

static gboolean
panel_switcher_focus_set_engine_real (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
	gboolean result;
#line 1657 "panel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1658 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1658 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1658 "panel.vala"
	selected_engine = _tmp1_;
#line 1659 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 1659 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1659 "panel.vala"
	prev_context_path = _tmp3_;
#line 1660 "panel.vala"
	_tmp6_ = selected_engine;
#line 1660 "panel.vala"
	if (_tmp6_ != NULL) {
#line 9007 "panel.c"
		const gchar* _tmp7_;
#line 1661 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1661 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 9013 "panel.c"
	} else {
#line 1660 "panel.vala"
		_tmp5_ = FALSE;
#line 9017 "panel.c"
	}
#line 1660 "panel.vala"
	if (_tmp5_) {
#line 9021 "panel.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 1662 "panel.vala"
		_tmp8_ = prev_context_path;
#line 1662 "panel.vala"
		_tmp9_ = self->priv->m_current_context_path;
#line 1662 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
#line 9030 "panel.c"
	} else {
#line 1660 "panel.vala"
		_tmp4_ = FALSE;
#line 9034 "panel.c"
	}
#line 1660 "panel.vala"
	if (_tmp4_) {
#line 9038 "panel.c"
		IBusEngineDesc* _tmp10_;
		Switcher* _tmp11_;
#line 1663 "panel.vala"
		_tmp10_ = selected_engine;
#line 1663 "panel.vala"
		panel_set_engine (self, _tmp10_);
#line 1664 "panel.vala"
		_tmp11_ = self->priv->m_switcher;
#line 1664 "panel.vala"
		switcher_reset (_tmp11_);
#line 1665 "panel.vala"
		result = TRUE;
#line 1665 "panel.vala"
		_g_free0 (prev_context_path);
#line 1665 "panel.vala"
		_g_object_unref0 (selected_engine);
#line 1665 "panel.vala"
		return result;
#line 9057 "panel.c"
	}
#line 1668 "panel.vala"
	result = FALSE;
#line 1668 "panel.vala"
	_g_free0 (prev_context_path);
#line 1668 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 1668 "panel.vala"
	return result;
#line 9067 "panel.c"
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 1677 "panel.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 9075 "panel.c"
}

static gboolean
___lambda69_ (Panel* self)
{
	gboolean result;
#line 1685 "panel.vala"
	panel_switcher_focus_set_engine_real (self);
#line 1686 "panel.vala"
	self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1687 "panel.vala"
	result = FALSE;
#line 1687 "panel.vala"
	return result;
#line 9090 "panel.c"
}

static gboolean
____lambda69__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda69_ ((Panel*) self);
#line 1683 "panel.vala"
	return result;
#line 9100 "panel.c"
}

static void
panel_switcher_focus_set_engine (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
#line 1671 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1672 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1672 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1672 "panel.vala"
	selected_engine = _tmp1_;
#line 1673 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 1673 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1673 "panel.vala"
	prev_context_path = _tmp3_;
#line 1674 "panel.vala"
	_tmp6_ = selected_engine;
#line 1674 "panel.vala"
	if (_tmp6_ == NULL) {
#line 9133 "panel.c"
		const gchar* _tmp7_;
#line 1675 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1675 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 9139 "panel.c"
	} else {
#line 1674 "panel.vala"
		_tmp5_ = FALSE;
#line 9143 "panel.c"
	}
#line 1674 "panel.vala"
	if (_tmp5_) {
#line 9147 "panel.c"
		Switcher* _tmp8_;
#line 1676 "panel.vala"
		_tmp8_ = self->priv->m_switcher;
#line 1676 "panel.vala"
		_tmp4_ = switcher_is_running (_tmp8_);
#line 9153 "panel.c"
	} else {
#line 1674 "panel.vala"
		_tmp4_ = FALSE;
#line 9157 "panel.c"
	}
#line 1674 "panel.vala"
	if (_tmp4_) {
#line 9161 "panel.c"
		GMainContext* context = NULL;
		GMainContext* _tmp9_;
		GMainContext* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 1677 "panel.vala"
		_tmp9_ = g_main_context_default ();
#line 1677 "panel.vala"
		_tmp10_ = _g_main_context_ref0 (_tmp9_);
#line 1677 "panel.vala"
		context = _tmp10_;
#line 1678 "panel.vala"
		if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 9174 "panel.c"
			GMainContext* _tmp12_;
			GSource* _tmp13_;
#line 1679 "panel.vala"
			_tmp12_ = context;
#line 1679 "panel.vala"
			_tmp13_ = g_main_context_find_source_by_id (_tmp12_, self->priv->m_switcher_focus_set_engine_id);
#line 1679 "panel.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 9183 "panel.c"
		} else {
#line 1678 "panel.vala"
			_tmp11_ = FALSE;
#line 9187 "panel.c"
		}
#line 1678 "panel.vala"
		if (_tmp11_) {
#line 1681 "panel.vala"
			g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 9193 "panel.c"
		}
#line 1683 "panel.vala"
		self->priv->m_switcher_focus_set_engine_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda69__gsource_func, g_object_ref (self), g_object_unref);
#line 1674 "panel.vala"
		_g_main_context_unref0 (context);
#line 9199 "panel.c"
	} else {
#line 1690 "panel.vala"
		if (panel_switcher_focus_set_engine_real (self)) {
#line 9203 "panel.c"
			GMainContext* context = NULL;
			GMainContext* _tmp14_;
			GMainContext* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 1691 "panel.vala"
			_tmp14_ = g_main_context_default ();
#line 1691 "panel.vala"
			_tmp15_ = _g_main_context_ref0 (_tmp14_);
#line 1691 "panel.vala"
			context = _tmp15_;
#line 1692 "panel.vala"
			if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 9216 "panel.c"
				GMainContext* _tmp17_;
				GSource* _tmp18_;
#line 1693 "panel.vala"
				_tmp17_ = context;
#line 1693 "panel.vala"
				_tmp18_ = g_main_context_find_source_by_id (_tmp17_, self->priv->m_switcher_focus_set_engine_id);
#line 1693 "panel.vala"
				_tmp16_ = _tmp18_ != NULL;
#line 9225 "panel.c"
			} else {
#line 1692 "panel.vala"
				_tmp16_ = FALSE;
#line 9229 "panel.c"
			}
#line 1692 "panel.vala"
			if (_tmp16_) {
#line 1695 "panel.vala"
				g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 9235 "panel.c"
			}
#line 1697 "panel.vala"
			self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1690 "panel.vala"
			_g_main_context_unref0 (context);
#line 9241 "panel.c"
		}
	}
#line 1671 "panel.vala"
	_g_free0 (prev_context_path);
#line 1671 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 9248 "panel.c"
}

static void
panel_real_focus_in (IBusPanelService* base,
                     const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
	IBusEngineDesc* engine = NULL;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	IBusEngineDesc* _tmp6_;
	IBusEngineDesc* _tmp7_;
	IBusEngineDesc* _tmp20_;
#line 1702 "panel.vala"
	self = (Panel*) base;
#line 1702 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1703 "panel.vala"
	_tmp0_ = g_strdup (input_context_path);
#line 1703 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1703 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 1712 "panel.vala"
	if (!g_str_has_suffix (input_context_path, "InputContext_1")) {
#line 9275 "panel.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1713 "panel.vala"
		_tmp1_ = self->priv->m_current_context_path;
#line 1713 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1713 "panel.vala"
		_g_free0 (self->priv->m_real_current_context_path);
#line 1713 "panel.vala"
		self->priv->m_real_current_context_path = _tmp2_;
#line 1714 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1714 "panel.vala"
		property_panel_focus_in (_tmp3_);
#line 1715 "panel.vala"
		panel_switcher_focus_set_engine (self);
#line 9293 "panel.c"
	}
#line 1718 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1719 "panel.vala"
		return;
#line 9299 "panel.c"
	}
#line 1721 "panel.vala"
	_tmp4_ = self->priv->m_engine_contexts;
#line 1721 "panel.vala"
	_tmp5_ = g_hash_table_lookup (_tmp4_, input_context_path);
#line 1721 "panel.vala"
	_tmp6_ = _g_object_ref0 ((IBusEngineDesc*) _tmp5_);
#line 1721 "panel.vala"
	engine = _tmp6_;
#line 1723 "panel.vala"
	_tmp7_ = engine;
#line 1723 "panel.vala"
	if (_tmp7_ == NULL) {
#line 9313 "panel.c"
		IBusEngineDesc* _tmp8_ = NULL;
		IBusEngineDesc** _tmp9_;
		gint _tmp9__length1;
		IBusEngineDesc* _tmp12_;
		IBusEngineDesc* _tmp13_;
#line 1735 "panel.vala"
		_tmp9_ = self->priv->m_engines;
#line 1735 "panel.vala"
		_tmp9__length1 = self->priv->m_engines_length1;
#line 1735 "panel.vala"
		if (_tmp9__length1 > 0) {
#line 9325 "panel.c"
			IBusEngineDesc** _tmp10_;
			gint _tmp10__length1;
			IBusEngineDesc* _tmp11_;
#line 1735 "panel.vala"
			_tmp10_ = self->priv->m_engines;
#line 1735 "panel.vala"
			_tmp10__length1 = self->priv->m_engines_length1;
#line 1735 "panel.vala"
			_tmp11_ = _tmp10_[0];
#line 1735 "panel.vala"
			_tmp8_ = _tmp11_;
#line 9337 "panel.c"
		} else {
#line 1735 "panel.vala"
			_tmp8_ = NULL;
#line 9341 "panel.c"
		}
#line 1735 "panel.vala"
		_tmp12_ = _g_object_ref0 (_tmp8_);
#line 1735 "panel.vala"
		_g_object_unref0 (engine);
#line 1735 "panel.vala"
		engine = _tmp12_;
#line 1737 "panel.vala"
		_tmp13_ = engine;
#line 1737 "panel.vala"
		if (_tmp13_ == NULL) {
#line 1738 "panel.vala"
			_g_object_unref0 (engine);
#line 1738 "panel.vala"
			return;
#line 9357 "panel.c"
		}
	} else {
		gboolean in_engines = FALSE;
		IBusEngineDesc** _tmp14_;
		gint _tmp14__length1;
#line 1740 "panel.vala"
		in_engines = FALSE;
#line 1742 "panel.vala"
		_tmp14_ = self->priv->m_engines;
#line 1742 "panel.vala"
		_tmp14__length1 = self->priv->m_engines_length1;
#line 9369 "panel.c"
		{
			IBusEngineDesc** e_collection = NULL;
			gint e_collection_length1 = 0;
			gint _e_collection_size_ = 0;
			gint e_it = 0;
#line 1742 "panel.vala"
			e_collection = _tmp14_;
#line 1742 "panel.vala"
			e_collection_length1 = _tmp14__length1;
#line 1742 "panel.vala"
			for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 9381 "panel.c"
				IBusEngineDesc* _tmp15_;
				IBusEngineDesc* e = NULL;
#line 1742 "panel.vala"
				_tmp15_ = _g_object_ref0 (e_collection[e_it]);
#line 1742 "panel.vala"
				e = _tmp15_;
#line 9388 "panel.c"
				{
					IBusEngineDesc* _tmp16_;
					const gchar* _tmp17_;
					IBusEngineDesc* _tmp18_;
					const gchar* _tmp19_;
#line 1743 "panel.vala"
					_tmp16_ = engine;
#line 1743 "panel.vala"
					_tmp17_ = ibus_engine_desc_get_name (_tmp16_);
#line 1743 "panel.vala"
					_tmp18_ = e;
#line 1743 "panel.vala"
					_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 1743 "panel.vala"
					if (g_strcmp0 (_tmp17_, _tmp19_) == 0) {
#line 1744 "panel.vala"
						in_engines = TRUE;
#line 1745 "panel.vala"
						_g_object_unref0 (e);
#line 1745 "panel.vala"
						break;
#line 9410 "panel.c"
					}
#line 1742 "panel.vala"
					_g_object_unref0 (e);
#line 9414 "panel.c"
				}
			}
		}
#line 1751 "panel.vala"
		if (!in_engines) {
#line 1752 "panel.vala"
			_g_object_unref0 (engine);
#line 1752 "panel.vala"
			return;
#line 9424 "panel.c"
		}
	}
#line 1755 "panel.vala"
	_tmp20_ = engine;
#line 1755 "panel.vala"
	panel_set_engine (self, _tmp20_);
#line 1702 "panel.vala"
	_g_object_unref0 (engine);
#line 9433 "panel.c"
}

static void
panel_real_focus_out (IBusPanelService* base,
                      const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
#line 1758 "panel.vala"
	self = (Panel*) base;
#line 1758 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1759 "panel.vala"
	_tmp0_ = g_strdup ("");
#line 1759 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1759 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 9452 "panel.c"
}

static void
panel_real_destroy_context (IBusPanelService* base,
                            const gchar* input_context_path)
{
	Panel * self;
	GHashTable* _tmp0_;
#line 1762 "panel.vala"
	self = (Panel*) base;
#line 1762 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1763 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1764 "panel.vala"
		return;
#line 9469 "panel.c"
	}
#line 1766 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1766 "panel.vala"
	g_hash_table_remove (_tmp0_, input_context_path);
#line 9475 "panel.c"
}

static gboolean
__lambda107_ (Panel* self)
{
	Indicator* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	gboolean result;
#line 1787 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 1787 "panel.vala"
	_tmp1_ = panel_create_activate_menu (self, FALSE);
#line 1787 "panel.vala"
	_tmp2_ = _tmp1_;
#line 1787 "panel.vala"
	indicator_set_menu (_tmp0_, _tmp2_);
#line 1787 "panel.vala"
	_g_object_unref0 (_tmp2_);
#line 1788 "panel.vala"
	result = FALSE;
#line 1788 "panel.vala"
	return result;
#line 9499 "panel.c"
}

static gboolean
___lambda107__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda107_ ((Panel*) self);
#line 1783 "panel.vala"
	return result;
#line 9509 "panel.c"
}

static void
panel_real_register_properties (IBusPanelService* base,
                                IBusPropList* props)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1769 "panel.vala"
	self = (Panel*) base;
#line 1769 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1770 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1770 "panel.vala"
	property_manager_set_properties (_tmp0_, props);
#line 1771 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1771 "panel.vala"
	property_panel_set_properties (_tmp1_, props);
#line 1772 "panel.vala"
	panel_set_properties (self, props);
#line 1775 "panel.vala"
	if (self->priv->m_icon_type != PANEL_ICON_TYPE_INDICATOR) {
#line 1776 "panel.vala"
		return;
#line 9537 "panel.c"
	}
#line 1777 "panel.vala"
	if (self->priv->m_is_context_menu) {
#line 1778 "panel.vala"
		return;
#line 9543 "panel.c"
	}
#line 1779 "panel.vala"
	if (self->priv->m_menu_update_delay_time_id > ((guint) 0)) {
#line 1780 "panel.vala"
		g_source_remove (self->priv->m_menu_update_delay_time_id);
#line 1781 "panel.vala"
		self->priv->m_menu_update_delay_time_id = (guint) 0;
#line 9551 "panel.c"
	}
#line 1783 "panel.vala"
	self->priv->m_menu_update_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, self->priv->m_menu_update_delay_time, ___lambda107__gsource_func, g_object_ref (self), g_object_unref);
#line 9555 "panel.c"
}

static void
panel_real_update_property (IBusPanelService* base,
                            IBusProperty* prop)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1793 "panel.vala"
	self = (Panel*) base;
#line 1793 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1794 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1794 "panel.vala"
	property_manager_update_property (_tmp0_, prop);
#line 1795 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1795 "panel.vala"
	property_panel_update_property (_tmp1_, prop);
#line 1796 "panel.vala"
	panel_set_property (self, prop, FALSE);
#line 9579 "panel.c"
}

static void
panel_real_update_preedit_text (IBusPanelService* base,
                                IBusText* text,
                                guint cursor_pos,
                                gboolean visible)
{
	Panel * self;
#line 1799 "panel.vala"
	self = (Panel*) base;
#line 1799 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1802 "panel.vala"
	if (visible) {
#line 9595 "panel.c"
		CandidatePanel* _tmp0_;
		PropertyPanel* _tmp1_;
#line 1803 "panel.vala"
		_tmp0_ = self->priv->m_candidate_panel;
#line 1803 "panel.vala"
		candidate_panel_set_preedit_text (_tmp0_, text, cursor_pos);
#line 1804 "panel.vala"
		_tmp1_ = self->priv->m_property_panel;
#line 1804 "panel.vala"
		property_panel_set_preedit_text (_tmp1_, text, cursor_pos);
#line 9606 "panel.c"
	} else {
		CandidatePanel* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1806 "panel.vala"
		_tmp2_ = self->priv->m_candidate_panel;
#line 1806 "panel.vala"
		candidate_panel_set_preedit_text (_tmp2_, NULL, (guint) 0);
#line 1807 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1807 "panel.vala"
		property_panel_set_preedit_text (_tmp3_, NULL, (guint) 0);
#line 9618 "panel.c"
	}
}

static void
panel_real_hide_preedit_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1811 "panel.vala"
	self = (Panel*) base;
#line 1812 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1812 "panel.vala"
	candidate_panel_set_preedit_text (_tmp0_, NULL, (guint) 0);
#line 9633 "panel.c"
}

static void
panel_real_update_auxiliary_text (IBusPanelService* base,
                                  IBusText* text,
                                  gboolean visible)
{
	Panel * self;
	IBusText* _tmp0_ = NULL;
	CandidatePanel* _tmp1_;
	IBusText* _tmp2_ = NULL;
	PropertyPanel* _tmp3_;
#line 1815 "panel.vala"
	self = (Panel*) base;
#line 1815 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1817 "panel.vala"
	if (visible) {
#line 1817 "panel.vala"
		_tmp0_ = text;
#line 9654 "panel.c"
	} else {
#line 1817 "panel.vala"
		_tmp0_ = NULL;
#line 9658 "panel.c"
	}
#line 1817 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 1817 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp1_, _tmp0_);
#line 1818 "panel.vala"
	if (visible) {
#line 1818 "panel.vala"
		_tmp2_ = text;
#line 9668 "panel.c"
	} else {
#line 1818 "panel.vala"
		_tmp2_ = NULL;
#line 9672 "panel.c"
	}
#line 1818 "panel.vala"
	_tmp3_ = self->priv->m_property_panel;
#line 1818 "panel.vala"
	property_panel_set_auxiliary_text (_tmp3_, _tmp2_);
#line 9678 "panel.c"
}

static void
panel_real_hide_auxiliary_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1821 "panel.vala"
	self = (Panel*) base;
#line 1822 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1822 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp0_, NULL);
#line 9692 "panel.c"
}

static void
panel_real_update_lookup_table (IBusPanelService* base,
                                IBusLookupTable* table,
                                gboolean visible)
{
	Panel * self;
	IBusLookupTable* _tmp0_ = NULL;
	CandidatePanel* _tmp1_;
	IBusLookupTable* _tmp2_ = NULL;
	PropertyPanel* _tmp3_;
#line 1825 "panel.vala"
	self = (Panel*) base;
#line 1825 "panel.vala"
	g_return_if_fail (table != NULL);
#line 1827 "panel.vala"
	if (visible) {
#line 1827 "panel.vala"
		_tmp0_ = table;
#line 9713 "panel.c"
	} else {
#line 1827 "panel.vala"
		_tmp0_ = NULL;
#line 9717 "panel.c"
	}
#line 1827 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 1827 "panel.vala"
	candidate_panel_set_lookup_table (_tmp1_, _tmp0_);
#line 1828 "panel.vala"
	if (visible) {
#line 1828 "panel.vala"
		_tmp2_ = table;
#line 9727 "panel.c"
	} else {
#line 1828 "panel.vala"
		_tmp2_ = NULL;
#line 9731 "panel.c"
	}
#line 1828 "panel.vala"
	_tmp3_ = self->priv->m_property_panel;
#line 1828 "panel.vala"
	property_panel_set_lookup_table (_tmp3_, _tmp2_);
#line 9737 "panel.c"
}

static void
panel_real_hide_lookup_table (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1831 "panel.vala"
	self = (Panel*) base;
#line 1832 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1832 "panel.vala"
	candidate_panel_set_lookup_table (_tmp0_, NULL);
#line 9751 "panel.c"
}

static void
panel_real_set_content_type (IBusPanelService* base,
                             guint purpose,
                             guint hints)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1835 "panel.vala"
	self = (Panel*) base;
#line 1836 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1836 "panel.vala"
	candidate_panel_set_content_type (_tmp0_, purpose, hints);
#line 9767 "panel.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 9784 "panel.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 9811 "panel.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 9817 "panel.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 9823 "panel.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 9827 "panel.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 9835 "panel.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 9839 "panel.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 9851 "panel.c"
}

static void
_vala_array_add28 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1936 "panel.vala"
	if ((*length) == (*size)) {
#line 1936 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1936 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9866 "panel.c"
	}
#line 1936 "panel.vala"
	(*array)[(*length)++] = value;
#line 1936 "panel.vala"
	(*array)[*length] = NULL;
#line 9872 "panel.c"
}

static void
panel_real_state_changed (IBusPanelService* base)
{
	Panel * self;
	Switcher* _tmp0_;
	gchar* icon_name = NULL;
	gchar* _tmp2_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp3_;
	IBusEngineDesc* _tmp4_;
	IBusEngineDesc* _tmp5_;
	const gchar* _tmp13_;
	IBusEngineDesc* _tmp54_;
	gint i = 0;
	IBusEngineDesc** _tmp63_;
	gint _tmp63__length1;
	IBusEngineDesc** _tmp70_;
	gint _tmp70__length1;
	IBusEngineDesc* _tmp71_;
	IBusEngineDesc* _tmp72_;
	gchar** names = NULL;
	gchar** _tmp73_;
	gint names_length1;
	gint _names_size_;
	IBusEngineDesc** _tmp74_;
	gint _tmp74__length1;
	GSettings* _tmp79_;
	gchar** _tmp80_;
	gint _tmp80__length1;
#line 1839 "panel.vala"
	self = (Panel*) base;
#line 1841 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1841 "panel.vala"
	if (switcher_is_running (_tmp0_)) {
#line 1842 "panel.vala"
		return;
#line 9912 "panel.c"
	}
#line 1845 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9916 "panel.c"
		Indicator* _tmp1_;
#line 1847 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 1847 "panel.vala"
		if (_tmp1_ == NULL) {
#line 1848 "panel.vala"
			return;
#line 9924 "panel.c"
		}
	}
#line 1852 "panel.vala"
	_tmp2_ = g_strdup ("ibus-keyboard");
#line 1852 "panel.vala"
	icon_name = _tmp2_;
#line 1854 "panel.vala"
	_tmp3_ = self->priv->m_bus;
#line 1854 "panel.vala"
	_tmp4_ = ibus_bus_get_global_engine (_tmp3_);
#line 1854 "panel.vala"
	engine = _tmp4_;
#line 1855 "panel.vala"
	_tmp5_ = engine;
#line 1855 "panel.vala"
	if (_tmp5_ != NULL) {
#line 9941 "panel.c"
		IBusEngineDesc* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		IBusEngineDesc* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1856 "panel.vala"
		_tmp6_ = engine;
#line 1856 "panel.vala"
		_tmp7_ = ibus_engine_desc_get_icon (_tmp6_);
#line 1856 "panel.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 1856 "panel.vala"
		_g_free0 (icon_name);
#line 1856 "panel.vala"
		icon_name = _tmp8_;
#line 1857 "panel.vala"
		_tmp9_ = engine;
#line 1857 "panel.vala"
		_tmp10_ = ibus_engine_desc_get_icon_prop_key (_tmp9_);
#line 1857 "panel.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1857 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1857 "panel.vala"
		self->priv->m_icon_prop_key = _tmp11_;
#line 9968 "panel.c"
	} else {
		gchar* _tmp12_;
#line 1859 "panel.vala"
		_tmp12_ = g_strdup ("");
#line 1859 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1859 "panel.vala"
		self->priv->m_icon_prop_key = _tmp12_;
#line 9977 "panel.c"
	}
#line 1862 "panel.vala"
	_tmp13_ = icon_name;
#line 1862 "panel.vala"
	if (string_get (_tmp13_, (glong) 0) == '/') {
#line 1863 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9985 "panel.c"
			GtkStatusIcon* _tmp14_;
			const gchar* _tmp15_;
#line 1864 "panel.vala"
			_tmp14_ = self->priv->m_status_icon;
#line 1864 "panel.vala"
			_tmp15_ = icon_name;
#line 1864 "panel.vala"
			gtk_status_icon_set_from_file (_tmp14_, _tmp15_);
#line 9994 "panel.c"
		} else {
#line 1866 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9998 "panel.c"
				Indicator* _tmp16_;
				const gchar* _tmp17_;
#line 1867 "panel.vala"
				_tmp16_ = self->priv->m_indicator;
#line 1867 "panel.vala"
				_tmp17_ = icon_name;
#line 1867 "panel.vala"
				indicator_set_icon_full (_tmp16_, _tmp17_, "");
#line 10007 "panel.c"
			}
		}
	} else {
		gchar* language = NULL;
		IBusEngineDesc* _tmp18_;
		const gchar* _tmp32_;
#line 1870 "panel.vala"
		language = NULL;
#line 1872 "panel.vala"
		_tmp18_ = engine;
#line 1872 "panel.vala"
		if (_tmp18_ != NULL) {
#line 10020 "panel.c"
			gchar* name = NULL;
			IBusEngineDesc* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gboolean _tmp22_ = FALSE;
			const gchar* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
#line 1873 "panel.vala"
			_tmp19_ = engine;
#line 1873 "panel.vala"
			_tmp20_ = ibus_engine_desc_get_name (_tmp19_);
#line 1873 "panel.vala"
			_tmp21_ = g_strdup (_tmp20_);
#line 1873 "panel.vala"
			name = _tmp21_;
#line 1874 "panel.vala"
			_tmp23_ = name;
#line 1874 "panel.vala"
			_tmp24_ = strlen (_tmp23_);
#line 1874 "panel.vala"
			_tmp25_ = _tmp24_;
#line 1874 "panel.vala"
			if (_tmp25_ >= 4) {
#line 10045 "panel.c"
				const gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 1874 "panel.vala"
				_tmp26_ = name;
#line 1874 "panel.vala"
				_tmp27_ = string_slice (_tmp26_, (glong) 0, (glong) 4);
#line 1874 "panel.vala"
				_tmp28_ = _tmp27_;
#line 1874 "panel.vala"
				_tmp22_ = g_strcmp0 (_tmp28_, "xkb:") == 0;
#line 1874 "panel.vala"
				_g_free0 (_tmp28_);
#line 10059 "panel.c"
			} else {
#line 1874 "panel.vala"
				_tmp22_ = FALSE;
#line 10063 "panel.c"
			}
#line 1874 "panel.vala"
			if (_tmp22_) {
#line 10067 "panel.c"
				Switcher* _tmp29_;
				IBusEngineDesc* _tmp30_;
				gchar* _tmp31_;
#line 1875 "panel.vala"
				_tmp29_ = self->priv->m_switcher;
#line 1875 "panel.vala"
				_tmp30_ = engine;
#line 1875 "panel.vala"
				_tmp31_ = switcher_get_xkb_language (_tmp29_, _tmp30_);
#line 1875 "panel.vala"
				_g_free0 (language);
#line 1875 "panel.vala"
				language = _tmp31_;
#line 10081 "panel.c"
			}
#line 1872 "panel.vala"
			_g_free0 (name);
#line 10085 "panel.c"
		}
#line 1878 "panel.vala"
		_tmp32_ = language;
#line 1878 "panel.vala"
		if (_tmp32_ != NULL) {
#line 1879 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10093 "panel.c"
				GdkPixbuf* pixbuf = NULL;
				const gchar* _tmp33_;
				GdkPixbuf* _tmp34_;
				GtkStatusIcon* _tmp35_;
				GdkPixbuf* _tmp36_;
#line 1880 "panel.vala"
				_tmp33_ = language;
#line 1880 "panel.vala"
				_tmp34_ = panel_create_icon_pixbuf_with_string (self, _tmp33_);
#line 1880 "panel.vala"
				pixbuf = _tmp34_;
#line 1882 "panel.vala"
				_tmp35_ = self->priv->m_status_icon;
#line 1882 "panel.vala"
				_tmp36_ = pixbuf;
#line 1882 "panel.vala"
				gtk_status_icon_set_from_pixbuf (_tmp35_, _tmp36_);
#line 1879 "panel.vala"
				_g_object_unref0 (pixbuf);
#line 10113 "panel.c"
			} else {
#line 1885 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10117 "panel.c"
					cairo_surface_t* image = NULL;
					const gchar* _tmp37_;
					cairo_surface_t* _tmp38_;
					Indicator* _tmp39_;
					cairo_surface_t* _tmp40_;
#line 1886 "panel.vala"
					_tmp37_ = language;
#line 1886 "panel.vala"
					_tmp38_ = panel_create_cairo_image_surface_with_string (self, _tmp37_, TRUE);
#line 1886 "panel.vala"
					image = _tmp38_;
#line 1889 "panel.vala"
					_tmp39_ = self->priv->m_indicator;
#line 1889 "panel.vala"
					_tmp40_ = image;
#line 1889 "panel.vala"
					indicator_set_cairo_image_surface_full (_tmp39_, _tmp40_, "");
#line 1885 "panel.vala"
					_cairo_surface_destroy0 (image);
#line 10137 "panel.c"
				}
			}
		} else {
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp41_;
			GtkIconTheme* _tmp42_;
			GtkIconTheme* _tmp43_;
			const gchar* _tmp44_;
			GtkIconInfo* _tmp45_;
			GtkIconInfo* _tmp46_;
			gboolean _tmp47_;
#line 1893 "panel.vala"
			_tmp41_ = gtk_icon_theme_get_default ();
#line 1893 "panel.vala"
			_tmp42_ = _g_object_ref0 (_tmp41_);
#line 1893 "panel.vala"
			theme = _tmp42_;
#line 1894 "panel.vala"
			_tmp43_ = theme;
#line 1894 "panel.vala"
			_tmp44_ = icon_name;
#line 1894 "panel.vala"
			_tmp45_ = gtk_icon_theme_lookup_icon (_tmp43_, _tmp44_, 48, 0);
#line 1894 "panel.vala"
			_tmp46_ = _tmp45_;
#line 1894 "panel.vala"
			_tmp47_ = _tmp46_ != NULL;
#line 1894 "panel.vala"
			_g_object_unref0 (_tmp46_);
#line 1894 "panel.vala"
			if (_tmp47_) {
#line 1895 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10171 "panel.c"
					GtkStatusIcon* _tmp48_;
					const gchar* _tmp49_;
#line 1896 "panel.vala"
					_tmp48_ = self->priv->m_status_icon;
#line 1896 "panel.vala"
					_tmp49_ = icon_name;
#line 1896 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp48_, _tmp49_);
#line 10180 "panel.c"
				} else {
#line 1898 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10184 "panel.c"
						Indicator* _tmp50_;
						const gchar* _tmp51_;
#line 1899 "panel.vala"
						_tmp50_ = self->priv->m_indicator;
#line 1899 "panel.vala"
						_tmp51_ = icon_name;
#line 1899 "panel.vala"
						indicator_set_icon_full (_tmp50_, _tmp51_, "");
#line 10193 "panel.c"
					}
				}
			} else {
#line 1902 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10199 "panel.c"
					GtkStatusIcon* _tmp52_;
#line 1903 "panel.vala"
					_tmp52_ = self->priv->m_status_icon;
#line 1903 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp52_, "ibus-engine");
#line 10205 "panel.c"
				} else {
#line 1905 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10209 "panel.c"
						Indicator* _tmp53_;
#line 1906 "panel.vala"
						_tmp53_ = self->priv->m_indicator;
#line 1906 "panel.vala"
						indicator_set_icon_full (_tmp53_, "ibus-engine", "");
#line 10215 "panel.c"
					}
				}
			}
#line 1878 "panel.vala"
			_g_object_unref0 (theme);
#line 10221 "panel.c"
		}
#line 1862 "panel.vala"
		_g_free0 (language);
#line 10225 "panel.c"
	}
#line 1912 "panel.vala"
	_tmp54_ = engine;
#line 1912 "panel.vala"
	if (_tmp54_ == NULL) {
#line 1913 "panel.vala"
		_g_object_unref0 (engine);
#line 1913 "panel.vala"
		_g_free0 (icon_name);
#line 1913 "panel.vala"
		return;
#line 10237 "panel.c"
	}
	{
		gboolean _tmp55_ = FALSE;
#line 1916 "panel.vala"
		i = 0;
#line 1916 "panel.vala"
		_tmp55_ = TRUE;
#line 1916 "panel.vala"
		while (TRUE) {
#line 10247 "panel.c"
			IBusEngineDesc** _tmp57_;
			gint _tmp57__length1;
			IBusEngineDesc** _tmp58_;
			gint _tmp58__length1;
			IBusEngineDesc* _tmp59_;
			const gchar* _tmp60_;
			IBusEngineDesc* _tmp61_;
			const gchar* _tmp62_;
#line 1916 "panel.vala"
			if (!_tmp55_) {
#line 10258 "panel.c"
				gint _tmp56_;
#line 1916 "panel.vala"
				_tmp56_ = i;
#line 1916 "panel.vala"
				i = _tmp56_ + 1;
#line 10264 "panel.c"
			}
#line 1916 "panel.vala"
			_tmp55_ = FALSE;
#line 1916 "panel.vala"
			_tmp57_ = self->priv->m_engines;
#line 1916 "panel.vala"
			_tmp57__length1 = self->priv->m_engines_length1;
#line 1916 "panel.vala"
			if (!(i < _tmp57__length1)) {
#line 1916 "panel.vala"
				break;
#line 10276 "panel.c"
			}
#line 1917 "panel.vala"
			_tmp58_ = self->priv->m_engines;
#line 1917 "panel.vala"
			_tmp58__length1 = self->priv->m_engines_length1;
#line 1917 "panel.vala"
			_tmp59_ = _tmp58_[i];
#line 1917 "panel.vala"
			_tmp60_ = ibus_engine_desc_get_name (_tmp59_);
#line 1917 "panel.vala"
			_tmp61_ = engine;
#line 1917 "panel.vala"
			_tmp62_ = ibus_engine_desc_get_name (_tmp61_);
#line 1917 "panel.vala"
			if (g_strcmp0 (_tmp60_, _tmp62_) == 0) {
#line 1918 "panel.vala"
				break;
#line 10294 "panel.c"
			}
		}
	}
#line 1922 "panel.vala"
	if (i == 0) {
#line 1923 "panel.vala"
		_g_object_unref0 (engine);
#line 1923 "panel.vala"
		_g_free0 (icon_name);
#line 1923 "panel.vala"
		return;
#line 10306 "panel.c"
	}
#line 1926 "panel.vala"
	_tmp63_ = self->priv->m_engines;
#line 1926 "panel.vala"
	_tmp63__length1 = self->priv->m_engines_length1;
#line 1926 "panel.vala"
	if (i >= _tmp63__length1) {
#line 1927 "panel.vala"
		_g_object_unref0 (engine);
#line 1927 "panel.vala"
		_g_free0 (icon_name);
#line 1927 "panel.vala"
		return;
#line 10320 "panel.c"
	}
	{
		gint j = 0;
#line 1929 "panel.vala"
		j = i;
#line 10326 "panel.c"
		{
			gboolean _tmp64_ = FALSE;
#line 1929 "panel.vala"
			_tmp64_ = TRUE;
#line 1929 "panel.vala"
			while (TRUE) {
#line 10333 "panel.c"
				IBusEngineDesc** _tmp66_;
				gint _tmp66__length1;
				IBusEngineDesc** _tmp67_;
				gint _tmp67__length1;
				IBusEngineDesc* _tmp68_;
				IBusEngineDesc* _tmp69_;
#line 1929 "panel.vala"
				if (!_tmp64_) {
#line 10342 "panel.c"
					gint _tmp65_;
#line 1929 "panel.vala"
					_tmp65_ = j;
#line 1929 "panel.vala"
					j = _tmp65_ - 1;
#line 10348 "panel.c"
				}
#line 1929 "panel.vala"
				_tmp64_ = FALSE;
#line 1929 "panel.vala"
				if (!(j > 0)) {
#line 1929 "panel.vala"
					break;
#line 10356 "panel.c"
				}
#line 1930 "panel.vala"
				_tmp66_ = self->priv->m_engines;
#line 1930 "panel.vala"
				_tmp66__length1 = self->priv->m_engines_length1;
#line 1930 "panel.vala"
				_tmp67_ = self->priv->m_engines;
#line 1930 "panel.vala"
				_tmp67__length1 = self->priv->m_engines_length1;
#line 1930 "panel.vala"
				_tmp68_ = _tmp67_[j - 1];
#line 1930 "panel.vala"
				_tmp69_ = _g_object_ref0 (_tmp68_);
#line 1930 "panel.vala"
				_g_object_unref0 (_tmp66_[j]);
#line 1930 "panel.vala"
				_tmp66_[j] = _tmp69_;
#line 10374 "panel.c"
			}
		}
	}
#line 1932 "panel.vala"
	_tmp70_ = self->priv->m_engines;
#line 1932 "panel.vala"
	_tmp70__length1 = self->priv->m_engines_length1;
#line 1932 "panel.vala"
	_tmp71_ = engine;
#line 1932 "panel.vala"
	_tmp72_ = _g_object_ref0 (_tmp71_);
#line 1932 "panel.vala"
	_g_object_unref0 (_tmp70_[0]);
#line 1932 "panel.vala"
	_tmp70_[0] = _tmp72_;
#line 1934 "panel.vala"
	_tmp73_ = g_new0 (gchar*, 0 + 1);
#line 1934 "panel.vala"
	names = _tmp73_;
#line 1934 "panel.vala"
	names_length1 = 0;
#line 1934 "panel.vala"
	_names_size_ = names_length1;
#line 1935 "panel.vala"
	_tmp74_ = self->priv->m_engines;
#line 1935 "panel.vala"
	_tmp74__length1 = self->priv->m_engines_length1;
#line 10402 "panel.c"
	{
		IBusEngineDesc** desc_collection = NULL;
		gint desc_collection_length1 = 0;
		gint _desc_collection_size_ = 0;
		gint desc_it = 0;
#line 1935 "panel.vala"
		desc_collection = _tmp74_;
#line 1935 "panel.vala"
		desc_collection_length1 = _tmp74__length1;
#line 1935 "panel.vala"
		for (desc_it = 0; desc_it < desc_collection_length1; desc_it = desc_it + 1) {
#line 10414 "panel.c"
			IBusEngineDesc* _tmp75_;
			IBusEngineDesc* desc = NULL;
#line 1935 "panel.vala"
			_tmp75_ = _g_object_ref0 (desc_collection[desc_it]);
#line 1935 "panel.vala"
			desc = _tmp75_;
#line 10421 "panel.c"
			{
				IBusEngineDesc* _tmp76_;
				const gchar* _tmp77_;
				gchar* _tmp78_;
#line 1936 "panel.vala"
				_tmp76_ = desc;
#line 1936 "panel.vala"
				_tmp77_ = ibus_engine_desc_get_name (_tmp76_);
#line 1936 "panel.vala"
				_tmp78_ = g_strdup (_tmp77_);
#line 1936 "panel.vala"
				_vala_array_add28 (&names, &names_length1, &_names_size_, _tmp78_);
#line 1935 "panel.vala"
				_g_object_unref0 (desc);
#line 10436 "panel.c"
			}
		}
	}
#line 1938 "panel.vala"
	_tmp79_ = self->priv->m_settings_general;
#line 1938 "panel.vala"
	_tmp80_ = names;
#line 1938 "panel.vala"
	_tmp80__length1 = names_length1;
#line 1938 "panel.vala"
	g_settings_set_strv (_tmp79_, "engines-order", _tmp80_);
#line 1839 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1839 "panel.vala"
	_g_object_unref0 (engine);
#line 1839 "panel.vala"
	_g_free0 (icon_name);
#line 10454 "panel.c"
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "panel.vala"
	g_return_if_fail (n_param_values == 4);
#line 24 "panel.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "panel.vala"
		data1 = closure->data;
#line 24 "panel.vala"
		data2 = param_values->data[0].v_pointer;
#line 10479 "panel.c"
	} else {
#line 24 "panel.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "panel.vala"
		data2 = closure->data;
#line 10485 "panel.c"
	}
#line 24 "panel.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 24 "panel.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 10491 "panel.c"
}

static void
panel_class_init (PanelClass * klass,
                  gpointer klass_data)
{
#line 24 "panel.vala"
	panel_parent_class = g_type_class_peek_parent (klass);
#line 24 "panel.vala"
	g_type_class_adjust_private_offset (klass, &Panel_private_offset);
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_cursor_location = (void (*) (IBusPanelService*, gint, gint, gint, gint)) panel_real_set_cursor_location;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_in = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_in;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_out = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_out;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->destroy_context = (void (*) (IBusPanelService*, const gchar*)) panel_real_destroy_context;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->register_properties = (void (*) (IBusPanelService*, IBusPropList*)) panel_real_register_properties;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_property = (void (*) (IBusPanelService*, IBusProperty*)) panel_real_update_property;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_preedit_text = (void (*) (IBusPanelService*, IBusText*, guint, gboolean)) panel_real_update_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_preedit_text = (void (*) (IBusPanelService*)) panel_real_hide_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_auxiliary_text = (void (*) (IBusPanelService*, IBusText*, gboolean)) panel_real_update_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_auxiliary_text = (void (*) (IBusPanelService*)) panel_real_hide_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_lookup_table = (void (*) (IBusPanelService*, IBusLookupTable*, gboolean)) panel_real_update_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_lookup_table = (void (*) (IBusPanelService*)) panel_real_hide_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_content_type = (void (*) (IBusPanelService*, guint, guint)) panel_real_set_content_type;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->state_changed = (void (*) (IBusPanelService*)) panel_real_state_changed;
#line 24 "panel.vala"
	G_OBJECT_CLASS (klass)->finalize = panel_finalize;
#line 24 "panel.vala"
	panel_signals[PANEL_REALIZE_SURFACE_SIGNAL] = g_signal_new ("realize-surface", TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 24 "panel.vala"
	panel_signals[PANEL_UPDATE_SHORTCUT_KEYS_SIGNAL] = g_signal_new ("update-shortcut-keys", TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT_ENUM, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_INT, BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE);
#line 10536 "panel.c"
}

static void
panel_instance_init (Panel * self,
                     gpointer klass)
{
	IBusEngineDesc** _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	XKBLayout* _tmp13_;
	gchar* _tmp14_;
#line 24 "panel.vala"
	self->priv = panel_get_instance_private (self);
#line 32 "panel.vala"
	self->priv->m_settings_general = NULL;
#line 33 "panel.vala"
	self->priv->m_settings_hotkey = NULL;
#line 34 "panel.vala"
	self->priv->m_settings_panel = NULL;
#line 35 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_STATUS_ICON;
#line 38 "panel.vala"
	self->priv->m_indicator_show_status = INDICATOR_STATUS_ACTIVE;
#line 43 "panel.vala"
	_tmp0_ = g_new0 (IBusEngineDesc*, 0 + 1);
#line 43 "panel.vala"
	self->priv->m_engines = _tmp0_;
#line 43 "panel.vala"
	self->priv->m_engines_length1 = 0;
#line 43 "panel.vala"
	self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 44 "panel.vala"
	_tmp1_ = g_str_hash;
#line 44 "panel.vala"
	_tmp2_ = g_str_equal;
#line 44 "panel.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
#line 44 "panel.vala"
	self->priv->m_engine_contexts = _tmp3_;
#line 47 "panel.vala"
	_tmp4_ = g_strdup ("");
#line 47 "panel.vala"
	self->priv->m_current_context_path = _tmp4_;
#line 48 "panel.vala"
	_tmp5_ = g_strdup ("");
#line 48 "panel.vala"
	self->priv->m_real_current_context_path = _tmp5_;
#line 49 "panel.vala"
	self->priv->m_use_global_engine = TRUE;
#line 50 "panel.vala"
	self->priv->m_use_engine_lang = TRUE;
#line 54 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 58 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 61 "panel.vala"
	self->priv->m_switcher_delay_time = 400;
#line 62 "panel.vala"
	self->priv->m_use_system_keyboard_layout = FALSE;
#line 63 "panel.vala"
	_tmp6_ = g_str_hash;
#line 63 "panel.vala"
	_tmp7_ = g_str_equal;
#line 63 "panel.vala"
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, _g_free0_, _g_object_unref0_);
#line 63 "panel.vala"
	self->priv->m_xkb_icon_pixbufs = _tmp8_;
#line 66 "panel.vala"
	_tmp9_ = g_str_hash;
#line 66 "panel.vala"
	_tmp10_ = g_str_equal;
#line 66 "panel.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, _g_free0_, _cairo_surface_destroy0_);
#line 66 "panel.vala"
	self->priv->m_xkb_icon_image = _tmp11_;
#line 69 "panel.vala"
	memset (&_tmp12_, 0, sizeof (GdkRGBA));
#line 69 "panel.vala"
	_tmp12_.red = 0.0;
#line 69 "panel.vala"
	_tmp12_.green = 0.0;
#line 69 "panel.vala"
	_tmp12_.blue = 0.0;
#line 69 "panel.vala"
	_tmp12_.alpha = 1.0;
#line 69 "panel.vala"
	self->priv->m_xkb_icon_rgba = _tmp12_;
#line 71 "panel.vala"
	_tmp13_ = xkb_layout_new ();
#line 71 "panel.vala"
	self->priv->m_xkblayout = _tmp13_;
#line 72 "panel.vala"
	self->priv->inited_engines_order = TRUE;
#line 75 "panel.vala"
	_tmp14_ = g_strdup ("");
#line 75 "panel.vala"
	self->priv->m_icon_prop_key = _tmp14_;
#line 76 "panel.vala"
	self->priv->m_property_icon_delay_time = 500;
#line 78 "panel.vala"
	self->priv->m_menu_update_delay_time = (guint) 100;
#line 83 "panel.vala"
	self->priv->m_is_kde = panel_is_kde ();
#line 94 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 10652 "panel.c"
}

static void
panel_finalize (GObject * obj)
{
	Panel * self;
	Indicator* _tmp0_;
	GList* _tmp2_;
#line 24 "panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PANEL, Panel);
#line 178 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 178 "panel.vala"
	if (_tmp0_ != NULL) {
#line 10667 "panel.c"
		Indicator* _tmp1_;
#line 179 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 179 "panel.vala"
		indicator_unregister_connection (_tmp1_);
#line 10673 "panel.c"
	}
#line 181 "panel.vala"
	_tmp2_ = self->priv->m_keybindings;
#line 181 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp2_);
#line 183 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 183 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 31 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 32 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 33 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 34 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 37 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 40 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 41 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 42 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 43 "panel.vala"
	self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 44 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_engine_contexts);
#line 47 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 48 "panel.vala"
	_g_free0 (self->priv->m_real_current_context_path);
#line 51 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 52 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 55 "panel.vala"
	_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 56 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 57 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 59 "panel.vala"
	_g_object_unref0 (self->priv->m_about_dialog);
#line 60 "panel.vala"
	_g_object_unref0 (self->priv->m_css_provider);
#line 63 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_pixbufs);
#line 66 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_image);
#line 71 "panel.vala"
	_xkb_layout_unref0 (self->priv->m_xkblayout);
#line 75 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 94 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 24 "panel.vala"
	G_OBJECT_CLASS (panel_parent_class)->finalize (obj);
#line 10733 "panel.c"
}

static GType
panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Panel), 0, (GInstanceInitFunc) panel_instance_init, NULL };
	GType panel_type_id;
	panel_type_id = g_type_register_static (ibus_panel_service_get_type (), "Panel", &g_define_type_info, 0);
	Panel_private_offset = g_type_add_instance_private (panel_type_id, sizeof (PanelPrivate));
	return panel_type_id;
}

GType
panel_get_type (void)
{
	static volatile gsize panel_type_id__once = 0;
	if (g_once_init_enter (&panel_type_id__once)) {
		GType panel_type_id;
		panel_type_id = panel_get_type_once ();
		g_once_init_leave (&panel_type_id__once, panel_type_id);
	}
	return panel_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 10765 "panel.c"
		gssize i;
#line 23 "emojier.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "emojier.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "emojier.vala"
				destroy_func (((gpointer*) array)[i]);
#line 10773 "panel.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "emojier.vala"
	g_free (array);
#line 10788 "panel.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 23 "emojier.vala"
	if (array) {
#line 23 "emojier.vala"
		while (((gpointer*) array)[length]) {
#line 23 "emojier.vala"
			length++;
#line 10802 "panel.c"
		}
	}
#line 23 "emojier.vala"
	return length;
#line 10807 "panel.c"
}

